<id>
URL Autolinking Fix
</id>

<version>
1.1
</version>

<mod info>
This hack fixes the automatic link detection for http, ftp, gopher and news. It is based on Wartortle's 'No Url Tags' mod.
Use <auto_link_disable.mod> if you don't want to fix but to disable this feature.
</mod info>

<author>
[CV]XXL
</author>

<homepage>
http://xxl.cstrike.de
</homepage>

<edit file>
Sources\Display.pl
</edit file>

<search for>
        $message =~ s/\ http:\/\/(\S+?)\ / <a href=\"http:\/\/$1\"\ target=\"_blank\">http\:\/\/$1<\/a> /isg;
        $message =~ s/<br>http:\/\/(\S+?)\ /<br><a href=\"http:\/\/$1\"\ target=\"_blank\">http\:\/\/$1<\/a>/isg;
        $message =~ s/^http:\/\/(\S+?)\ /<a href=\"http:\/\/$1\"\ target=\"_blank\">http\:\/\/$1<\/a>/isg;

        $message =~ s/\ https:\/\/(\S+?)\ / <a href=\"https:\/\/$1\"\ target=\"_blank\">https\:\/\/$1<\/a> /isg;
        $message =~ s/<br>https:\/\/(\S+?)\ /<br><a href=\"https:\/\/$1\"\ target=\"_blank\">https\:\/\/$1<\/a>/isg;
        $message =~ s/^https:\/\/(\S+?)\ /<a href=\"https:\/\/$1\"\ target=\"_blank\">https\:\/\/$1<\/a>/isg;

        $message =~ s/\ ftp:\/\/(\S+?)\ / <a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a> /isg;
        $message =~ s/<br>ftp:\/\/(\S+?)\ /<br><a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a>/isg;
        $message =~ s/^ftp:\/\/(\S+?)\ /<a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a>/isg;

        $message =~ s/\ gopher:\/\/(\S+?)\ / <a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a> /isg;
        $message =~ s/<br>gopher:\/\/(\S+?)\ /<br><a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a>/isg;
        $message =~ s/^gopher:\/\/(\S+?)\ /<a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a>/isg;

        $message =~ s/\ news:\/\/(\S+?)\ / <a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a> /isg;
        $message =~ s/<br>news:\/\/(\S+?)\ /<br><a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a>/isg;
        $message =~ s/^news:\/\/(\S+?)\ /<a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a>/isg;
</search for>

<replace>
        $message =~ s/(\s)http:\/\/(\S+?)<p>/$1<a href=\"http:\/\/$2\"\ target=\"_blank\">http\:\/\/$2<\/a>/isg;
        $message =~ s/(\s)http:\/\/(\S+?)<br>/$1<a href=\"http:\/\/$2\"\ target=\"_blank\">http\:\/\/$2<\/a>/isg;
        $message =~ s/<br>http:\/\/(\S+?)<br>/<br><a href=\"http:\/\/$1\"\ target=\"_blank\">http\:\/\/$1<\/a>/isg;
        $message =~ s/<br>http:\/\/(\S+?)<p>/<br><a href=\"http:\/\/$1\"\ target=\"_blank\">http\:\/\/$1<\/a>/isg;
        $message =~ s/<br>http:\/\/(\S+?)\ /<br><a href=\"http:\/\/$1\"\ target=\"_blank\">http\:\/\/$1<\/a> /isg;

        $message =~ s/(\s)https:\/\/(\S+?)<p>/$1<a href=\"https:\/\/$2\"\ target=\"_blank\">https\:\/\/$2<\/a>/isg;
        $message =~ s/(\s)https:\/\/(\S+?)<br>/$1<a href=\"https:\/\/$2\"\ target=\"_blank\">https\:\/\/$2<\/a>/isg;
        $message =~ s/<br>https:\/\/(\S+?)<br>/<br><a href=\"https:\/\/$1\"\ target=\"_blank\">https\:\/\/$1<\/a>/isg;
        $message =~ s/<br>https:\/\/(\S+?)<p>/<br><a href=\"https:\/\/$1\"\ target=\"_blank\">https\:\/\/$1<\/a>/isg;
        $message =~ s/<br>https:\/\/(\S+?)\ /<br><a href=\"https:\/\/$1\"\ target=\"_blank\">https\:\/\/$1<\/a> /isg;

        $message =~ s/(\s)ftp:\/\/(\S+?)<p>/$1<a href=\"ftp:\/\/$2\"\ target=\"_blank\">ftp\:\/\/$2<\/a>/isg;
        $message =~ s/(\s)ftp:\/\/(\S+?)<br>/$1<a href=\"ftp:\/\/$2\"\ target=\"_blank\">ftp\:\/\/$2<\/a>/isg;
        $message =~ s/<br>ftp:\/\/(\S+?)<br>/<br><a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a>/isg;
        $message =~ s/<br>ftp:\/\/(\S+?)<p>/<br><a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a>/isg;
        $message =~ s/<br>ftp:\/\/(\S+?)\ /<br><a href=\"ftp:\/\/$1\"\ target=\"_blank\">ftp\:\/\/$1<\/a> /isg;

        $message =~ s/(\s)gopher:\/\/(\S+?)<p>/$1<a href=\"gopher:\/\/$2\"\ target=\"_blank\">gopher\:\/\/$2<\/a>/isg;
        $message =~ s/(\s)gopher:\/\/(\S+?)<br>/$1<a href=\"gopher:\/\/$2\"\ target=\"_blank\">gopher\:\/\/$2<\/a>/isg;
        $message =~ s/<br>gopher:\/\/(\S+?)<br>/<br><a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a>/isg;
        $message =~ s/<br>gopher:\/\/(\S+?)<p>/<br><a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a>/isg;
        $message =~ s/<br>gopher:\/\/(\S+?)\ /<br><a href=\"gopher:\/\/$1\"\ target=\"_blank\">gopher\:\/\/$1<\/a> /isg;

        $message =~ s/(\s)news:\/\/(\S+?)<p>/$1<a href=\"news:\/\/$2\"\ target=\"_blank\">news\:\/\/$2<\/a>/isg;
        $message =~ s/(\s)news:\/\/(\S+?)<br>/$1<a href=\"news:\/\/$2\"\ target=\"_blank\">news\:\/\/$2<\/a>/isg;
        $message =~ s/<br>news:\/\/(\S+?)<br>/<br><a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a>/isg;
        $message =~ s/<br>news:\/\/(\S+?)<p>/<br><a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a>/isg;
        $message =~ s/<br>news:\/\/(\S+?)\ /<br><a href=\"news:\/\/$1\"\ target=\"_blank\">news\:\/\/$1<\/a> /isg;
</replace>