###############################################################################
# Recent.pl                                                                   #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Project started by Zef Hemel (zef@zefnet.com)                   #
# Software Version: YaBB 1 Final                                              #
# =========================================================================== #
# Software Distributed by:    www.yabb.org                                    #
# Support, News, Updates at:  www.yabb.org/cgi-bin/support/YaBB.pl            #
# =========================================================================== #
# Copyright (c) 2000-2001 YaBB - All Rights Reserved                          #
# Software by: The YaBB Development Team                                      #
###############################################################################
# rewritten by [CV]XXL (email: X_X_L@gmx.net)                                 #
###############################################################################
$recentplver="1 Final (rewritten)";

sub LastPost {

	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);

	%data= ();

	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		foreach(split(/\,/,$catinfo[1])) {			
			$membergroups{$_} = $_;
		}		
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && !exists $membergroups{$settings[7]}) {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				$curboard =~ s/[\n\r]//g;
				open(BOARDDATA, "$boardsdir/$curboard.txt");
				&lock(BOARDDATA);
				@messages = <BOARDDATA>;
				&unlock(BOARDDATA);
				close(BOARDDATA);
				
				$board = "$curboard";
				
				($num, $title, $dummy, $dummy, $datetime, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $messages[0]);
				
			#### output ####
					#$post = "$txt{'234'} \"<a href=\"$cgi$board&action=display&num=$title[0]\">$title</a>\" $txt{'235'} ($month/$day - $hour\:$min $ampm)<br></font></td>\n";
					$post = "$txt{'234'} \"<a href=\"$cgi$board&action=display&num=$num\">$title</a>\" $txt{'235'} ($datetime)<br></font></td>\n";

					($date, $time) = split(/ at /, $datetime);
					($month, $day, $year) = split(/\//, $date);
					($hour, $min, $sec) = split (/:/, $time);
					$totaltime = (($year+2000)*365+$month*30+$day)*24*60*60+$hour*60*60+$min*60;
					$data{$totaltime}= $post;
			}
		}
	}

	@num = sort {$b <=> $a } keys %data;
	$j=0;
	while ($j<1){
	print "$data{$num[$j]}";
	$j++;
	}	
}

sub RecentPosts {
	$title = "Recent Posts";
	&header;
	$display = 10;

	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);

	%data= ();

	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		foreach(split(/\,/,$catinfo[1])) {			
			$membergroups{$_} = $_;
		}		
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && !exists $membergroups{$settings[7]}) {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				$curboard =~ s/[\n\r]//g;
				open(BOARDDATA, "$boardsdir/$curboard.txt");
				&lock(BOARDDATA);
				@messages = <BOARDDATA>;
				&unlock(BOARDDATA);
				close(BOARDDATA);

				open(BOARDDATA, "$boardsdir/$curboard.dat");
				&lock(BOARDDATA);
				@boardinfo = <BOARDDATA>;
				&unlock(BOARDDATA);
				close(BOARDDATA);
				
				
			for ($a = 0; $a < @messages && $a <= $display; $a++) {
				($title[0], $title[1], $title[2], $title[3], $title[4], $title[5], $title[6], $title[7], $title[8]) = split(/\|/, $messages[$a]);
				
			#### output ####
				open (TEXT, "$datadir/$title[0].txt");
				$text = <TEXT>;
				chomp($text);
				@text = split(/\|/, $text);
				$message = $text[8];

				require "$sourcedir/Display.pl";
				if($enable_ubbc) {
					&DoUBBC;
				}

				$board = "$curboard";

				$post=<<"EOT";
<li><div align=left>
[ $catinfo[0] / $boardinfo[0] ] <a href="$cgi$board&action=display&num=$title[0]">$title[1]</a><br><br>
<font face="Verdana, Arial" size=1>Started by <b>$title[2]</b><br>
Last post on $title[4]<br>
<br><font color="#999999">- - - - - - -</font><br>
<br>$message<br>
<br><font color="#999999">- - - - - - -</font><br>
<br><a href="$cgi$board&action=post&num=$title[0]&title=Post+reply&start=0">Reply</a> |
<a href="$cgi$board&action=post&num=$title[0]&quote=0&title=Post+reply&start=0">Reply With Quote</a> |
<a href="$cgi$board&action=notify&thread=$title[0]">Notify</a><br>
<img src="/images/spacer.gif" width=1 height=9 border=0><br>
<hr width="50%"></font><br></div></li>
EOT

				($date, $time) = split(/ at /, $title[4]);
				($month, $day, $year) = split(/\//, $date);
				($hour, $min, $sec) = split (/:/, $time);
				$totaltime = (($year+2000)*365+$month*30+$day)*24*60*60+$hour*60*60+$min*60;
				$data{$totaltime}= $post;
			}
			}
		}
	}

print "<font face=\"Verdana, Arial\" size=2>\n<ol>\n";

	@num = sort {$b <=> $a } keys %data;
	$j=0;
	while ($j<$display){
	print "$data{$num[$j]}";
	$j++;
	}

print "</ol>\n</font>\n\n<font face=\"Verdana, Arial\" size=1><a href=\"$cgi\">$txt{'236'}</a>\n$txt{'237'}<br></font>";

	&footer;
	exit;
}

1;
