<id>
Poll Mod
</id>

<version>
3.0
</version>

<mod info>
This mod adds poll capability to your YaBB 1 Gold SP1 Board.
The polls themselves are similar to that of vB and YaBB SE.


To Install:
-----------
	- Install the mod file as usual and upload the modified files.
	  (See the BoardMod FAQ if you do not know how to do this).
	- Install the "New Indicator Bugfix" mod if you haven't already.
	- If you want to "Showcase" a poll by displaying it in the Board Index, install the Showcase addon.
	- If you have installed MBCO2, and want to restrict who can create polls, and on which boards, install the MBCO2 Polls patch.
	- Place Poll.pl in your Sources directory, and chmod it the same as the rest of the files there.
	- Place the images into your YaBBImages directory (there are some additional alternatives included)
	- Go to the Forum Preferences and Settings, and set the values for the new Poll options.


Version History:
----------------

Version 1.2 by Sam Holman (Samm)

Version 2.0 by Shoeb Omar (Omario)
	- Voter Details panel added
	- Speed increase
	- Options (which are new features) added within admin center:
		~ Number of Poll Options
		~ Allow users to add polls to their own threads?
		~ Allow users to edit their own polls?
		~ Allow users to delete their own polls? 
		~ Enable Guest Voting?
	- Entire Mod Rewritten for more mod compatibility
	- Lock/Unlock feature added
	- Looks better
	- Partial Smiley Support added (Not all work due to the nature of being able to vote properly)

Version 3.0 by BHRA Webmaster (BHRA Webmaster)
	- New Features
		~ New Vote indicator (This will only work properly if you have applied the "New Indicator Bugfix" mod)
		~ Ability for users to change vote
		~ Admin ability to remove votes
		~ Full Smiley/UBBC support
		~ Anyone can add polls to existing threads - not just the topic starter!
		~ Reduced/simplified post page for adding/modifying polls
	- More information stored
		~ Time each vote was made
		~ Poll Author and last Modified details
		~ Poll "Comments" now possible  
	- Options added within admin center:
		~ Maximum allowed characters on question/options/comment
		~ Allow Smilies/UBBC tags within Polls
		~ Allow users to add polls to existing threads
	- Options added to each Poll:
		~ Allow Guest voting (moved from Admin Center)
		~ Hide results until Poll is closed/locked
		~ Allow multiple selection
	- And lots more!


Acknowledgements:
-----------------
Thanks go to Dummy Proof for preliminary beta testing, and for writing the "Showcase Poll" addon.
And of course to Shoeb Omar (Omario) and Sam Holman (Samm) for writing the previous versions of this mod.

</mod info>

<author>
BHRA Webmaster, Shoeb Omar (Omario), Sam Holman (Samm)
</author>

<homepage>
http://www.bhra.org.uk, http://www.clickopedia.com
</homepage>

###############################################################################

<edit file>
Sources/MessageIndex.pl
</edit file>

###   The following step will probably cause the most problems   ###
###          The only change is to add $mpoll after $new         ###
###  This is a purely cosmetic change and can safely be ignored  ###

<search for>
        <td class="windowbg" valign="middle" width="48%" bgcolor="$color{'windowbg'}"><font size=2>$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
</search for>

<replace>
        <td class="windowbg" valign="middle" width="48%" bgcolor="$color{'windowbg'}"><font size=2>$new $mpoll<a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
</replace>

<search for>
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>&nbsp;
	    </font></td>
</search for>

<replace>
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>$menusep<a href="$cgi;action=post;title=$polltxt{'1a'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
</replace>

<search for>
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>&nbsp;
	    </font></td>
</search for>

<replace>
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>$menusep<a href="$cgi;action=post;title=$polltxt{'1a'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
</replace>

<search for>
		# Load the current nickname of the account name of the thread starter.
</search for>

<add after>
		$micon = qq~<img src="$imagesdir/$micon.gif" alt="" border="0" align="absmiddle">~;
		$mpoll = "";
		if (-e "$datadir/$mnum.poll") {
			$mpoll = qq~<b>$polltxt{'15'}: </b>~;
			fopen (FILE, "$datadir/$mnum.poll");
			$poll_question = <FILE>; 
			fclose (FILE);
			chomp $poll_question;
			($dummy, $poll_locked, $dummy) = split(/\|/, $poll_question, 3);
			$micon = qq~$img{'pollicon'}~;
			if ($poll_locked) { $micon = $img{'polliconclosed'}; }
			else {
				fopen(FILE, "$datadir/$mnum.polled");
				$polled = <FILE>;
				fclose(FILE);
				$dlp = &getlog($mnum);
				($dummy, $dummy, $dummy, $vote_date, $dummy) = split(/\|/, $polled);
				$vote_date = stringtotime($vote_date);
				if( $max_log_days_old && $dlp < $vote_date && $username ne 'Guest' && &getlog("$currentboard--mark") < $vote_date ) {$micon = qq~$img{'polliconnew'}~;}
			}
		}

</add after>

<search for>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$micon.gif" alt="" border="0" align=middle></td>
</search for>

<replace>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}">$micon</td>
</replace>

###############################################################################

<edit file>
Sources/Display.pl
</edit file>

<search for>
	# Get the class of this thread, based on lock status and number of replies.
	$replybutton = qq~<a href="$cgi;action=post;num=$viewnum;title=$txt{'116'};start=$start">$img{'reply'}</a>~;
	$threadclass = 'thread';
	if( $mstate == 1 ) {
		$threadclass = 'locked';
		$replybutton = "";
	}
</search for>

<replace>
	# Look for a poll file for this thread.
	if (-e "$datadir/$viewnum.poll") { $has_poll = 1; } else { $has_poll = 0; }

	# Get the class of this thread, based on lock status and number of replies.
	$replybutton = qq~<a href="$cgi;action=post;num=$viewnum;title=$txt{'116'}">$img{'reply'}</a>~;
	$pollbutton = qq~$menusep<a href="$cgi;action=post;num=$viewnum;title=$polltxt{'2a'}">$img{'addpoll'}</a>~;
	$threadclass = 'thread';
	if( $mstate == 1 ) {
		$threadclass = 'locked';
		$replybutton = "";
		$pollbutton = "";
	}
	if ($has_poll || $useraddpoll == 0) { $pollbutton = ""; }
</replace>

<search for>
            $replybutton$notify$menusep
</search for>

<replace>
            $replybutton$pollbutton$notify$menusep
</replace>

<search for>
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
</search for>

<add before>
~;
	if ($has_poll) { require "$sourcedir/Poll.pl"; &display_poll($viewnum); }
	$yymain .= qq~
</add before>

<search for>
            $replybutton$notify$menusep
</search for>

<replace>
            $replybutton$pollbutton$notify$menusep
</replace>

###############################################################################

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.txt");
	unlink("$datadir/$thread.mail");
	unlink("$datadir/$thread.data");
</search for>

<add after>
	unlink("$datadir/$thread.poll");
	unlink("$datadir/$thread.polled");
</add after>

###############################################################################

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					unlink("$datadir/$num.txt");
					unlink("$datadir/$num.mail");
					unlink("$datadir/$num.data");
</search for>

<add after>
					unlink("$datadir/$num.poll");
					unlink("$datadir/$num.polled");
</add after>

###############################################################################

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	if( $mstate == 1 ) {
		&fatal_error($txt{'90'});
	}
</search for>

<add after>

	if ($INFO{'message'} eq $polltxt{'15'}) {
		unless (-e "$datadir/$threadid.poll") {&fatal_error("$polltxt{'13'}");}

		fopen (FILE, "$datadir/$threadid.poll");
		@poll_data = <FILE>;
		fclose (FILE);
		chomp $poll_data[0];
		($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_choice, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_data[0]);
		for(my $i = 0; $i < @poll_data; $i++) {
			chomp $poll_data[$i];
			($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		}

		unless($poll_uname eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { &fatal_error("$polltxt{'13'}"); }

		$poll_comment =~ s~<br>~\n~g;
		$pollthread = 2;
		$settofield = "question";

	} else {
</add after>

<search for>
	$submittxt = "$txt{'10'}";
</search for>

<add before>
		$settofield = "message";
	}
</add before>

<search for>
	$settofield = "message";
	&Postpage;
</search for>

<replace>
	&Postpage;
</replace>

<search for>
	if($deletepost) {
		$threadid = $INFO{'thread'};
		$postid = $INFO{'id'};
	}
	else {
		$threadid = $FORM{'threadid'};
		$postid = $FORM{'postid'};
	}
</search for>

<replace>
	if($deletepost) {
		$threadid = $INFO{'thread'};
		$postid = $INFO{'id'};
		if ($postid eq $polltxt{'15'} ) {$pollthread = 1;}
	}
	else {
		$threadid = $FORM{'threadid'};
		$postid = $FORM{'postid'};
		$pollthread = $FORM{'pollthread'};
	}

	if ($pollthread) {
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		unless (-e "$datadir/$threadid.poll") {&fatal_error("$polltxt{'13'}");}

		fopen (FILE, "$datadir/$threadid.poll");
		@poll_data = <FILE>;
		fclose (FILE);
		chomp $poll_data[0];
		($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_choice, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_data[0]);

		unless($poll_uname eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { &fatal_error("$polltxt{'13'}"); }

		if ( $deletepost ) { # Delete Poll

			unlink("$datadir/$threadid.poll");
			unlink("$datadir/$threadid.polled");

		} else { # Modify Poll

			$numcount = 0;
			unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
			if ( length($FORM{"question"} ) > $maxpq) { &fatal_error("$polltxt{'40'} $polltxt{'34a'} $maxpq $polltxt{'34b'} $polltxt{'36'}"); }
			$poll_question = $FORM{"question"};
			&ToHTML($poll_question);
			$guest_vote = $FORM{'guest_vote'} || 0;
			$hide_results = $FORM{'hide_results'} || 0;
			$multi_choice = $FORM{'multi_choice'} || 0;
			$poll_comment = $FORM{'poll_comment'} || "";
			if ( length($poll_comment ) > $maxpc) { &fatal_error("$polltxt{'57'} $polltxt{'34a'} $maxpc $polltxt{'34b'} $polltxt{'36'}"); }
			&ToHTML($poll_comment);
			$poll_comment =~ s~\n~<br>~g;
			$poll_comment =~ s~\r~~g;
			my @new_poll_data;
			push @new_poll_data, qq~$poll_question|$poll_locked|$poll_uname|$poll_name|$poll_email|$poll_date|$guest_vote|$hide_results|$multi_choice|$date|$username|$poll_comment\n~;

			for ($i = 1; $i <= $numpolloptions; $i++){
				chomp $poll_data[$i];
				($votes, $dummy) = split(/\|/, $poll_data[$i]);
				if (!$votes) {$votes = "0";}
				if ($FORM{"option$i"}) {
					if (length($FORM{"option$i"}) > $maxpo) { &fatal_error("$polltxt{'7'} $i  $polltxt{'34a'} $maxpo $polltxt{'34b'} $polltxt{'36'}"); }
					&ToHTML($FORM{"option$i"});
					$numcount++;
					push @new_poll_data, qq~$votes|$FORM{"option$i"}\n~;
				}
			}
			if ($numcount < 2) { &fatal_error("$polltxt{'38'}"); }

			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL @new_poll_data;
			fclose (POLL);
		}

		$yySetLocation = qq~$cgi;action=display;num=$threadid~;
		&redirectexit;
	}
</replace>

<search for>
			unlink("$datadir/$tnum.txt");
			unlink("$datadir/$tnum.mail");
			unlink("$datadir/$tnum.data");
</search for>

<add after>
			unlink("$datadir/$tnum.poll");
			unlink("$datadir/$tnum.polled");
</add after>

###############################################################################

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
			unlink("$datadir/$id\.txt");
			unlink("$datadir/$id\.mail");
			unlink("$datadir/$id\.data");
</search for>

<add after>
			unlink("$datadir/$id\.poll");
			unlink("$datadir/$id\.polled");
</add after>

###############################################################################

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
					unlink("$datadir/$id.txt");
					unlink("$datadir/$id.mail");
					unlink("$datadir/$id.data");
</search for>

<add after>
					unlink("$datadir/$id.poll");
					unlink("$datadir/$id.polled");
</add after>

###############################################################################

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
### Poll Mod 3.0 ###
	$polltxt{'1'} = "Create Poll";
	$polltxt{'1a'} = "Create+Poll";	# There should be a + instead of spaces
	$polltxt{'2'} = "Add Poll";
	$polltxt{'2a'} = "Add+Poll";	# There should be a + instead of spaces
	$polltxt{'4'} = "Poll Question";
	$polltxt{'5'} = "shortcuts (IE and NS6 only): hit alt+s to send or alt+r to reset";
	$polltxt{'6'} = "Question";
	$polltxt{'7'} = "Option";
	$polltxt{'8'} = "Guests are not allowed to vote. Please register.";
	$polltxt{'9'} = "An error has occurred and this action could not be completed. Sorry for the inconvenience.";
	$polltxt{'10'} = "This poll is locked so your vote could not be removed";
	$polltxt{'11'} = "This poll is locked so your vote could not be counted";
	$polltxt{'12'} = "Please select an option to vote for before voting!";
	$polltxt{'13'} = "You are not allowed to perform that action";
	$polltxt{'14'} = "The poll could not be found";
	$polltxt{'15'} = "Poll";
	$polltxt{'16'} = "Question";
	$polltxt{'17'} = "Total votes";
	$polltxt{'18'} = "Submit Vote";
	$polltxt{'19'} = "View Results";
	$polltxt{'20'} = "Open";
	$polltxt{'21'} = "Close";
	$polltxt{'22'} = "*** This poll has now closed ***";
	$polltxt{'23'} = "Details for Poll:";
	$polltxt{'24'} = "Votes";
	$polltxt{'25'} = "Nobody voted for this option.";
	$polltxt{'26'} = "Hide results:";
	$polltxt{'27'} = "Remove";
	$polltxt{'28'} = "Number of Poll Options:";
	$polltxt{'29'} = "Allow users to add polls to existing threads:";
	$polltxt{'30'} = "IP Address";
	$polltxt{'31'} = "Date Voted";
	$polltxt{'32'} = "Enable Guest Voting:";
	$polltxt{'33'} = "View Votes";
	$polltxt{'34a'} = "was longer than the maximum";
	$polltxt{'34b'} = "characters.";
	$polltxt{'35'} = "There was an illegal character in option";
	$polltxt{'36'} = "Please try again.";
	$polltxt{'37'} = "Please supply a poll question.";
	$polltxt{'38'} = "Please provide at least 2 poll options.";
	$polltxt{'39'} = "Modify";
	$polltxt{'40'} = "The poll question";
	$polltxt{'41'} = "There was an illegal character in your poll question. Please try again.";
	$polltxt{'42'} = "Poll Details";
	$polltxt{'43'} = "Remove Vote";
	$polltxt{'44'} = "Are you sure you want to delete this poll?";
	$polltxt{'45'} = "Created by";
	$polltxt{'45a'} = "Last Modified by";
	$polltxt{'46'} = "on";
	$polltxt{'47'} = "Thank you for voting in this poll.";
	$polltxt{'48'} = "The results however will remain hidden until all the votes have been counted.";
	$polltxt{'49'} = "Remove Votes";
	$polltxt{'50'} = "You have already voted in this poll";
	$polltxt{'51'} = "A guest has already used this IP address to register their vote";
	$polltxt{'52'} = "A member has already used this IP address to register their vote";
	$polltxt{'53'} = "*** No-one else can see these results until the poll is closed ***";
	$polltxt{'54'} = "Check this if you want guests to be able to vote in this poll.";
	$polltxt{'55'} = "Check this if you do not want the results of this poll shown until voting has been closed.";
	$polltxt{'56'} = "Check this if you want to allow users to vote for more than one option.";
	$polltxt{'57'} = "The poll comment";
	$polltxt{'58'} = "Multiple Choice";
	$polltxt{'59'} = "Poll Comment";
	$polltxt{'60'} = "Allow UBBC tags and Smilies in Polls:";
	$polltxt{'61'} = "Maximum number of Characters in a Poll Question:";
	$polltxt{'62'} = "Maximum number of Characters in a Poll Option:";
	$polltxt{'63'} = "Maximum number of Characters in a Poll Comment (Set to 0 to disable):";

	$img{'pollicon'} = qq~<img src="$imagesdir/poll_open.gif" alt="" border="0">~;
	$img{'polliconnew'} = qq~<img src="$imagesdir/poll_new.gif" alt="" border="0">~;
	$img{'polliconclosed'} = qq~<img src="$imagesdir/poll_lock.gif" alt="" border="0">~;
	if($MenuType == 1) {
		$img{'createpoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'1'}</font>~;
		$img{'addpoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'2'}</font>~;
		$img{'modifypoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'39'}</font>~;
		$img{'deletepoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'27'}</font>~;
		$img{'openpoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'20'}</font>~;
		$img{'closepoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'21'}</font>~;
		$img{'viewvotes'} = qq~<font size="1" class="imgcatbg">$polltxt{'33'}</font>~;
		$img{'deletevote'} = qq~<font size="1" class="imgcatbg">$polltxt{'43'}</font>~;
	} else {
		$img{'createpoll'} = qq~<img src="$imagesdir/poll_create.gif" alt="$polltxt{'1'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'1'}</font>~;
		$img{'addpoll'} = qq~<img src="$imagesdir/poll_create.gif" alt="$polltxt{'2'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'2'}</font>~;
		$img{'modifypoll'} = qq~<img src="$imagesdir/poll_mod.gif" alt="$polltxt{'39'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'39'}</font>~;
		$img{'deletepoll'} = qq~<img src="$imagesdir/poll_del.gif" alt="$polltxt{'27'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'27'}</font>~;
		$img{'openpoll'} = qq~<img src="$imagesdir/poll_lock.gif" alt="$polltxt{'20'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'20'}</font>~;
		$img{'closepoll'} = qq~<img src="$imagesdir/poll_lock.gif" alt="$polltxt{'21'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'21'}</font>~;
		$img{'viewvotes'} = qq~<img src="$imagesdir/poll_vvote.gif" alt="$polltxt{'33'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'33'}</font>~;
		$img{'deletevote'} = qq~<img src="$imagesdir/poll_dvote.gif" alt="$polltxt{'43'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'43'}</font>~;
	}
### Poll Mod 3.0 ###

</add before>

###############################################################################

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'lock') { require "$sourcedir/LockThread.pl"; &LockThread; }
</search for>

<add after>
	elsif ($action eq 'lockpoll') { require "$sourcedir/Poll.pl"; &LockPoll; }
</add after>

<search for>
	elsif ($action eq 'sticky') { require "$sourcedir/Subs.pl"; &Sticky; }
</search for>

<add after>
	elsif ($action eq 'showvoters') { require "$sourcedir/Poll.pl"; &votedetails; }
</add after>

<search for>
	elsif ($action eq 'usersrecentposts') { require "$sourcedir/Profile.pl"; &usersrecentposts; }
</search for>

<add after>
	elsif ($action eq 'vote') { require "$sourcedir/Poll.pl"; &DoVote; }
	elsif ($action eq 'undovote') { require "$sourcedir/Poll.pl"; &UndoVote; }
</add after>

###############################################################################

<edit file>
Sources/Post.pl
</edit file>

<search for>
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);
</search for>

<add after>

	$pollthread = 0;
	$polltxt{'1a'} =~ tr/+/ /;
	$polltxt{'2a'} =~ tr/+/ /;
	if ($INFO{'title'} eq $polltxt{'1a'}) { $pollthread = 1; }
	elsif ($INFO{'title'} eq $polltxt{'2a'}) { $pollthread = 2; }
	if ($pollthread == 2 && $useraddpoll == 0) { &fatal_error($txt{'1'}); }
</add after>

<search for>
	if(!$sub) { $subtitle = "<i>$txt{'33'}</i>"; }
</search for>

<add before>
	if ($pollthread && $username eq "Guest") {$guest_vote = 1;}
	if ($pollthread == 2) {
		$settofield="question";
		$sub = "$msubject";
	} else {
		if (!$enable_notification || $username eq 'Guest') {$notification = ""} else { $notification = qq~<tr>
                <td><font size="2"><b>$txt{'131'}:</b></font></td>
                <td><input type="checkbox" name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
              </tr>~;}
	}
</add before>

<search for>
	&doshowthread;
</search for>

<replace>
	if ($pollthread != 2) { &doshowthread; }
</replace>

<search for>
    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
</search for>

<replace>
    </td>
  </tr>~;
	if ($pollthread != 2 || ($pollthread == 2 && $username eq 'Guest')) { $yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">~;
		if ($pollthread == 2 ) {$extra = "";} else { $yymain .= qq~
</replace>

<search for>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><input type=text name="subject" value="$sub" size="40" maxlength="50" onMouseOver="this.focus()" tabindex="1"></font></td>
      </tr>
</search for>

<add after>
~;
		}
		$yymain .= qq~
</add after>

<search for>
    </table>
    </td>
   </tr>
~;
</search for>

<add after>
	}

## [Poll Mod Options] ##
	if ($pollthread) {
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		if ($guest_vote) {$gvchecked = " checked";}
		if ($hide_results) {$hrchecked = " checked";}
		if ($multi_choice) {$mcchecked = " checked";}
		$yymain .= qq~
        <tr>
          <td bgcolor="$color{'windowbg2'}" class="windowbg2">
            <input type="hidden" name="pollthread" value="$pollthread">
            <table width="100%" cellpadding="3" cellspacing="0" border="0">
              <tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'6'}:</b></font></td>
                <td align="left"><input type="text" size="40" name="question" value="$poll_question" maxlength="$maxpq"></td>
              </tr><tr>
                <td width="23%" align="left">&nbsp;</td>
                <td align="left">
                  <table cellpadding="0" cellspacing="0" border="0">~;

		for(my $i = 1; $i <= $numpolloptions; $i++) {
			$yymain .= qq~
                    <tr>
                      <td align="right"> &nbsp; <font size="2">$polltxt{'7'} $i: &nbsp;</font></td>
                      <td align="left"><input type="text" size="25" maxlength="$maxpo" name="option$i" value="$options[$i]"></td>
                    </tr>~;
		}
		$yymain .= qq~
                  </table>
                </td>~;

		if ($maxpc > 0) {
			$yymain .= qq~
             </tr><tr>
                <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$polltxt{'59'}:</b></font></td>
                <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><textarea name="poll_comment" rows="3" cols="60" wrap="soft" onkeyup="if (document.postmodify.poll_comment.value.length > $maxpc) {document.postmodify.poll_comment.value = document.postmodify.poll_comment.value.substring(0,$maxpc)}">$poll_comment</textarea></font></td>~;
		}

		$yymain .= qq~
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'32'}</b></font></td>
                <td align="left"><input type="checkbox" name="guest_vote" value="1"$gvchecked> <font size="1">$polltxt{'54'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'26'}</b></font></td>
                <td align="left"><input type="checkbox" name="hide_results" value="1"$hrchecked> <font size="1">$polltxt{'55'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'58'}</b></font></td>
                <td align="left"><input type="checkbox" name="multi_choice" value="1"$mcchecked> <font size="1">$polltxt{'56'}</font></td>
              </tr>

            </table>
          </td>
        </tr>~;
	}
	if ($pollthread != 2) { # if not adding a poll to an existing thread, display standard post page inputs

## [/Poll Mod Options] ##

</add after>

<search for>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}">
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center">
        <font size="1" class="text1" color="$color{'titletext'}"><font size="1">$txt{'329'}</font></font><BR>
		<input type="hidden" name="waction" value="$waction">
		<input type="submit" name="$post" value="$submittxt" onClick="WhichClicked('$post');" accesskey="s" tabindex="5">
		<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">
~;
</search for>

<replace>
  </tr>~;
	}
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}">
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center">
        <font size="1" class="text1" color="$color{'titletext'}"><font size="1">$txt{'329'}</font></font><BR>
		<input type="hidden" name="waction" value="$waction">
		<input type="submit" name="$post" value="$submittxt" onClick="WhichClicked('$post');" accesskey="s" tabindex="5">
~;
unless ($pollthread == 2) {$yymain .= qq~		<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">~;}
</replace>

<search for>
sub Preview {
</search for>

<add after>
	$poll_question = $FORM{'question'};
	$numpolloptions ||= 8;
	for(my $i = 1; $i <= $numpolloptions; $i++) {$options[$i] = $FORM{"option$i"};}
	$guest_vote = $FORM{'guest_vote'};
	$hide_results = $FORM{'hide_results'};
	$multi_choice = $FORM{'multi_choice'};
	$poll_comment = $FORM{'poll_comment'};
	$pollthread =  $FORM{'pollthread'} || 0;

</add after>

<search for>
	&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~);
</search for>

<add before>
	$pollthread = $FORM{'pollthread'} || 0;
	if ($pollthread != 2) {	# If user is NOT adding a Poll to an existing thread
</add before>

<search for>

	if ($username ne 'Guest') {
		# If not guest, get name and email.
</search for>

<add before>

	} # end if

</add before>

<search for>
	# If no thread specified, this is a new thread.
	# Find a valid random ID for it.
</search for>

<add before>
## [Poll Mod] ##
	my @poll_data;
	if ($pollthread) {	
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		$numcount = 0;
		if ( length($FORM{"question"} ) > $maxpq) { &fatal_error("$polltxt{'40'} $polltxt{'34a'} $maxpq $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($FORM{"question"});
		$guest_vote = $FORM{'guest_vote'} || 0;
		$hide_results = $FORM{'hide_results'} || 0;
		$multi_choice = $FORM{'multi_choice'} || 0;
		$poll_comment = $FORM{'poll_comment'} || "";
		if ( length($poll_comment ) > $maxpc) { &fatal_error("$polltxt{'57'} $polltxt{'34a'} $maxpc $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($poll_comment);
		$poll_comment =~ s~\n~<br>~g;
		$poll_comment =~ s~\r~~g;
		push @poll_data, qq~$FORM{"question"}|0|$username|$name|$email|$date|$guest_vote|$hide_results|$multi_choice|||$poll_comment\n~;

		for ($i = 1; $i <= $numpolloptions; $i++){
			if ($FORM{"option$i"}) {
				if (length($FORM{"option$i"}) > $maxpo) { &fatal_error("$polltxt{'7'} $i  $polltxt{'34a'} $maxpo $polltxt{'34b'} $polltxt{'36'}"); }
				&ToHTML($FORM{"option$i"});
				$numcount++;
				push @poll_data, qq~0|$FORM{"option$i"}\n~;
			}
		}
		unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
		if ($numcount < 2) { &fatal_error("$polltxt{'38'}"); }
	}
## [/Poll Mod] ##

</add before>

<search for>
	} else {
		# This is an old thread. Save it.
</search for>

<replace>
		if ($pollthread) { # Save Poll data for new thread
			fopen (POLL, ">$datadir/$newthreadid.poll");
			print POLL @poll_data;
			fclose (POLL);
		}
	} else {
		# This is an old thread. Save it.
		if ($pollthread) { # Save new Poll data
			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL @poll_data;
			fclose (POLL);
			$yySetLocation = qq~$cgi;action=display;num=$threadid~;
			&redirectexit;
		} else { # or save new reply data
</replace>

<search for>
	}

	if($username ne 'Guest') {
		# Increment post count for the member.
</search for>

<add before>

		} # end else

</add before>

###############################################################################

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	my($menuchecked, $ubbcchecked, $aluchecked, $cpchecked, $pbchecked, $insertchecked, $newschecked, $gpchecked, $notifchecked);
</search for>

<add after>
	my ($uapchecked, $upchecked);
</add after>

<search for>
	if ($showyabbcbutt) { $syabbcchecked = "checked" }
</search for>

<add after>
	$maxpq ||= 60;
	$maxpo ||= 50;
	$maxpc ||= 0;
	$numpolloptions ||= 8;
	if ($useraddpoll) { $uapchecked = " checked" }
	if ($ubbcpolls) { $upchecked = " checked" }
</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'746'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowpics" $allowpicschecked></td>
  </tr><tr>
</search for>

<add before>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'28'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="numpolloptions" size="5" value="$numpolloptions"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'61'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpq" size="5" value="$maxpq"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'62'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpo" size="5" value="$maxpo"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'63'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpc" size="5" value="$maxpc"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'29'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="useraddpoll"$uapchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'60'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="ubbcpolls"$upchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
</add before>

<search for>
	my @onoff = qw/
		allowpics showyabbcbutt showbdescrip maintenance guestaccess insert_original enable_ubbc enable_news enable_guestposting enable_notification showlatestmember showrecentbar showmarkread showmodify showuserpic showusertext showgenderimage shownewsfader MenuType curposlinks profilebutton autolinkurls emailpassword RegAgree emailwelcome allow_hide_email usetempfile faketruncation emailnewpass/;
</search for>

<add after>
	push(@onoff, "useraddpoll", "ubbcpolls", "pollcomments");
</add after>

<search for>
	$maxmesslen = $FORM{'maxmesslen'} || 5000;
</search for>

<add after>
	$numpolloptions = $FORM{'numpolloptions'} || 8;
	$maxpq = $FORM{'maxpq'} || 60;
	$maxpo = $FORM{'maxpo'} || 50;
	$maxpc = $FORM{'maxpc'} || 0;
</add after>

<search for>
\$MaxMessLen = $maxmesslen;  				# Maximum Allowed Characters in a Posts
</search for>

<add after>
\$numpolloptions = $numpolloptions;  			# Number of poll options
\$maxpq = $maxpq;  						# Maximum Allowed Characters in a Poll Qestion?
\$maxpo = $maxpo;  						# Maximum Allowed Characters in a Poll Option?
\$maxpc = $maxpc;  						# Maximum Allowed Characters in a Poll Comment?
\$useraddpoll = $useraddpoll;  				# Allow users to add polls to existing threads? (1 = yes)
\$ubbcpolls = $ubbcpolls;  					# Allow UBBC tags and smilies in polls? (1 = yes)

</add after>

###############################################################################

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
				if ($1 eq 'mail' && -e "$datadir/$thread.mail") { unlink("$datadir/$thread.mail"); }
</search for>

<add after>
				if ($1 eq 'poll' && -e "$datadir/$thread.poll") { unlink("$datadir/$thread.poll"); } 
				if ($1 eq 'polled' && -e "$datadir/$thread.polled") { unlink("$datadir/$thread.polled"); } 
</add after>
