<id>
Board Index Showcase Poll Addon Mod for Polls v3
</id>

<version>
1.0
</version>

<mod info>
"Showcase's" a poll selected by the Admin to be displayed on the Board Index page.

Showcase a Poll by clicking "Showcase Poll?" in Title Bar of existing polls (Admin only).

Remove the current "Showcase Poll" by clicking "Remove Showcase Poll?" in Title Bar 
of the currently showcased poll on the Board Index page (Admin only).

Current "Showcase Poll's" are designated in the thread display page of the poll which is the 
current "Showcase Poll" with "Currently Being Showcased" in the Title Bar of 
the Poll (visible to all users).

Link to the Thread of which the Showcase Poll is associated is provided.

If a Poll that is currently being "Showcased", is in a thread that resides in a Category 
for which the Guest or Member does not have access to, then the "Showcase Poll" will 
not be displayed to that Guest or Member on the Board Index page.

THIS MOD REQUIRES POLLS V3 By BHRA (it will NOT install on Polls v2)

Version 1.0 - First Release

Files modified:
  english.lng
  YaBB.pl
  Sources/BoardIndex.pl
  Sources/Poll.pl
  Sources/ModifyMessage.pl


Credit obviously goes to BHRA for Polls v3 and then to Shoeb Omar (Omario) and Sam Holman (Samm) for previous Poll Mods.
Big Thank You goes to all the mod writers that I have learned from, especially BHRA!

</mod info>

<author>
DummyProof
</author>

<homepage>
http://cgi.tripod.com/yabbsp1_1/cgi-bin/YaBB.pl
</homepage>

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'showvoters') { require "$sourcedir/Poll.pl"; &votedetails; }
</search for>

<add after>
	elsif ($action eq 'scpoll') { require "$sourcedir/Poll.pl"; &showcasepoll; }
	elsif ($action eq 'scpolldel') { require "$sourcedir/Poll.pl"; &delshowcasepoll; }
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}
</search for>

<add after>
########showcase poll start
# Look for a showcase.poll file.
if (-e "$datadir/showcase.poll") {
	my ($board, $viewnum);
	fopen (FILE, "$datadir/showcase.poll");
	@showdata = <FILE>;
	fclose (FILE);
	$showcasepoll = $showdata[0];
	$showcasepoll =~ s~\n~~g;
	($scboard, $viewnum) = split(/\|/, $showcasepoll);

	# Look for a valid poll file.
	if (-e "$datadir/$viewnum.poll") {
	$pollthread = 1;
	unless( &BoardAccessGet($scboard) ) { $pollthread = 0; }
	}
	if ($pollthread) { 
		$yymain .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
		require "$sourcedir/Poll.pl"; &display_poll($viewnum, 1, $scboard);
	 }
}
#########showcase poll end

</add after>

<edit file>
Sources/Poll.pl
</edit file>

<search for>
sub DoVote {
	$pollnum = $INFO{'num'};
	$start = $INFO{'start'};
</search for>

<add after>
	$scpoll = $INFO{'scp'};
</add after>

<search for>
	fopen (FILE, ">$datadir/$pollnum.polled");
	print FILE "$user_ip|$username|$vote|$date\n";
	print FILE @polled;
	fclose (FILE);
			
	if ($start) { $start = ";start=$start"; }
	$yySetLocation = qq~$cgi;action=display;num=$pollnum$start~;
</search for>

<replace>
	fopen (FILE, ">$datadir/$pollnum.polled");
	print FILE "$user_ip|$username|$vote|$date\n";
	print FILE @polled;
	fclose (FILE);
			
	if ($start) { $start = ";start=$start"; }
	if ($scpoll == 1){
		$yySetLocation = qq~$scripturl~;
	} else {
		$yySetLocation = qq~$cgi;action=display;num=$pollnum$start~;
	}
</replace>

<search for>
sub UndoVote {
	$pollnum = $INFO{'num'};
</search for>

<add after>
	$scpoll = $INFO{'scp'};
</add after>

<search for>
	fopen (FILE, ">$datadir/$pollnum.polled");
	print FILE @polled;
	fclose (FILE);
			
	if ($start) { $start = ";start=$start"; }
	$yySetLocation = qq~$cgi;action=display;num=$pollnum$start~;
</search for>

<replace>
	fopen (FILE, ">$datadir/$pollnum.polled");
	print FILE @polled;
	fclose (FILE);
			
	if ($start) { $start = ";start=$start"; }
	if ($scpoll == 1){
		$yySetLocation = qq~$scripturl~;
	} else {
		$yySetLocation = qq~$cgi;action=display;num=$pollnum$start~;
	}
</replace>

<search for>
sub LockPoll {
	$pollnum = $INFO{'num'};
</search for>

<add after>
	$scpoll = $INFO{'scp'};
</add after>

<search for>
	fopen (FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question|$poll_locked|$poll_uname|$poll_stuff\n";
	print FILE @poll_data;
	fclose (FILE);

	if ($start) { $start = ";start=$start"; }
	$yySetLocation = qq~$cgi;action=display;num=$pollnum$start~;
</search for>

<replace>
	fopen (FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question|$poll_locked|$poll_uname|$poll_stuff\n";
	print FILE @poll_data;
	fclose (FILE);

	if ($start) { $start = ";start=$start"; }
	if ($scpoll == 1){
		$yySetLocation = qq~$scripturl~;
	} else {
		$yySetLocation = qq~$cgi;action=display;num=$pollnum$start~;
	}
</replace>

<search for>
sub display_poll{
	$pollnum = @_[0];
</search for>

<add after>
########showcase poll
	$brdpoll = @_[1];
	$brdpid = @_[2];
	$scp = '';
	$vthread = '';
	$boardpoll = '';
	if($brdpoll){
		$scp = ";scp=$brdpoll";
		$vthread = qq~<a href="$cgi$scboard;action=display;num=$pollnum" class="altlink">$img{'viewthread'}</a>$menusep~;
	}

# Look for a showcase.poll file.
if (-e "$datadir/showcase.poll") {
	fopen (FILE, "$datadir/showcase.poll");
		@showdata = <FILE>;
	fclose (FILE);
	$showcasepoll = $showdata[0];
	$showcasepoll =~ s~\n~~g;
	($scboard, $scviewnum) = split(/\|/, $showcasepoll);
}
	if ($scviewnum == $pollnum && ( $brdpoll != 1 )){
		$boardpoll = qq~<i>$scpolltxt{'3'}</i>&nbsp;&nbsp;~;
	}
	if ($settings[7] eq "Administrator") {
		if ($scviewnum != $pollnum && ( $brdpoll != 1 )) {
			$boardpoll = qq~<a href="$cgi;action=scpoll;num=$pollnum" class="altlink">$scpolltxt{'4'}</a>&nbsp;&nbsp;~;
		} elsif ($scviewnum == $pollnum && ( $brdpoll == 1 )){
			$boardpoll = qq~<a href="$cgi;action=scpolldel" class="altlink">$scpolltxt{'2'}</a>&nbsp;&nbsp;~;
		}
	}
########showcase poll
</add after>

<search for>
		if ($poll_locked) {
			$lockpoll = qq~<a href="$cgi;action=lockpoll;num=$pollnum" class="altlink">$img{'openpoll'}</a>~;
		} else {
			$lockpoll = qq~<a href="$cgi;action=lockpoll;num=$pollnum" class="altlink">$img{'closepoll'}</a>~;
		}
		$modifypoll = qq~$menusep<a href="$cgi;action=modify;message=$polltxt{'15'};thread=$pollnum" class="altlink">$img{'modifypoll'}</a>~;
		$deletepoll = qq~$menusep<a href="javascript:DoConfirm('$polltxt{'44'}','$cgi;action=modify2;thread=$pollnum;id=$polltxt{'15'};d=1')" class="altlink">$img{'deletepoll'}</a>~;
		if ($settings[7] eq "Administrator") { $displayvoters = qq~<a href="$cgi;action=showvoters;num=$pollnum">$img{'viewvotes'}</a>~;}
		if ($hide_results) {
</search for>

<replace>
		if ($poll_locked) {
			$lockpoll = qq~<a href="$cgi;action=lockpoll;num=$pollnum$scp" class="altlink">$img{'openpoll'}</a>~;
		} else {
			$lockpoll = qq~<a href="$cgi;action=lockpoll;num=$pollnum$scp" class="altlink">$img{'closepoll'}</a>~;
		}
		$modifypoll = qq~$menusep<a href="$cgi$brdpid;action=modify;message=$polltxt{'15'};thread=$pollnum" class="altlink">$img{'modifypoll'}</a>~;
		$deletepoll = qq~$menusep<a href="javascript:DoConfirm('$polltxt{'44'}','$cgi$brdpid;action=modify2;thread=$pollnum;id=$polltxt{'15'};d=1')" class="altlink">$img{'deletepoll'}</a>~;
		if ($settings[7] eq "Administrator") { $displayvoters = qq~<a href="$cgi$brdpid;action=showvoters;num=$pollnum">$img{'viewvotes'}</a>~;}
		if ($hide_results) {
</replace>

<search for>
		$deletevote = qq~<a href="$cgi;action=undovote;num=$pollnum">$img{'deletevote'}</a>~;
</search for>

<replace>
		$deletevote = qq~<a href="$cgi;action=undovote;num=$pollnum$scp">$img{'deletevote'}</a>~;
</replace>

<search for>
            <table cellpadding="0" cellspacing="0" width="100%">
              <tr>
                <td valign="middle" align="left"><font size="2" class="text1" color="$color{'titletext'}">$poll_icon <b>$polltxt{'15'}</b></font></td>
                <td valign="middle" align="right"><font size="1" color="$color{'titletext'}">$lockpoll$modifypoll$deletepoll</font></td>
</search for>

<replace>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td valign="middle" align="left" width="35%"><font size="2" class="text1" color="$color{'titletext'}">$poll_icon <b>$polltxt{'15'}</b></font></td>
                <td valign="middle" align="center" width="30%">$boardpoll</td>
                <td valign="middle" align="right" width="35%"><font size="1" color="$color{'titletext'}">$lockpoll$modifypoll$deletepoll</font></td>
</replace>

<search for>
            <form name="poll" method="post" action="$cgi;action=vote;num=$pollnum" style="display:inline">
</search for>

<replace>
            <form name="poll" method="post" action="$cgi;action=vote;num=$pollnum$scp" style="display:inline">
</replace>

<search for>
                  <td valign="bottom" align="right"><br><font size="1">$deletevote$displayvoters</font></td>
</search for>

<replace>
                  <td valign="bottom" align="right"><br><font size="1">$vthread$deletevote$displayvoters</font></td>
</replace>

<search for>
1;
</search for>

<add before>
sub showcasepoll{
	if (-e "$datadir/showcase.poll") {
		fopen (FILE, "$datadir/showcase.poll");
		@showdata = <FILE>;
		fclose (FILE);
		$showcasepoll = $showdata[0];
		$showcasepoll =~ s~\n~~g;
		($tmpa, $tmpb) = split(/\|/, $showcasepoll);
	}
	my $brdid = $INFO{'board'};
	my $thrdid = $INFO{'num'};
	fopen (FILE, ">$datadir/showcase.poll");
	print FILE "$brdid|$thrdid";
	fclose (FILE);
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
	exit;
}

sub delshowcasepoll{
	if (-e "$datadir/showcase.poll") { unlink("$datadir/showcase.poll"); }
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
	exit;
}

</add before>

<edit file>
english.lng
</edit file>

<search for>
	$polltxt{'63'} = "Maximum number of Characters in a Poll Comment (Set to 0 to disable):";
</search for>

<add after>
	$scpolltxt{'1'} = "View Thread";
	$scpolltxt{'2'} = "Remove Showcase Poll?";
	$scpolltxt{'3'} = "Currently Being Showcased";
	$scpolltxt{'4'} = "Showcase Poll?";
</add after>

<search for>
		$img{'deletevote'} = qq~<font size="1" class="imgcatbg">$polltxt{'43'}</font>~;
</search for>

<add after>
		$img{'viewthread'} = qq~<font size="1" class="imgcatbg">$scpolltxt{'1'}</font>~;
</add after>

<search for>
		$img{'deletevote'} = qq~<img src="$imagesdir/poll_dvote.gif" alt="$polltxt{'43'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'43'}</font>~;
</search for>

<add after>
		$img{'viewthread'} = qq~<img src="$imagesdir/thread.gif" alt="$scpolltxt{'1'}" border="0"> <font size="1" class="imgcatbg">$scpolltxt{'1'}</font>~;
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
			unlink("$datadir/$threadid.poll");
			unlink("$datadir/$threadid.polled");
</search for>

<add before>
			########showcase poll start
			# Look for a showcase.poll file to unlink.
			if (-e "$datadir/showcase.poll") {
				my ($board, $viewnum);
				fopen (FILE, "$datadir/showcase.poll");
				@showdata = <FILE>;
				fclose (FILE);
				$showcasepoll = $showdata[0];
				$showcasepoll =~ s~\n~~g;
				($scboard, $viewnum) = split(/\|/, $showcasepoll);
				if ($viewnum == $threadid) {unlink ("$datadir/showcase.poll");}
			}
			#########showcase poll end
</add before>