<id>
New Indicator Bug SP1/1.1
</id>

<version>
1.0
</version>

<mod info>
There is a bug in the users log which means the "new" topic indicator is shown on old posts regardless of when they were last viewed.
By old posts, I mean those that haven't been replied to within the time limit of the users log set in the admin center. 

This mod should fix that.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
		if( $max_log_days_old && $dlp != $threaddate && $username ne 'Guest' && &getlog("$currentboard--mark") < $threaddate ) {
</search for>

<replace>
		if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$currentboard--mark") < $threaddate ) {
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	&dumplog($mnum,$mdate);
</search for>

<replace>
	&dumplog($mnum,$date);
</replace>