##########################################################################
# SendEvent.pl version 3.51 for YaBB SP1 and SP 1.1                      #
# For use with NewcalendarSP1 version 3.51 w/form highlighter            #
##########################################################################
$sendeventplver = "3.51";

sub SendEvent {
	$eventdate = $FORM{'eventdate'} || 'Date';
	$eventday = $FORM{'eventday'} || 'Day';
	$eventmonth = $FORM{'eventmonth'} || 'Month';
	$eventyear = $FORM{'eventyear'} || 'Year';
	$eventname = $FORM{'eventname'} || 'Name';
	$eventauthor = $FORM{'eventauthor'} || 'Author';
	$eventtype = $FORM{'eventtype'} || 'Event Type';

	$yymain .= qq~
<form onKeyUp="highlight(event)" onClick="highlight(event)" action="$cgi;action=sendevent2" method="post">
  <table border=0  align="center" cellspacing=1 cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
    <tr>
      <td width="100%" bgcolor="$color{'windowbg'}" class="windowbg">
        <table width="100%" border="0" cellspacing="0" cellpadding="3">
          <tr>
            <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
              <img src="$imagesdir/email.gif" alt="" border="0">
              <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'339'}&nbsp;$ecaltxt{'83'}&nbsp; &#171; $eventname &#187; &nbsp;$txt{'708'}</b></font>
            </td>
          </tr><tr>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=right valign=top>
              <font size=2><B>$txt{'715'}</B></font>
            </td>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=left valign=middle>
              <input type="text" name="y_name" size="20" maxlength="40" value="$settings[1]">
            </td>
          </tr><tr>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=right valign=top>
              <font size=2><B>$txt{'716'}</B></font>
            </td>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=left valign=middle>
              <input type="text" name="y_email" size="20" maxlength="40" value="$settings[2]">
            </td>
          </tr><tr>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=center valign=top colspan="2">
              <hr width="100%" size="1" class="hr">
            </td>
          </tr><tr>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align="right" valign="top">
              <font size=2><B>$txt{'717'}</B></font>
            </td>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align="left" valign="middle">
              <input type="text" name="r_name" size="20" maxlength="40">
            </td>
          </tr><tr>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=right valign=top>
              <font size=2><B>$txt{'718'}</B></font>
            </td>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=left valign=middle>
              <input type="text" name="r_email" size="20" maxlength="40">
            </td>
          </tr><tr>
            <td bgcolor="$color{'windowbg'}" class="windowbg" align=center valign=middle colspan=2>
	        <INPUT TYPE="hidden" NAME="eventdate" VALUE="$eventdate">
	        <INPUT TYPE="hidden" NAME="eventday" VALUE="$eventday">
	        <INPUT TYPE="hidden" NAME="eventmonth" VALUE="$eventmonth">
	        <INPUT TYPE="hidden" NAME="eventyear" VALUE="$eventyear">
	        <INPUT TYPE="hidden" NAME="eventname" VALUE="$eventname">
	        <INPUT TYPE="hidden" NAME="eventauthor" VALUE="$eventauthor">
	        <INPUT TYPE="hidden" NAME="eventtype" VALUE="$eventtype">
              <input type="submit" name="Send" value="$txt{'339'}">
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
</form>
~;
	$yytitle = "$txt{'339'}&nbsp;$ecaltxt{'83'}&nbsp; &#171; $eventname &#187; &nbsp;$txt{'708'}";
	&template;
	exit;
}

sub SendEvent2 {
	$yname = $FORM{'y_name'};
	$rname = $FORM{'r_name'};
	$yemail = $FORM{'y_email'};
	$remail = $FORM{'r_email'};
	$eventdate = $FORM{'eventdate'} || 'Date';
	$eventday = $FORM{'eventday'} || 'Day';
	$eventmonth = $FORM{'eventmonth'} || 'Month';
	$eventyear = $FORM{'eventyear'} || 'Year';
	$eventname = $FORM{'eventname'} || 'Name';
	$eventauthor = $FORM{'eventauthor'} || 'Author';
	$eventtype = $FORM{'eventtype'} || 'Event Type';
	$yname =~ s/\A\s+//;
	$yname =~ s/\s+\Z//;
	$rname =~ s/\A\s+//;
	$rname =~ s/\s+\Z//;

	&fatal_error($txt{'75'}) unless ($yname ne '' && $yname ne '_' && $yname ne ' ');
	&fatal_error($txt{'568'}) if(length($yname) > 25);
	&fatal_error("$txt{'76'}") if($yemail eq '');
	&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($yemail !~ /^[0-9A-Za-z@\._\-]+$/);
	&fatal_error("$txt{'500'}") if(($yemail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($yemail !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	&fatal_error($txt{'75'}) unless ($rname ne '' && yname ne '_' && $rname ne ' ');
	&fatal_error($txt{'568'}) if(length($rname) > 25);
	&fatal_error("$txt{'76'}") if($remail eq '');
	&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($remail !~ /^[0-9A-Za-z@\._\-]+$/);
	&fatal_error("$txt{'500'}") if(($remail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($remail !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));

	&sendmail($remail,"$ecaltxt{'83'}:  $eventname ($txt{'318'} $yname)","$txt{'711'} $rname,\n\n$ecaltxt{'84'} $mbname. \n\n$ecaltxt{'83'}: $eventname\n$txt{'279'}: $eventauthor\n$ecaltxt{'33'} $eventtype\n$ecaltxt{'85'}: $eventdate\n\n$ecaltxt{'87'}\n\n$scripturl?action=newcalendar&selmonth=$eventmonth&selday=$eventday&selyear=$eventyear&acttype=viewdata\n\n$txt{'714'},\n$yname",$yemail);

	$yySetLocation = qq~$scripturl?action=newcalendar&selmonth=$eventmonth&selday=$eventday&selyear=$eventyear&acttype=viewdata~;
	&redirectexit;
}

1;
