$rebuildmod = "Rebuild Message Index 1.01 by BHRA Webmaster";

###############################################################################
# RebuildIndex.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# =========================================================================== #
# Mod Name:    Rebuild Message Index for SP1/1.1 - version 1.01               #
# Written by:  BHRA Webmaster (http://www.bhra.org.uk)                        #
###############################################################################

$rmi_txt{'1'} = "Rebuild Message Index";
$rmi_txt{'2'} = "Instructions:";
$rmi_txt{'3'} = "'Orphan' Board";
$rmi_txt{'4'} = "It may not be possible to determine which boards some threads were originally posted to. If you would like these 'Orphan' threads recovered, tick the checkbox and use the selection box to specify which board these threads should be sent to.";
$rmi_txt{'5'} = "Rebuild Index";
$rmi_txt{'6'} = "This admin function will cure problems associated with the message index, by scanning all the thread data files and using this information to rebuild the message index files. Use the checkboxes below to select which boards you want to rebuild, then press the button at the bottom.";
$rmi_txt{'7'} = "If you have applied this mod to an established message board, the existing threads will have to be updated so that YaBB will be able to determine which boards they originally came from. This should only need to be done once, and can be performed by clicking on the following link:";
$rmi_txt{'8'} = "Save board locations of existing threads";

$rmi_txt{'10'} = "The Forum must be in Maintainance Mode to perform this function.";
$rmi_txt{'11'} = "The Message Index File(s) have been rebuilt.";
$rmi_txt{'12'} = "The current board locations for all threads have been saved.";

###############################################################################

sub RMI_index {
	&is_admin;
	if ($maintenance != 1) { &fatal_error("$rmi_txt{'10'}"); }
	my $orphan = "";

	$yymain .= qq~
<form action="$cgi;action=rmi_recover" method="POST" style="display:inline">
<br>
<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>
          <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><img src="$imagesdir/exclamation.gif" alt="" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$rmi_txt{'1'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="2"><br><font size="1">$rmi_txt{'2'}<br><br>$rmi_txt{'6'}<br><br>$rmi_txt{'7'}<br><br><center><a href="$cgi;action=rmi_set">$rmi_txt{'8'}</a></center></font><br></td>
        </tr>~;

	fopen(FILE, "$vardir/cat.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	@categories = <FILE>;
	fclose(FILE);

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		@catinfo = <FILE>;
		fclose(FILE);
		chomp $curcatname;
		chomp $curcataccess;
		$yymain .= qq~
        <tr>
          <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">
            <table cellpadding="0" cellspacing="6" border="0" width="100%">
              <tr>
                <td align="left" valign="top" width="40%"><font size="2"><b>$curcatname</b></font></td>
                <td align="left" valign="top" width="60%"><font size="2">~;
		foreach $curboard (@catinfo) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			chomp $boardinfo[0];
			$boardname = $boardinfo[0];
			$selectname = $curboard.'check';
			$yymain .= qq~
                  <input type="checkbox" name="$selectname" value="1"> $boardname<br>~;
			if ($curboard eq $currentboard) {$selected = " selected";} else {$selected = "";}
			$orphan .= qq~
                    <option value="$curboard"$selected>$boardname</option>~;
		}
		$yymain .= qq~</font></td>
              </tr>
            </table>
          </td>
        </tr>~;
		$counter++;
	}

	$yymain .= qq~
        <tr>
          <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1">$rmi_txt{'4'}</font><br>
            <table cellpadding="0" cellspacing="6" border="0" width="100%" align="center">
              <tr>
                <td align="left valign="top" width="40%"><font size="2"><b>$rmi_txt{'3'}</b></font></td>
                <td align="left valign="top" width="60%"><font size="2"><input type="checkbox" name="orphancheck" value="1"> &nbsp; <select name="orphan">$orphan
                  </select>
                </font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="catbg" bgcolor="$color{'catbg'}" align="center" colspan="2"><input type="submit" value="$rmi_txt{'5'}"> &nbsp; <input type="reset" value="$txt{'278'}"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>~;

	$yytitle = "$rmi_txt{'1'}";
	&template;
	exit;
}

###############################################################################

sub RMI_recover {
	&is_admin;
	if ($maintenance != 1) { &fatal_error("$rmi_txt{'10'}"); }
	my @tmp;

	opendir(DIR, "$datadir");
	@contents = readdir(DIR);
	closedir(DIR);
	if ($FORM{"orphancheck"} ne "1") {$FORM{"orphan"} = "";}
	foreach $filename (@contents) {
		my ($mnum, $ext) = split(/\./, $filename);
		if ($ext eq "txt" && -e "$datadir/$mnum.txt") {
			fopen(FILE, "$datadir/$mnum.data");
			$stuff = <FILE>;
			$boardid = <FILE> || $FORM{"orphan"};
			$mstate = <FILE> || "0";
			fclose(FILE);
			chomp $boardid;
			chomp $mstate;
			if ($boardid eq "") {$boardid = $FORM{"orphan"};}

			fopen(FILE,"$datadir/$mnum.txt");
			@messages = <FILE>;
			fclose(FILE);
			$mreplies = $#messages;
			($msubthread, $mname, $memail, $dummy, $musername, $micon, $dummy, $dummy, $postmessage, $dummy) = split(/\|/, $messages[0]);
			if ($postmessage =~ m/^$txt{'160'}/) {$msubthread = "$txt{'758'}: ".$msubthread;} # changes subject in message index to "Moved: Subject"
			($dummy, $dummy, $dummy, $date1, $dummy) = split(/\|/, $messages[$mreplies]);
			&exact_time_since_datum;

			$threadLine = qq~$result|$mnum|$msubthread|$mname|$memail|$date1|$mreplies|$musername|$micon|$mstate\n~;
			push @{ $HoA{$boardid} }, $threadLine;
		}
	}

	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		@catinfo = <FILE>;
		fclose(FILE);
#		$yymain .= qq~<br><b>$curcatname</b><br>~;
		foreach $curboard (@catinfo) {
			chomp $curboard;
			if ($FORM{$curboard.'check'} == 1 || $FORM{"orphan"} eq $curboard) {
				@messages = sort{$b <=> $a} @{ $HoA{$curboard} };
				foreach (@messages) { ($dummy, $_) = split(/\|/,$_,2); }
				fopen(FILE, "+>$boardsdir/$curboard.txt");
				print FILE @messages;
				fclose(FILE);
				&BoardCountTotals($curboard);
#				$yymain .= qq~$curboard<br>~;
			}
		}
	}

	$yymain .= qq~
<br>
<table border="0" width="80%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/info.gif" alt="" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$rmi_txt{'1'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}"><br><font size="2">$rmi_txt{'11'}</font><br><br></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<center><br><a href="javascript:history.go(-1)">$txt{'250'}</a></center>~;

	$yytitle = "$rmi_txt{'1'}";
	&template;
	exit;
}

###############################################################################

sub RMI_set {
	&is_admin;
	if ($maintenance != 1) { &fatal_error("$rmi_txt{'10'}"); }

	fopen(FILE, "$vardir/cat.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	@categories = <FILE>;
	fclose(FILE);
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		@catinfo = <FILE>;
		fclose(FILE);
#		$yymain .= qq~<br><b>$curcatname</b><br>~;
		foreach $curboard (@catinfo) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
			@threadlist = <FILE>;
			fclose(FILE);
			foreach $thread ( @threadlist ) {
				chomp $thread;
				($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $thread );
				fopen(FILE, "$datadir/$mnum.data");
				@other_stuff = <FILE>;
				fclose(FILE);

				chomp $other_stuff[0];
				$other_stuff[0] = qq~$other_stuff[0]\n~;
				$other_stuff[1] = qq~$curboard\n~;
				$other_stuff[2] = qq~$mstate\n~;

				fopen(FILE, "+>$datadir/$mnum.data");
				print FILE @other_stuff;
				fclose(FILE);

			}
#			$yymain .= qq~$curboard<br>~;
		}
	}

	$yymain .= qq~
<br>
<table border="0" width="80%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/info.gif" alt="" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$rmi_txt{'1'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}"><br><font size="2">$rmi_txt{'12'}</font><br><br></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<center><br><a href="javascript:history.go(-1)">$txt{'250'}</a></center>~;

	$yytitle = "$rmi_txt{'1'}";
	&template;
	exit;
}

###############################################################################

sub exact_time_since_datum {  # Input: $date1
	my( $dates, $times, $month, $day, $year, $hour, $min, $sec, $number1, $dummy, $number2 );
	my @days = (0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
	($dates, $times) = split(/ $txt{'107'} /, $date1);
	($month, $day, $year) = split(/\//, $dates);
	($hour, $min, $sec) = split(/\:/, $times);
	$month--;

	# Y2K Bug - Assumes any year > 70 is > 1970 and any year < 70 is < 2070. (blank years are assumed to be 1900!)
	if ($year < 70 && $year ne "") {$year = $year + 100;}

	# If Month > Febuary, and current year is a leap year, add on an extra day.
	if ($month > 1 && ($year % 4) == 0) {$day = $day + 1;}

	$result = int($year*365.25) + $days[$month] + $day + ($hour/24) + ($min/1440) + ($sec/86400);
}

1;