<id>
Rebuild Message Index SP1/1.1 Recycle Bin Patch
</id>

<version>
1.0
</version>

<mod info>
This mod adds an admin function to rebuild damaged message index files. It does this by storing the id of the board each thread is on in the data file for that thread. By reading this information, YaBB can determine which board to place the threads on when rebuilding the index files for each board.

This is a Patch file for the Recycle Bin Mod. 

Only apply this mod if you have both the Rebuild Message Index Mod and the Recycle Bin Mod installed.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

#############################################################################################################

<edit file>
Sources\RemoveThread.pl
</edit file>

<search for>
				fopen(FILE, "$datadir/$thread.$1");
				@fileinfo = <FILE>;
				fclose(FILE);
</search for>

<add after>
				if ($1 eq 'data') {
					chomp $fileinfo[0]; $fileinfo[0] = qq~$fileinfo[0]\n~;
					$fileinfo[1] = qq~Recycle_Bin\n~;
				}
</add after>