<id>
Search Update SP1/1.1
</id>

<version>
1.0
</version>

<mod info>
This mod updates the Search function to search for whole words, and includes a few bug fixes for good measure!

Features/Improvements:
	"Match all words", "Match any words" and "Match as phrase" now match whole words instead of partial words (searching for "ban" WON'T match "banana" or "abandon")
	"Match partial words" search option added (so searching for "ban" WILL match "banana" and "abandon")
	If you enter the same search word twice, it only searches for the word once (removing the "nesting error" bug caused when the word was highlighted multiple times).
	If you use "Match as phrase", the phrase is now highlighted if found in the message.
	Censored words and phrases are now highlighted.
	New "Display only one result per thread?" search option added so only one post is displayed per thread.
	Now uses a new [highlight] ubbc tag so search strings in code boxes are highlighted. (as an added bonus, this new tag can be used in regular messages) 
	Search strings in certain ubbc tags are NOT highlighted, so the links still work.
	
To install: 
	Apply the mod and upload the modified files - that's it!

</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

###############################################################################

<edit file>
english.lng
</edit file>

<search for>
$txt{'191'} = "Display how many results?";
</search for>

<add after>
$txt{'191a'} = "Display only one result per thread?";
</add after>

<search for>
$txt{'345'} = "Match as phrase";
</search for>

<add after>
$txt{'345a'} = "Match partial words";
</add after>

###############################################################################

<edit file>
Sources/Search.pl
</edit file>

<search for>
         <option value="asphrase">$txt{'345'}</option>
</search for>

<add after>
         <option value="aspartial">$txt{'345a'}</option>
</add after>

<search for>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><b>$txt{'191'}</B></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
        <input type=text size=5 name=numberreturned maxlength=5 value=25></font></td>
      </tr><tr>
</search for>

<add after>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><b>$txt{'191a'}</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
        <input type=checkbox name=oneperthread value=1></font></td>
      </tr><tr>
</add after>

<search for>
	my $search = $FORM{'search'};
</search for>

<add after>
	my $one_per_thread = $FORM{'oneperthread'} || 0;
</add after>

<search for>
	elsif( $searchtype eq 'asphrase' ) { $searchtype = 3; }
</search for>

<add after>
	elsif( $searchtype eq 'aspartial' ) { $searchtype = 4; }
</add after>

<search for>
	if( $searchtype != 3 ) { @search = split( /\s+/, $search ); }
	else { @search = ( $search ); }
</search for>

<replace>
	if( $searchtype != 3 ) { @search = split( /\s+/, lc $search ); }
	else { @search = ( lc $search ); }
</replace>

<search for>
			postcheck: for( $msgnum = 0; $msgnum < @messages; $msgnum++ ) {
</search for>

<replace>
			postcheck: for( $msgnum = @messages; $msgnum >= 0; $msgnum-- ) {
</replace>

<search for>
				if( $searchsubject ) {
					if( $searchtype == 2 ) {
						$subfound = 0;
						foreach( @search ) {
							if( $msub =~ m~\Q$_\E~i ) { $subfound = 1; last; }
						}
					}
					else {
						$subfound = 1;
						foreach( @search ) {
							if( $msub !~ m~\Q$_\E~i ) { $subfound = 0; last; }
						}
					}
				}
				if( $searchmessage && ! $subfound ) {
					if( $searchtype == 2 ) {
						$msgfound = 0;
						foreach( @search ) {
							if( $message =~ m~\Q$_\E~i ) { $msgfound = 1; last; }
						}
					}
					else {
						$msgfound = 1;
						foreach( @search ) {
							if( $message !~ m~\Q$_\E~i ) { $msgfound = 0; last; }
						}
					}
				}
				unless( $msgfound || $subfound ) { next postcheck; }
				if( $subfound ) {
					foreach( @search ) {
						$msub =~ s~(\Q$_\E)~<font size="3"><b>$_</b></font>~ig;
					}
				}
				$data{$mtime} = [$curboard, $tnum, $msgnum, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate];
				if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
				++$numfound;
</search for>

<replace>
				if( $searchsubject ) {
					if( $searchtype == 2 || $searchtype == 4 ) {
						$subfound = 0;
						foreach( @search ) {
							if( $searchtype == 4 && $msub =~ m~\Q$_\E~i ) { $subfound = 1; last; }
							elsif( $msub =~ m~(^|\W|_)\Q$_\E(?=$|\W|_)~i ) { $subfound = 1; last; }
						}
					}
					else {
						$subfound = 1;
						foreach( @search ) {
							if( $msub !~ m~(^|\W|_)\Q$_\E(?=$|\W|_)~i ) { $subfound = 0; last; }
						}
					}
				}
				if( $searchmessage && ! $subfound ) {
					if( $searchtype == 2 || $searchtype == 4 ) {
						$msgfound = 0;
						foreach( @search ) {
							if( $searchtype == 4 && $message =~ m~\Q$_\E~i ) { $msgfound = 1; last; }
							elsif( $message =~ m~(^|\W|_)\Q$_\E(?=$|\W|_)~i ) { $msgfound = 1; last; }
						}
					}
					else {
						$msgfound = 1;
						foreach( @search ) {
							if( $message !~ m~(^|\W|_)\Q$_\E(?=$|\W|_)~i ) { $msgfound = 0; last; }
						}
					}
				}
				unless( $msgfound || $subfound ) { next postcheck; }
				$data{$mtime} = [$curboard, $tnum, $msgnum, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate];
				if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
				++$numfound;
				if( $one_per_thread ) { last postcheck; }
</replace>

<search for>
	for( $i = 0; $i < @messages; $i++ ) {
</search for>

<add before>
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$search =~ s~\Q$tmpa\E~$tmpb~gi; 
	}

	# Search for censored or uncencored search string and remove duplicate words
	my @tmpsearch;
	if( $searchtype == 3 ) {@tmpsearch = ( lc $search );}
	else {@tmpsearch = split( /\s+/, lc $search );}
	push @tmpsearch, @search;
	undef %found;
	@search = grep(!$found{$_}++, @tmpsearch);

#	$searchstring = join('", "', @search);
#	$yymain .= qq~Search for: "$searchstring"<br><br>~;

</add before>

<search for>
		$sender = "search";	# for efficiency we let bolding be done in the wrap function
		&wrap;
</search for>

<replace>
		# Highlight search strings in Subject heading
		foreach $tmp ( @search ) {
			if( $searchtype == 4 ) {$msub =~ s~(\Q$tmp\E)~<font size="3"><b>$1</b></font>~ig;}
			else {$msub =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<font size="3"><b>$2</b></font>$3~ig;}
		}

		&wrap;
		# Highlight search strings in Message
		if( $autolinkurls ) {
			$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1\[url=$2\]$2\[\/url\]~isg;
			$message =~ s~([^\"\=\[\]/\:\.(\://\w+)]|[\n\b]|\A)\\*(www\.[^\.][\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$1\[url=$2\]$2\[\/url\]~isg;
		}
		$message =~ s~\[(url|link|email)\](.*?)\[/\1\]~\[$1=$2\]$2\[/$1\]~ig;
		$message =~ s~\[(news|gopher|ftp|flash|img)(.*?)\](.*?)\[/\1\]~\[$1$2 tmp=$3\](.*?)\[/$1\]~ig;
		foreach $tmp ( @search ) {
			if($searchtype == 4) { $message =~ s~(\Q$tmp\E)~\[highlight\]$1\[/highlight\]~ig; }
			else { $message =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1\[highlight\]$2\[/highlight\]$3~ig; }
		}
		$tmp=1;
		while($tmp) {
			$message =~ s~\[([^\]]*?)\[/?highlight(.*?)\]~\[$1~ig;
			if ($message !~ m~\[([^\]]*?)\[/?highlight(.*?)\]~i) { $tmp=0; }
		}
		$message =~ s~\[(news|gopher|ftp|flash|img)(.*?) tmp=(.*?)\](.*?)\[/\1\]~\[$1$2\]$3\[/$1\]~ig;
</replace>

###############################################################################

<edit file>
Sources/Subs.pl
</edit file>

<search for>
			$cur =~ s~(\S{72})~$1 ~g;
			if($sender eq "search") {
				foreach( @search ) {
					if($cur !~ m~<yabbbr>~) { $cur =~ s~(\Q$_\E)~\[b\]$_\[/b\]~ig; }
				}
			}
</search for>

<replace>
			$cur =~ s~(\S{72})~$1 ~g;
</replace>

###############################################################################

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
		$code =~ s~([\(\)\-\:\\\/\?\!\]\[\.\^])~$killhash{$1}~g;
</search for>

<add after>
		$code =~ s~\&\#91\;highlight\&\#93\;(.*?)\&\#91\;\&\#47\;highlight\&\#93\;~<b>$1</b>~isg;
</add after>

<search for>
	$message =~ s~\[blue\](.*?)\[/blue\]~<font color=0000FF>$1</font>~isg;
</search for>

<add after>
	$message =~ s~\[highlight\](.*?)\[/highlight\]~<b>$1</b>~isg;
</add after>

###############################################################################

<edit file>
Sources/PrintPage.pl
</edit file>

<search for>
		$threadpost =~ s~<br>~\n~ig;
</search for>

<add after>
		$threadpost =~ s~\[highlight(.*?)\](.*?)\[/highlight\]~$2~isg;
</add after>