<id>
YaMS 4.02 - MemberMap column add-on
</id>

<version>
2.6
</version>

<mod info>
THIS MOD IS ONLY FOR BOARDS WITH YaMS 4.02 AND MemberMap 2.6 ALLREADY INSTALLED!!
This mod adds a column for MemberMap in YaMS 4.02
Admin can set text/image mode and view/hide Member Map column from Admin-Center - 
Forum Preferences and Settings - Member List area.
In image-mode the column will show the members flag, in text-mode the members 
location. In both modes it will link to the members map.

Instructions:

Make sure you have both YaMS 4.02 and MemberMap 2.6 installed.
Apply the mod
Upload (in ASCII):
english.lng
Sources/AdminEdit.pl
Sources/Memberlist.pl
</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>


<edit file>
english.lng
</edit file>

<search for>
$membtxt{'54'} = "Columns";
</search for>

<add after>
$membtxt{'55'} = "City, Country";
</add after>


<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	my($sviewnumbcolm, $sviewipcolm, $sguest_allow, $sviewnumb, $smailpic, $smailtxt, $swwwpic, $swwwtxt, $simpic, $simtxt, $sicqpic, $sicqtxt, $syimpic, $syimtxt, $saimpic, $saimtxt);
</search for>

<add after>
	my($sviewmapcolm, $smappic, $smaptxt);
</add after>

<search for>
	if ($view_ipcolm) { $sviewipcolm = 'checked' }
</search for>

<add after>
	if ($view_mapcolm) { $sviewmapcolm = 'checked' }
</add after>

<search for>
	if ($guest_allow) { $sguest_allow = 'checked' }
</search for>

<add after>
	if ($mapcol eq "pic") { $smappic = 'checked' } else { $smaptxt = 'checked' }
</add after>

<search for>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'01'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mailcolm" $sviewmailcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="pic" $smailpic> <img src="$imagesdir/email.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="txt" $smailtxt> <font size="2">$membtxt{'48'}</font></td>
</search for>

<add before>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'01'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mapcolm" $sviewmapcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mapcol" value="pic" $smappic> <img src="$imagesdir/map.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mapcol" value="txt" $smaptxt> <font size="2">$membtxt{'55'}</font></td>
</add before>

<search for>
	push(@onoff, "view_numbcolm", "view_ipcolm", "guest_allow", "view_numb", "defbar", "mailcol", "wwwcol", "imcol", "icqcol", "yimcol", "aimcol");
</search for>

<add after>
	push(@onoff, "view_mapcolm", "mapcol");
</add after>

<search for>
	$mailcol = $FORM{'mailcol'} || 'pic';
</search for>

<add before>
	$mapcol = $FORM{'mapcol'} || 'pic';
</add before>

<search for>
\$view_mailcolm = $view_mailcolm;	     			# Set to 0 to hide e-mail column in Memberlist
</search for>

<add before>
\$view_mapcolm = $view_mapcolm;	     				# Set to 0 to hide Member Map column in Memberlist
</add before>

<search for>
\$mailcol = $mailcol;						# Set to txt for text in e-mail column
</search for>

<add before>
\$mapcol = $mapcol;						# Set to txt for text in map column
</add before>


<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
if($mailcol eq "pic") { $mailhdr .= qq(<IMG SRC="$imagesdir/email.gif" border="0" align="absmiddle" alt="$txt{'307'}">); } else { $mailhdr = "$txt{'307'}" }
</search for>

<add before>
if($mapcol eq "pic") { $maphdr .= qq(<IMG SRC="$imagesdir/map.gif" border="0" align="absmiddle" alt="$maptxt{'01'}">); } else { $maphdr = "$maptxt{'01'}" }
</add before>

<search for>
if ($view_regdate) {
	$membspan++;
}
</search for>

<add before>
	if ($view_mapcolm)	{ $membspan++; }
</add before>

<search for>
	if ($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
		if ($view_mailcolm && $mlcall ne "mlemail")	{
</search for>

<add before>
	if ($view_mapcolm)	{
	$TableHeader .= qq(
	<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$maphdr&nbsp;</td>
	);
	}
</add before>

<search for>
		if($member[7] eq "") { $member[7] = "$memberinfo"; }
</search for>

<add after>
		my($loccode, $memblocal, $membcountry, $membcontin, $membx, $memby, $dispflag);

		if($member[15] eq "")	{ $dispflag = "&nbsp;"; }
		else {
			($loccode, $memblocal, $membcountry, $membcontin, $membx, $memby, $dummy) = split(/\|/, $member[15]);
			if($membcountry ne "") {
				if($loccode eq "x1") {
					if($mapcol eq "pic") {
						$dispflag = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$name}#mmap"><img src="$imagesdir/flag/$membcountry.gif" border=0></a>~; 
						$mapjust = "center";
					}
					else {
						$dispflag = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$name}"#mmap>$memblocal, $membcountry</a>~; 
						$mapjust = "left";
					}
				}
				else { $dispflag = "&nbsp;"; }
			}
			else { $dispflag = "&nbsp;"; }
		}
</add after>

<search for>
				<td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$name}">$member[1]</a></font></td>
				~;
</search for>

<add after>
				if ($view_mapcolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mapjust" valign="middle"><font size=2>$dispflag</font></td>
					~;
				}
</add after>

<search for>
			if($member[7] eq "") { $member[7] = "$memberinfo"; }
</search for>

<add after>
			my($loccode, $memblocal, $membcountry, $membcontin, $membx, $memby, $dispflag);

			if($member[15] eq "")	{ $dispflag = "&nbsp;"; }
			else {
				($loccode, $memblocal, $membcountry, $membcontin, $membx, $memby, $dummy) = split(/\|/, $member[15]);
				if($membcountry ne "") {
					if($loccode eq "x1") {
						if($mapcol eq "pic") {
							$dispflag = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$membername}#mmap"><img src="$imagesdir/flag/$membcountry.gif" border=0></a>~; 
							$mapjust = "center";
						}
						else {
							$dispflag = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$membername}#mmap">$memblocal, $membcountry</a>~; 
							$mapjust = "left";
						}
					}
					else { $dispflag = "&nbsp;"; }
				}
				else { $dispflag = "&nbsp;"; }
			}
</add after>

<search for>
			<td valign="middle" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
			~;
</search for>

<add after>
			if ($view_mapcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mapjust" valign="middle"><font size=2>$dispflag</font></td>
				~;
			}
</add after>

<search for>
	unless(!$ipaddr)
	{
		for($i=0;$i<$memcount;$i++) {
			chomp(@imemberfile);
			$imemberfile[$i] =~ s/ //gi;
			$imemberfile[$i] =~ s/\n//gi;
			$memberfile = $imemberfile[$i];
			fopen(MEMBERFILEREAD,"$memberdir/$memberfile.yam");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;

			($SearchName1, $SearchName2, $SearchName3) = split(/\|/, $member[1]);

			if ($SearchName1 eq $ipaddr) {push(@ToShow,$memberfile);}
			elsif ($SearchName2 eq $ipaddr) {push(@ToShow,$memberfile);}
			elsif ($SearchName3 eq $ipaddr) {push(@ToShow,$memberfile);}
		}
		$memcount=@ToShow;
		$numshown=0; $b=$start;

		unless ($memcount == 0)	{
		while(($numshown < $MembersPerPage))
		{
			$membername=@ToShow[$b];
			if ($membername ne "")
			{
			@member = ();
			$Bar = "";
			$ICQ = "";
			$hjsite = "";
			fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;
			$viewipnumb = "";
			fopen(NUMBERFILEREAD,"$memberdir/$membername.yam");
			@number = <NUMBERFILEREAD>;
			fclose(NUMBERFILEREAD);
			chomp @number;
			if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
				($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
				if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
				else {
					$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
					if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
					if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
				}
			}
			if ($number[0] == 0) { $number[0] = "&nbsp;"; }
			&FormatUserName($membername);
</search for>

<add after>
		my($loccode, $memblocal, $membcountry, $membcontin, $membx, $memby, $dispflag);

		if($member[15] eq "")	{ $dispflag = "&nbsp;"; }
		else {
			($loccode, $memblocal, $membcountry, $membcontin, $membx, $memby, $dummy) = split(/\|/, $member[15]);
			if($membcountry ne "") {
				if($loccode eq "x1") {
					if($mapcol eq "pic") {
						$dispflag = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$membername}#mmap"><img src="$imagesdir/flag/$membcountry.gif" border=0></a>~; 
						$mapjust = "center";
					}
					else {
						$dispflag = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$membername}#mmap">$memblocal, $membcountry</a>~; 
						$mapjust = "left";
					}
				}
				else { $dispflag = "&nbsp;"; }
			}
			else { $dispflag = "&nbsp;"; }
		}
</add after>

<search for>
			if ($view_mailcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
				~;
			}
			if ($view_wwwcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
				~;
			}
			if ($view_imcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
				~;
			}
			if ($view_icqcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
				~;
			}
			if ($view_yimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$yimimg</font></td>
				~;
			}
			if ($view_aimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$aimimg</font></td>
				~;
			}
				if (-e "$sourcedir/Msn.pl" && $view_msncolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
					~;
					if ($msnsettings[0] ne '') {
						$yymain .= qq~
						<nobr>
						<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
						<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
						</nobr>
						~;
					}
					else { 
						$yymain .= qq~
						&nbsp;
					~;
					}

					$yymain .= qq~
					</td>
					~;
				}
				$yymain .= qq~
			<td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle"><font size=2>$member[7]</font>&nbsp;</td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$member[6]</font></td>
			<td class="windowbg" bgcolor="$color{'windowbg'}" width="104" align="absmiddle">$Bar</td>
			~;
			if ($view_regdate)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$dr</font></td>
				~;
			}
			if ($view_numbcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
				~;
			}
			if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$viewipnumb</font></td>
				~;
			}
			$yymain .= qq~
			</tr>
			~;
			}
			$numshown++;
			$b++;
		}
		}
	}
	if(!$ipaddr) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$membtxt{'34'}</b><br><br></td>~;}
</search for>

<add before>
			if ($view_mapcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mapjust" valign="middle"><font size=2>$dispflag</font></td>
				~;
			}
</add before>

