<id>
Security Fix SP1
</id>

<version>
1.4
</version>

<mod info>
This is a very important security fix for YaBB 1 Gold - Service Pack 1. Note that also all lower yabb versions are affected too!

v1.1: printpage.pl fixed too
v1.2: fixed checking for http://
v1.3: fixed image display
v1.4: fixed images with custom size
</mod info>

<author>
[CV]XXL
</author>

<homepage>
http://boardmod.xnull.com
</homepage>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
	$message =~ s~\[img\]\n?javascript\:(.+?)\n?\[/img\]~\[ img\]javascript\:$1\[/img \]~isg;
	if($message =~ m~\[img\]\n?(.+?)\n?\[/img\]~gi && $1 !~ m~javascript\:~gi) { $message =~ s~\[img\]\n?(.+?)\n?\[/img\]~<img src="$1" alt="" border="0">~isg; }
	$message =~ s~\[img width=(\d+) height=(\d+)\]\n?javascript\:(.+?)\n?\[/img\]~\[ img width=$1 height=$2\]javascript\:$3\[/img \]~isg;
	if($message =~ m~\[img width=(\d+) height=(\d+)\]\n?(.+?)\n?\[/img\]~gi && $3 !~ m~javascript\:~gi) { $message =~ s~\[img width=(\d+) height=(\d+)\]\n?(.+?)\n?\[/img\]~restrictimage($1,$2,$3)~eisg; }
</search for>

<replace>
	$char_160 = chr(160);
	$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~<img src="http\:\/\/$2" alt="" border="0">~isg;
	$message =~ s~\[img width=(\d+) height=(\d+)\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~restrictimage($1,$2,'http://'.$4)~eisg;
<</replace>

<edit file>
Sources/Printpage.pl
</edit file>

<search for>
		$threadpost =~ s~\[img\](.+?)\[/img\]~$1~isg;
		$threadpost =~ s~\[img width=(\d+) height=(\d+)\](.+?)\[/img\]~$3~eisg;
</search for>

<replace>
		$char_160 = chr(160);
		$threadpost =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~http://$2~isg;
		$threadpost =~ s~\[img width=(\d+) height=(\d+)\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~http://$4~isg;
</replace>