#!/usr/bin/perl

###############################################################################
# search.pl	(by Matt Mecham)                                              #
###############################################################################
# Modified version by maverick@unrealextreme.de                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Project started by Zef Hemel (zef@zefnet.com)                   #
# Software Version: YaBB 1 Final                                              #
# =========================================================================== #
# Software Distributed by:    www.yabb.org                                    #
# Support, News, Updates at:  www.yabb.org/cgi-bin/support/YaBB.pl            #
# =========================================================================== #
# Copyright (c) 2000-2001 YaBB - All Rights Reserved                          #
# Software by: The YaBB Development Team                                      #
###############################################################################

require "Settings.pl";
require "$sourcedir/Subs.pl";

$searchplver="1 Final";

$Cookie_Exp_Date = 'Mon, 31-Jan-3000 12:00:00 GMT';
&get_date;
&readform;
#if ($INFO{'catsearch'} !~ /^[\s0-9A-Za-z#%+,-\.:=?@^_]+$/){ &fatal_error("$txt{'399'}" ); }
if ($FORM{'catsearch'} =~ /\//){ &fatal_error("$txt{'397'}" ); } 
$cgi = "$boardurl/YaBB.pl\?board=$currentboard";
foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
	($cookie,$value) = split(/=/);
	if($cookie eq "$cookieusername") { $username="$value"; }
	if($cookie eq "$cookiepassword") { $password="$value"; }
}

if($username eq "") { $username = "Guest"; }

# Load user settings
if($username ne "Guest") {
	open(FILE, "$memberdir/$username.dat");
	&lock(FILE);
	@settings=<FILE>;
	&unlock(FILE);
	close(FILE);
	$settings[0] =~ s/\n//g;
	$settings[1] =~ s/\n//g;
	$settings[2] =~ s/\n//g;
	$settings[3] =~ s/\n//g;
	$settings[4] =~ s/\n//g;
	$settings[5] =~ s/\n//g;
	$settings[6] =~ s/\n//g;
	$settings[7] =~ s/\n//g;
	$settings[8] =~ s/\n//g;
	$realname="$settings[1]";
	$realemail = "$settings[2]";
}

$thisprogram = "Search.pl";

&readform;

$action = $FORM{'action'};
$search = $FORM{'search'};
$catsearch = $FORM{'catsearch'};
$numberreturned = $FORM{'numberreturned'};
$arraytostart = $FORM{'arraytostart'};
$newnumber = $FORM{'newnumber'};

$dropdown = $FORM{'dropdown'};

# ==== Begin Search Stuff =====================================================

if ($action eq "dosearch") { #start search results

# Prints out an error message if the user leaves the search form blank

if ($search eq "") {
&fatal_error("$better_search{'2'}");
}

# Truncates search string

$search =~ s/ //isg;
$search =~ s/\|//isg;
$search =~ s/\,//isg;
$search =~ s/\+//isg;
$search =~ s/\;//isg;
$search =~ s/\://isg;
$search =~ s/\"//isg;
$search =~ s/\'//isg;

# ==== Name Search (New Thread) ===============================================

if ($dropdown eq "startuser") {

	$title = "$txt{'166'}";
	&header;

	&namesearch("$catsearch");
	
	$totals = $mastercount - 1;
	
	if ($arraytostart eq "") { $arraytostart = "0"; }
	$arraystart = $arraytostart;
	
	$newnumber = $numberreturned + $newnumber;
	if ($newnumber > $totals) {
	$arrayend = $totals;
	$are_we_done = "<font face=\"Verdana, Arial\" size=1><b>$txt{'167'}</b> [ <a href=\"$boardurl/Search.pl\">$txt{'168'}</a> ]<br></font>";
	}
	else {
	$arrayend = ($numberreturned + $arraystart) - 1;
	$arraytostart = $arrayend + 1;
	$newnumber = $arrayend;
	$are_we_done = qq~

	<form action=\"$thisprogram\" method=\"post\">
	<input type=hidden name=action value=dosearch>
	<input type=hidden name=search value=$search>
	<input type=hidden name=dropdown value="startuser">
	<input type=hidden name=catsearch value=$catsearch>
	<input type=hidden name=arraytostart value=$arraytostart>
	<input type=hidden name=newnumber value=$newnumber>
	<input type=hidden name=numberreturned value=$numberreturned>
	<input type=submit name=submit value=\"$txt{'169'}\">
	</form>

	~;
	
	}
	
	$totaldone = $totals + 1;
	$totalstart = $arraystart + 1;
	$totalfinished = $arrayend + 1;
	
	if ($totaldone eq "0") { $resulttext = "$txt{'170'}"; }
	else { $resulttext = "$txt{'166'}: $totalstart $txt{'172'} $totalfinished"; }
	
	print <<"EOT";
<table width=100%>
<tr>
	<td><font face="Verdana,Arial" size=2><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;<A href="$boardurl/YaBB.pl">$mbname</A><br><IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$txt{'166'}</font></td>
</tr>
</table>

<table border=0 width=100% cellspacing=1 cellpadding=4 bgcolor="$color{'bordercolor'}">
<tr>
<td colspan=\"2\" bgcolor=\"$color{'titlebg'}\"><font face=\"Verdana, Arial\" size=2 color=\"$color{'titletext'}\"><b>$txt{'173'}: $search - $totaldone $txt{'174'}</b></font></td>
</tr><tr>
<td colspan=\"2\" bgcolor=\"$color{'catbg'}\"><font face=\"Verdana, Arial\" size=1>$resulttext</font></td>
<tr>
EOT
			
		$counter2 = $arraystart;
		foreach $number (@counter[$arraystart .. $arrayend]) {
		
		$temptitle = @threadtitle_var[$counter2];
		$tempmessage = @messagenumber_var[$counter2];
		$tempmessagetitle = @messagetitle_var[$counter2];
		$tempposter = @poster_var[$counter2];
		$tempdate = @date_var[$counter2];
		$tempsnippet = @snippet_var[$counter2];
		$tempcatboard = @catboard_var[$counter2];
		
		$tempsnippet =~ s/\<br><br>/<br>/sg;
		
		print "<td bgcolor=\"$color{'windowbg'}\" valign=top><font face=\"Verdana, Arial\" size=1 color=\"$color{'specialtext'}\">$tempdate</font></td>";
		print "<td bgcolor=\"$color{'windowbg2'}\" valign=top><font face=\"Verdana, Arial\" size=2>&nbsp;[ $tempcatboard] <a href=\"$boardurl/YaBB.pl?board=$temptitle&action=display&num=$tempmessage\" target=\"_blank\"><b>$tempmessagetitle</b></a></font></td>";
		print "</tr><tr>";
		print "<td colspan=\"2\" bgcolor=\"$color{'windowbg'}\" valign=top><font face=\"Verdana, Arial\" size=2>$tempsnippet...</font></td>";
		print "</tr><tr>";
		$counter2++;
		}
		
		print "<td colspan=\"2\" bgcolor=\"$color{'titlebg'}\"><font face=\"Verdana, Arial\" color=\"$color{'titletext'}\" size=2>$are_we_done</font></td>";

print <<"EOT";
</tr>
</table>
EOT

		&footer;
		exit;
	}
	
# ==== Name Search (New Post) =================================================
	
if ($dropdown eq "startpost") {

	$title = "$txt{'166'}";
	&header;

	&namepostsearch("$catsearch"); 
	
	$totals = $mastercount - 1;
	
	if ($arraytostart eq "") { $arraytostart = "0"; }
	$arraystart = $arraytostart;
	
	$newnumber = $numberreturned + $newnumber;
	if ($newnumber >= $totals) {
	$arrayend = $totals;
	$are_we_done = "<font face=\"Verdana, Arial\" size=1><b>$txt{'167'}</b> [ <a href=\"$boardurl/Search.pl\">$txt{'168'}</a> ]<br></font>";
	}
	else {
	$arrayend = ($numberreturned + $arraystart) - 1;
	$arraytostart = $arrayend + 1;
	$newnumber = $arrayend;
	$are_we_done = qq~
	
	<form action=\"$thisprogram\" method=\"post\">
	<input type=hidden name=action value=dosearch>
	<input type=hidden name=search value=$search>
	<input type=hidden name=dropdown value="startpost">
	<input type=hidden name=catsearch value=$catsearch>
	<input type=hidden name=arraytostart value=$arraytostart>
	<input type=hidden name=newnumber value=$newnumber>
	<input type=hidden name=numberreturned value=$numberreturned>
	<input type=submit name=submit value=\"$txt{'169'}\">
	</form>

	
	~;
	
	}
	
	$totaldone = $totals + 1;
	$totalstart = $arraystart + 1;
	$totalfinished = $arrayend + 1;
	
	if ($totaldone eq "0") { $resulttext = "$txt{'170'}"; }
	else { $resulttext = "$txt{'166'}: $totalstart $txt{'172'} $totalfinished"; }
	
print <<"EOT";
<table width=100%>
<tr>
	<td><font face="Verdana,Arial" size=2><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;<A href="$boardurl/YaBB.pl">$mbname</A><br><IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$txt{'166'}</font></td>
</tr>
</table>

<table border=0 width=100% cellspacing=1 cellpadding=4 bgcolor="$color{'bordercolor'}">
<tr>
<td colspan=\"2\" bgcolor=\"$color{'titlebg'}\"><font face=\"Verdana, Arial\" size=2 color=\"$color{'titletext'}\"><b>$txt{'177'}: $search - $totaldone $txt{'174'}</b></font></td>
</tr><tr>
<td colspan=\"2\" bgcolor=\"$color{'catbg'}\"><font face=\"Verdana, Arial\" size=1>$resulttext</font></td>
<tr>
EOT
		
		$counter2 = $arraystart;
		
		foreach $number (@counter[$arraystart .. $arrayend]) {
		
		$temptitle = @threadtitle_var[$counter2];
		$tempmessage = @messagenumber_var[$counter2];
		$tempmessagetitle = @messagetitle_var[$counter2];
		$tempposter = @poster_var[$counter2];
		$tempdate = @date_var[$counter2];
		$tempsnippet = @snippet_var[$counter2];
		$tempcatboard = @catboard_var[$counter2];
		$tempsnippet =~ s/\<br><br>/<br>/sg;
		
		print "<td bgcolor=\"$color{'windowbg'}\" valign=top><font face=\"Verdana, Arial\" size=1 color=\"$color{'specialtext'}\">$tempdate</font></td>";
		print "<td bgcolor=\"$color{'windowbg2'}\" valign=top><font face=\"Verdana, Arial\" size=2>&nbsp;[ $tempcatboard] <a href=\"$boardurl/YaBB.pl?board=$temptitle&action=display&num=$tempmessage\" target=\"_blank\"><b>$tempmessagetitle</b></a></font></td>";
		print "</tr><tr>";
		print "<td colspan=\"2\" bgcolor=\"$color{'windowbg'}\" valign=top><font face=\"Verdana, Arial\" size=2>$tempsnippet...</font></td>";
		print "</tr><tr>";
		$counter2++;
		}
		
		print "<td colspan=\"2\" bgcolor=\"$color{'titlebg'}\"><font face=\"Verdana, Arial\" size=2 color=\"$color{'titletext'}\">$are_we_done</font></td>";

print <<"EOT";
</tr>
</table>
EOT

		&footer;
		
		exit;

	}

# ==== Keyword Search =========================================================
	
if ($dropdown eq "startwords") {

	$title = "$txt{'166'}";
	&header;
	
	&keywordsearch("$catsearch"); 
	$totals = $mastercount - 1;
	
	if ($arraytostart eq "") { $arraytostart = "0"; }
	$arraystart = $arraytostart;
	
	$newnumber = $numberreturned + $newnumber;
	if ($newnumber >= $totals) {
	$arrayend = $totals;
	$are_we_done = "<font face=\"Verdana, Arial\" size=1><b>$txt{'167'}</b> [ <a href=\"$boardurl/Search.pl\">$txt{'168'}</a> ]<br></font>";
	}
	else {
	$arrayend = ($numberreturned + $arraystart) - 1;
	$arraytostart = $arrayend + 1;
	$newnumber = $arrayend;
	$are_we_done = qq~
	
	<form action=\"$thisprogram\" method=\"post\">
	<input type=hidden name=action value=dosearch>
	<input type=hidden name=search value=$search>
	<input type=hidden name=dropdown value="startwords">
	<input type=hidden name=catsearch value=$catsearch>
	<input type=hidden name=arraytostart value=$arraytostart>
	<input type=hidden name=newnumber value=$newnumber>
	<input type=hidden name=numberreturned value=$numberreturned>
	<input type=submit name=submit value=\"$txt{'169'}\">
	</form>

	~;
	
	}
	
	
	$totaldone = $totals + 1;
	$totalstart = $arraystart + 1;
	$totalfinished = $arrayend + 1;
	
	if ($totaldone eq "0") { $resulttext = "$txt{'170'}"; }
	else { $resulttext = "$txt{'166'}: $totalstart $txt{'172'} $totalfinished"; }

print <<"EOT";
<table width=100%>
<tr>
	<td><font face="Verdana,Arial" size=2><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;<A href="$boardurl/YaBB.pl">$mbname</A><br><IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$txt{'166'}</font></td>
</tr>
</table>

<table border=0 width=100% cellspacing=1 cellpadding=4 bgcolor="$color{'bordercolor'}">
<tr>
<td colspan=\"2\" bgcolor=\"$color{'titlebg'}\"><font face=\"Verdana, Arial\" size=2 color=\"$color{'titletext'}\"><b>$txt{'180'} $search - $totaldone $txt{'174'}</b></font></td>
</tr><tr>
<td colspan=\"2\" bgcolor=\"$color{'catbg'}\"><font face=\"Verdana, Arial\" size=1>$resulttext</font></td>
<tr>
EOT
	
		$counter2 = $arraystart;
		
		foreach $number (@counter[$arraystart .. $arrayend]) {
		
		$temptitle = @threadtitle_var[$counter2];
		$tempmessage = @messagenumber_var[$counter2];
		$tempmessagetitle = @messagetitle_var[$counter2];
		$tempposter = @poster_var[$counter2];
		$tempdate = @date_var[$counter2];
		$tempsnippet = @snippet_var[$counter2];
		$tempword = @foundword_var[$counter2];
		$tempcatboard = @catboard_var[$counter2];
		
		$tempsnippet =~ s/\<br><br>/<br>/sg;
		
		print "<td bgcolor=\"$color{'windowbg'}\" valign=top><font face=\"Verdana, Arial\" size=1 color=\"$color{'specialtext'}\">$tempdate</font></td>";
		print "<td bgcolor=\"$color{'windowbg2'}\" valign=top><font face=\"Verdana, Arial\" size=2>&nbsp;[ $tempcatboard] <a href=\"$boardurl/YaBB.pl?board=$temptitle&action=display&num=$tempmessage\" target=\"_blank\"><b>$tempmessagetitle</b></a></font></td>";
		print "</tr><tr>";
		print "<td colspan=\"2\" bgcolor=\"$color{'windowbg'}\" valign=top><font face=\"Verdana, Arial\" size=2>$txt{'197'}: <font color=\"$color{'specialtext'}\">$tempposter</font><br>$tempsnippet...</font></td>";
		print "</tr><tr>";
		$counter2++;
		}
		
		print "<td colspan=\"2\" bgcolor=\"$color{'titlebg'}\"><font face=\"Verdana, Arial\" size=2 color=\"$color{'titletext'}\">$are_we_done</font></td>";

print <<"EOT";
</tr>
</table>
EOT

		&footer;
		exit;
	
	}



}

else { &setup; }

# ==== Main Window ============================================================

sub setup {

    $dirtoopen = "$boardsdir";
    opendir (DIRECTORY,"$dirtoopen"); 
    @dirdata = readdir(DIRECTORY);
    closedir (DIRECTORY);
    
    @datdata = grep(/dat/,@dirdata);
    $totalboards = @sorteddirdata;
    
	$filetoopen = "$vardir/cat.txt";
	open(FILE, "$filetoopen");
	&lock(FILE);
	@masterdata = <FILE>;
	&unlock(FILE);
	close(FILE);

	foreach $category (@masterdata) { # start to open files
		chomp $category;
		open(FILE, "$boardsdir/$category.cat");
		&lock(FILE);
		@data = <FILE>;
		&unlock(FILE);
		close(FILE);
		$data[1] =~ s/\n//g;
		if($data[1] ne "") { #begin defining private forums
			if($settings[7] ne "Administrator" && $settings[7] ne "$data[1]") {
				next;
			} # end nested if
		} # end @datainfo if


		foreach $line (@data) {
		if($line ne "$data[0]" && $line ne "$data[1]") {
			chomp $line;
			open(FILE, "$boardsdir/$line.dat") || next;
			&lock(FILE);
			@newcatdata = <FILE>;
			&unlock(FILE);
			close(FILE);

			$selecthtml .= "<option value=\"$line\">$newcatdata[0]\n";	

		} # end main if (private boards)

		} # end second foreach

	} # end the main foreach
    
if ($numberreturned eq "") { $tempnumbox = "25"; }


$title = "$txt{'523'}";
&header;

print qq~

<table width=100%>
<tr>
	<td><font face="Verdana,Arial" size=2><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;<A href="$boardurl/YaBB.pl">$mbname</A><br><IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;$txt{'182'}</font></td>
</tr>
</table>

<table border=0 width=100% cellspacing=1 cellpadding=4 bgcolor="$color{'bordercolor'}">
<tr>
  <td bgcolor="$color{'titlebg'}"><font face="Verdana,Arial" size=1 color="$color{'titletext'}">$txt{'183'}</font></td>
</tr><tr><td bgcolor="$color{'windowbg'}">
<form action="$thisprogram" method="post">
<input type=text size=40 name=search><br>
<select name="dropdown">
<option value="startuser" selected>$txt{'186'}</option>
<option value="startpost">$txt{'187'}</option>
<option value="startwords">$better_search{'1'}</option>
</select><br>
<br>
<font face="Arial" size=2>
$txt{'189'}:<br></font>
<select name="catsearch"><option value="all">$txt{'190'} $selecthtml</select><br>
<br>
<font face="Arial" size=2>
$txt{'191'}<br></font>
<input type=text size=5 name=numberreturned value=$tempnumbox><br>
<br>
<input type=hidden name=action value=dosearch>
<input type="submit" name="submit" value="Search"><br>
</form>
</td></tr>
</table>
~;

&footer;

}

# ==== "Thread Started By" Routine ============================================

sub namesearch {
local($cattosearch) = @_;
	
	$test = $cattosearch;
	$mastercount = "0";
	if ($cattosearch eq "all") {
	
	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);
	foreach $curcat (@categories) {
		$curcat =~ s/\n//g;
		$curcat =~ s/\r//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/\n//g;
		$catinfo[1] =~ s/\r//g;
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && $settings[7] ne "$catinfo[1]") {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			chomp $curboard;
			($threadtitle, $trash) = split (/\./,$catinfo);
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
			open(FILE, "$boardsdir/$curboard.txt") || print "FATAL ERROR: $curboard.txt<br>";
#			open(FILE, "$boardsdir/$curboard.txt") || next;
			&lock(FILE);
			@newmessagedata = <FILE>;
			&unlock(FILE);
			close(FILE);
			open(FILE, "$boardsdir/$curboard.dat") || print "FATAL ERROR: $curboard.dat<br>";
			&lock(FILE);
			@currentboard = <FILE>;
			&unlock(FILE);
			close(FILE);

				foreach $line (@newmessagedata) { # start filtering
			
				($messagenumber, $messagetitle, $poster, $posteremail, $date, $trash, $trash, $trash, $trash, $post) = split(/\|/,$line);
					$poster =~ s/ //isg;
					if ($search eq $poster) {
					$snippet = substr($post, 0, 200);
					@threadtitle_var[$mastercount] = $curboard;
					@messagenumber_var[$mastercount] = $messagenumber;
					@messagetitle_var[$mastercount] = "$messagetitle";
					@poster_var[$mastercount] = $poster;
					@date_var[$mastercount] = $date;
					@counter[$mastercount] = $mastercount;
					@snippet_var[$mastercount] = $snippet;
					@catboard_var[$mastercount] = "$catinfo[0] / $currentboard[0]";
					$mastercount++;
					} # end poster match
				
				} # end filtering
			

			}
		}
	}

	} # end IF loop
	
	else {
	
		open(FILE, "$boardsdir/$cattosearch.txt") || &fatal_error("$txt{'23'} $cattosearch.txt");
		&lock(FILE);
		@newmessagedata = <FILE>;
		&unlock(FILE);
		close(FILE);
		open(FILE, "$boardsdir/$cattosearch.dat") || print "FATAL ERROR: $cattosearch.dat<br>";
		&lock(FILE);
		@currentboard = <FILE>;
		&unlock(FILE);
		close(FILE);
		
		($threadtitle, $trash) = split (/\./,$cattosearch);
		
			foreach $line (@newmessagedata) { # start filtering
		
			($messagenumber, $messagetitle, $poster, $posteremail, $date, $trash, $trash, $trash, $trash, $post) = split(/\|/,$line);
			$poster =~ s/ //isg;
			if ($search eq $poster) {
				$snippet = substr($post, 0, 200);
				@threadtitle_var[$mastercount] = $threadtitle;
				@messagenumber_var[$mastercount] = $messagenumber;
				@messagetitle_var[$mastercount] = $messagetitle;
				@poster_var[$mastercount] = $poster;
				@date_var[$mastercount] = $date;
				@snippet_var[$mastercount] = $snippet;
				@catboard_var[$mastercount] = "$currentboard[0]";
				$mastercount++;
				} # end poster match
				
			} # end filtering
			
	  } # end ELSE loop
		
	} # end name search routine

# ==== "Thread Posted In" Routine =============================================

sub namepostsearch {
	local($cattosearch) = @_;
	
	$test = $cattosearch;
	$mastercount = "0";
	if ($cattosearch eq "all") {
	
	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);
	foreach $curcat (@categories) {
		$curcat =~ s/\n//g;
		$curcat =~ s/\r//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/\n//g;
		$catinfo[1] =~ s/\r//g;
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && $settings[7] ne "$catinfo[1]") {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			chomp $curboard;
			($threadtitle, $trash) = split (/\./,$catinfo);
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
			open(FILE, "$boardsdir/$curboard.txt") || print "FATAL ERROR: $curboard.txt<br>";
#			open(FILE, "$boardsdir/$curboard.txt") || next;
			&lock(FILE);
			@newmessagedata = <FILE>;
			&unlock(FILE);
			close(FILE);
			open(FILE, "$boardsdir/$curboard.dat") || print "FATAL ERROR: $curboard.dat<br>";
			&lock(FILE);
			@currentboard = <FILE>;
			&unlock(FILE);
			close(FILE);
	
			foreach $line (@newmessagedata) { # start filtering
		
			($messagenumber, $trash, $threadstartedbyposter, $thrash, $trash, $trash, $trash, $trash, $trash, $trash) = split(/\|/,$line);
		
			open(FILE, "$datadir/$messagenumber.txt") || next;
			&lock(FILE);
			@postdata = <FILE>;
			&unlock(FILE);
			close(FILE);
			
				foreach $postline (@postdata) {
			
				($messagetitle, $poster, $posteremail, $date, $trash, $trash, $trash, $trash, $post) = split(/\|/,$postline);
						$poster =~ s/ //isg;
					if ($search eq $poster) {
						$snippet = substr($post, 0, 200);
						@threadtitle_var[$mastercount] = $curboard;
						@messagenumber_var[$mastercount] = $messagenumber;
						@messagetitle_var[$mastercount] = $messagetitle;
						@poster_var[$mastercount] = $poster;
						@date_var[$mastercount] = $date;
						@counter[$mastercount] = $mastercount;
						@snippet_var[$mastercount] = $snippet;
						@catboard_var[$mastercount] = "$catinfo[0] / $currentboard[0]";
						$mastercount++;
					} # end poster match
				
				} # end post text search
				
			} # end filtering
			} # end if($curboard
			
		} # end filter for names

	} # end category loop		
	} # end IF loop
	
else {

		open(FILE, "$boardsdir/$cattosearch.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
		&lock(FILE);
		@newmessagedata = <FILE>;
		&unlock(FILE);
		close(FILE);
		
		($threadtitle, $trash) = split (/\./,$cattosearch);
		
		foreach $line (@newmessagedata) { # start filtering
		
			($messagenumber, $trash, $threadstartedbyposter, $thrash, $trash, $trash, $trash, $trash, $trash, $trash) = split(/\|/,$line);
		
			open(FILE, "$datadir/$messagenumber.txt") || next;
			&lock(FILE);
			@postdata = <FILE>;
			&unlock(FILE);
			close(FILE);
			open(FILE, "$boardsdir/$cattosearch.dat") || print "FATAL ERROR: $cattosearch.dat<br>";
			&lock(FILE);
			@currentboard = <FILE>;
			&unlock(FILE);
			close(FILE);

				foreach $postline (@postdata) {
			
				($messagetitle, $poster, $posteremail, $date, $trash, $trash, $trash, $trash, $post) = split(/\|/,$postline);
				$poster =~ s/ //isg;
					if ($search eq $poster) {
						$snippet = substr($post, 0, 200);
						@threadtitle_var[$mastercount] = $threadtitle;
						@messagenumber_var[$mastercount] = $messagenumber;
						@messagetitle_var[$mastercount] = $messagetitle;
						@poster_var[$mastercount] = $poster;
						@date_var[$mastercount] = $date;
						@counter[$mastercount] = $mastercount;
						@snippet_var[$mastercount] = $snippet;
						@catboard_var[$mastercount] = "$currentboard[0]";
						$mastercount++;
					} # end poster match
				
				} # end post text search
				
			} # end filtering
		
	} # end ELSE loop	
	
} # end name post search routine

# ==== Keyword Routine ========================================================

sub keywordsearch {

	local($cattosearch) = @_;
	$test = $cattosearch;
	$mastercount = "0";
	if ($cattosearch eq "all") {
	
	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);
	@keywords = split (/,/,$search);
	foreach $curcat (@categories) {
		$curcat =~ s/\n//g;
		$curcat =~ s/\r//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/\n//g;
		$catinfo[1] =~ s/\r//g;
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && $settings[7] ne "$catinfo[1]") {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			chomp $curboard;
			($threadtitle, $trash) = split (/\./,$catinfo);
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
			open(FILE, "$boardsdir/$curboard.txt") || print "FATAL ERROR: $curboard.txt<br>";
#			open(FILE, "$boardsdir/$curboard.txt") || next;
			&lock(FILE);
			@newmessagedata = <FILE>;
			&unlock(FILE);
			close(FILE);
			open(FILE, "$boardsdir/$curboard.dat") || print "FATAL ERROR: $curboard.dat<br>";
			&lock(FILE);
			@currentboard = <FILE>;
			&unlock(FILE);
			close(FILE);

			foreach $line (@newmessagedata) { # start filtering
		
			($messagenumber, $trash, $threadstartedbyposter, $thrash, $trash, $trash, $trash, $trash, $trash, $trash) = split(/\|/,$line);
		
			open(FILE, "$datadir/$messagenumber.txt") || next;
			&lock(FILE);
			@postdata = <FILE>;
			&unlock(FILE);
			close(FILE);
			
				foreach $postline (@postdata) {
			
				($messagetitle, $poster, $posteremail, $date, $trash, $trash, $trash, $trash, $post) = split(/\|/,$postline);
			
					foreach $word (@keywords) {
						if (($post =~ /$word/gi || $messagetitle =~ /$word/gi) && ($word ne $threadstartedbyposter) && ($word ne $poster)) {
						$snippet = substr($post, 0, 200);
						@threadtitle_var[$mastercount] = $curboard;
						@messagenumber_var[$mastercount] = $messagenumber;
						@messagetitle_var[$mastercount] = $messagetitle;
						@poster_var[$mastercount] = $poster;
						@date_var[$mastercount] = $date;
						@counter[$mastercount] = $mastercount;
						@snippet_var[$mastercount] = $snippet;
						@foundword_var[$mastercount]= $word;
						@catboard_var[$mastercount] = "$catinfo[0] / $currentboard[0]";
						$mastercount++;
						} # end keyword match
				
					} # end @keywords foreach
				
				} # end post text search
				
			} # end filtering
			} # end if($curboard
			
		} # end filter for names
		
	} # end category loop
	} # end IF loop
	
else {

		open(FILE, "$boardsdir/$cattosearch.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
		&lock(FILE);
		@newmessagedata = <FILE>;
		&unlock(FILE);
		close(FILE);
		open(FILE, "$boardsdir/$cattosearch.dat") || print "FATAL ERROR: $cattosearch.dat<br>";
		&lock(FILE);
		@currentboard = <FILE>;
		&unlock(FILE);
		close(FILE);
		
		@keywords = split (/,/,$search);
		
		($threadtitle, $trash) = split (/\./,$cattosearch);
		
		foreach $line (@newmessagedata) { # start filtering
		
			($messagenumber, $trash, $threadstartedbyposter, $thrash, $trash, $trash, $trash, $trash, $trash, $trash) = split(/\|/,$line);
		
			open(FILE, "$datadir/$messagenumber.txt") || next;
			&lock(FILE);
			@postdata = <FILE>;
			&unlock(FILE);
			close(FILE);
			
				foreach $postline (@postdata) {
			
				($messagetitle, $poster, $posteremail, $date, $trash, $trash, $trash, $trash, $post) = split(/\|/,$postline);
			
					foreach $word (@keywords) {
						if (($post =~ /$word/gi || $messagetitle =~ /$word/gi) && ($word ne $threadstartedbyposter) && ($word ne $poster)) {
						$snippet = substr($post, 0, 200);
						@threadtitle_var[$mastercount] = $threadtitle;
						@messagenumber_var[$mastercount] = $messagenumber;
						@messagetitle_var[$mastercount] = $messagetitle;
						@poster_var[$mastercount] = $poster;
						@date_var[$mastercount] = $date;
						@counter[$mastercount] = $mastercount;
						@snippet_var[$mastercount] = $snippet;
						@foundword_var[$mastercount]= $word;
						@catboard_var[$mastercount] = "$currentboard[0]";
						$mastercount++;
						} # end keyword match
				
					} # end @keywords foreach
				
				} # end post text search
				
			} # end filtering
		
		} # end ELSE loop

} # End keywordsearch