<id>
MemberMap SP1/1.1
</id>

<version>
2.6
</version>

<mod info>

Instructions:

Apply the mod and upload (in ASCII mode):
YaBB.pl
english.lng
Sources/Admin.pl
Sources/AdminEdit.pl
Sources/Display.pl
Sources/Profile.pl
Sources/Register.pl
Sources/Subs.pl

Upload the MemberMap.pl file to your Sources folder.

Upload (in ASCII mode) to your Variables folder and chmod them to 666:
continent.txt
country.txt
state.txt

Upload (in Binary mode):
The .gif and .cur images to your Images folder.

Upload the flag folder with all the flags to your YaBBImages folder (in binary mode)


Description:

This mod let members mark their location on a Map and type 
City/Location and select State/Region and Country. The info is saved in the 
regular members.dat file and will appear in the members 
profile as City, State/Region, Country. Members and Admin can edit the 
map-entry from their Profile-view. Guests and
members can view the members location from Profile-view.
Everybody (Guests only if allowed) can view the total Member Map 
from the menu and open a members Profile by clicking on a Pin. 
Admin can add or remove Maps and Countries and re-order Maps from 
"Admin-center - Member Control - Setup Member Map". 
Admin can allow/disallow Guests to view Member Map, set View/hide 
headers in name-list, set sort by Name or Country in name-list from 
"Admin-center - Forum Preferences and Settings".
It also add a selection-box in Edit-Profile for members to 
select country.
Admin can make location required on registration from Admin-Center.
Admin can allow/disallow State/Region selection from Admin-Center.
Admin can allow/disallow gender-colored pins from Admin-Center.
Admin can set view/hide location in Posts as flag, text or both from Admin-Center.
If a member has "plotted" location on the Member Map the flag 
will link to the members map.

New Maps:

New Maps must be 550x430 pixels .gif format and should have a 
meaningfull name (use lowercase and underline for spaces 
ex.: new_zealand.gif). Upload your new map to your Images folder, 
and go to "Admin-center - Member Controls - Setup Member Map" and 
add the name of the Map without the .gif extention (use uppercase 
and underline for spaces ex.: New_Zealand).
In order to make room for the pins there must be at least 4 pixel
"no mans land" at the left and 10 pixel at the top of the map.

</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>

# MemberMap

$maptxt{'01'} = "Member Map";
$maptxt{'02'} = "Select Map";
$maptxt{'03'} = "Location";
$maptxt{'04'} = "Select Country";
$maptxt{'05'} = "Point and click on the map where you live.";
$maptxt{'06'} = " Save ";
$maptxt{'07'} = " View ";
$maptxt{'08'} = "Setup Member Map";
$maptxt{'09'} = "Maps (one per line)";
$maptxt{'10'} = "Countries (one per line)";
$maptxt{'11'} = "(Edit from View-Profile)";
$maptxt{'12'} = "Edit Member Map";
$maptxt{'13'} = "Allow Guests to view Member Map";
$maptxt{'14'} = "View location in Posts";
$maptxt{'15'} = "View index-headers in name list";
$maptxt{'16'} = "Sort name list by";
$maptxt{'17'} = "Name";
$maptxt{'18'} = "Country";
$maptxt{'19'} = "States (one per line)";
$maptxt{'20'} = "for States use - Initials,State<br>for Country-header use - xxx,Country";
$maptxt{'21'} = "Select State/Region (optional)";
$maptxt{'22'} = "Close";
$maptxt{'23'} = "Allow State/Region selection";
$maptxt{'24'} = "You should fill in a location.";
$maptxt{'25'} = "Location may only contain numbers and letters (example: 8900 Randers)";
$maptxt{'26'} = "You should select a country.";
$maptxt{'27'} = "Require location on registration";
$maptxt{'28'} = "Flag";
$maptxt{'29'} = "Text";
$maptxt{'30'} = "Show gender-color on Member Map";
$maptxt{'31'} = "Pin-color if gender-color un-selected";

</add after>

<search for>
	$img{'website_sm'} = qq~<img src="$imagesdir/www.gif" alt="$txt{'515'}" border="0">~;
</search for>

<add after>
	$img{'membermap'} = qq~<img src="$imagesdir/map.gif" alt="$maptxt{'01'}" border="0"> <font size="1" class="imgmenu">$maptxt{'01'}</font>~;
</add after>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'membermap'} = qq~<font size="1" class="imgwindowbg">$maptxt{'01'}</font>~;
</add after>


<edit file>
YaBB.pl
</edit file>

<search for>
		elsif ($action eq 'ml') { require "$sourcedir/Admin.pl"; &ml; }
</search for>

<add after>
		elsif ($action eq 'mmall') { require "$sourcedir/MemberMap.pl"; &MMall; }
		elsif ($action eq 'mmall2') { require "$sourcedir/MemberMap.pl"; &MMall2; }
		elsif ($action eq 'mmedit') { require "$sourcedir/MemberMap.pl"; &MMedit; }
		elsif ($action eq 'mmedit2') { require "$sourcedir/MemberMap.pl"; &MMedit2; }
</add after>

<search for>
	elsif ($action eq 'search2') { require "$sourcedir/Search.pl"; &plushSearch2; }
</search for>

<add after>
	elsif ($action eq 'setmembmap') { require "$sourcedir/AdminEdit.pl"; &SetMembermap; }
	elsif ($action eq 'setmembmap2') { require "$sourcedir/AdminEdit.pl"; &SetMembermap2; }
	elsif ($action eq 'setcountry2') { require "$sourcedir/AdminEdit.pl"; &SetCountry2; }
	elsif ($action eq 'setstate2') { require "$sourcedir/AdminEdit.pl"; &SetState2; }
</add after>


<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=setreserve">$txt{'207'}</a>
</search for>

<replace>
        - <a href="$cgi;action=setreserve">$txt{'207'}</a><BR>
        - <a href="$cgi;action=setmembmap">$maptxt{'08'}</a>
</replace>


<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub SetCensor {
</search for>

<add before>
sub SetMembermap {
	&is_admin;
	my(@lines, $cnmaps, $i);
	fopen(FILE, "$vardir/continent.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$cnmaps .= "$lines[$i]\n";
	}

	my(@lines, $countr, $i);
	fopen(FILE, "$vardir/country.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$countr .= "$lines[$i]\n";
	}

	my(@lines, $stat, $i);
	fopen(FILE, "$vardir/state.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$stat .= "$lines[$i]\n";
	}

	$yymain .= qq~
<table border="0" width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4">
  <tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/map.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$maptxt{'08'}</font></td>
  </tr>
<tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=setmembmap2" method="POST">
    <table align="center" border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="left"><font size=2><B>$maptxt{'09'}:</b></font></td>
	</tr><tr>
        <td align="center"><textarea name="maps" cols=30 rows=10>$cnmaps</textarea><BR>
        <input type=submit value="$txt{'10'}"></td>
      </tr>
    </table>
    </form>
    </td>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=setcountry2" method="POST">
    <table align="center" border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="left"><font size=2><B>$maptxt{'10'}:</b></font></td>
	</tr><tr>
        <td align="center"><textarea name="country" cols=30 rows=10>$countr</textarea><BR>
        <input type=submit value="$txt{'10'}"></td>
      </tr>
    </table>
    </form>
    </td>
  </tr>
  <tr>
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=setstate2" method="POST">
    <table align="center" border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="left">
          <font size=2><B>$maptxt{'19'}:</b></font><br>
          <font size=2>$maptxt{'20'}</font>
        </td>
	</tr><tr>
        <td align="center"><textarea name="states" cols=40 rows=10>$stat</textarea><BR>
        <input type=submit value="$txt{'10'}"></td>
      </tr>
    </table>
    </form>
    </td>
  </tr>
</table>
~;
	$yytitle = $maptxt{'08'};
	&template;
	exit;
}

sub SetMembermap2 {
	&is_admin;
	my $maps = $FORM{'maps'};
	while( $conts = each(%FORM) ) {
		$FORM{$conts} =~ tr/\n//d;
		$FORM{$conts} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/continent.txt", 1);
	print FILE "$maps";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetCountry2 {
	&is_admin;
	my $country = $FORM{'country'};
	while( $contr = each(%FORM) ) {
		$FORM{$contr} =~ tr/\n//d;
		$FORM{$contr} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/country.txt", 1);
	print FILE "$country";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetState2 {
	&is_admin;
	my $states = $FORM{'states'};
	while( $sstate = each(%FORM) ) {
		$FORM{$sstate} =~ tr/\n//d;
		$FORM{$sstate} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/state.txt", 1);
	print FILE "$states";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

</add before>


<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($smapguest_allow, $sview_flag, $sview_text, $sview_state, $smapsort_name, $smapsort_country, $smapsort_index, $sreq_location, $sview_mapgender);
	my($sred_pin, $sgreen_pin, $sblue_pin);
</add after>

<search for>
	if ($allowpics) { $allowpicschecked = "checked" }
</search for>

<add after>
	if ($view_state) { $sview_state = "checked" }
	if ($mapsort_index) { $smapsort_index = "checked" }
	if ($mapsort eq "name") { $smapsort_name = 'checked' } else { $smapsort_country = 'checked' }
	if ($mapguest_allow) { $smapguest_allow = "checked" }
	if ($view_flag) { $sview_flag = "checked" }
	if ($view_text) { $sview_text = "checked" }
	if ($req_location) { $sreq_location = "checked" }
	if ($view_mapgender) { $sview_mapgender = "checked" }
	if ($mappin eq "rpin") { $sred_pin = 'checked' } elsif ($mappin eq "gpin") { $sgreen_pin = 'checked' } else { $sblue_pin = 'checked' }
</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'591'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="godmem" size="5" value="$GodPostNum"></td>
</search for>

<add after>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/map.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>$maptxt{'01'}</b></font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'27'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="req_location" $sreq_location></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'23'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_state" $sview_state></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'15'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mapsort_index" $smapsort_index></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'16'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		<input type=radio name="mapsort" value="name" $smapsort_name><font size="2">$maptxt{'17'} &nbsp;</font>
		<input type=radio name="mapsort" value="country" $smapsort_country><font size="2">$maptxt{'18'}</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'13'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mapguest_allow" $smapguest_allow></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'14'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_flag" $sview_flag><font size="2">$maptxt{'28'} </font> <input type=checkbox name="view_text" $sview_text><font size="2">$maptxt{'29'}</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'30'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mapgender" $sview_mapgender></td>

  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'31'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		<input type=radio name="mappin" value="rpin" $sred_pin> <img src="$imagesdir/rpin.gif" alt="" border="0" align="absmiddle"> &nbsp;
		<input type=radio name="mappin" value="gpin" $sgreen_pin> <img src="$imagesdir/gpin.gif" alt="" border="0" align="absmiddle"> &nbsp;
		<input type=radio name="mappin" value="bpin" $sblue_pin> <img src="$imagesdir/bpin.gif" alt="" border="0" align="absmiddle"></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>MemberMap 2.6</I></b> &nbsp;</font></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
</add after>

<search for>
	# Set as 0 or 1 if box was checked or not
</search for>

<add before>
	push(@onoff, "view_state", "mapsort_index", "mapsort", "mapguest_allow", "view_flag", "view_text", "req_location", "view_mapgender", "rpin", "gpin", "bpin");
</add before>

<search for>
	$timeselected = $FORM{'timeselect'} || 0;
</search for>

<add after>
	$mapsort = $FORM{'mapsort'} || 'name';
	$mappin = $FORM{'mappin'} || 'rpin';
</add after>

<search for>
\$allow_hide_email = $allow_hide_email;			# Allow users to hide their email from public. Set 0 to disable
</search for>

<add after>
\$req_location = $req_location;	     			# Set to 1 to require location on registration
\$view_state = $view_state;		     			# Set to 0 to disallow State/Region selection in Member Map
\$mapsort_index = $mapsort_index;	     			# Set to 0 to hide index-headers in name-list in Member Map
\$mapsort = $mapsort;			     			# Set to country or name to sort name-list in Member Map by Country or Name
\$mapguest_allow = $mapguest_allow;	     			# Set to 0 to disallow guests to view Member Map
\$view_flag = $view_flag;		     			# Set to 0 to hide flags in Posts and Profile
\$view_text = $view_text;		     			# Set to 0 to hide location in Posts and Profile
\$view_mapgender = $view_mapgender;	     			# Set to 0 to hide location in Posts and Profile
\$mappin = $mappin;			     			# Set to rpin for red pins, gpin for green pins or bpin for blue pins on Member Map
</add after>


<edit file>
Sources/Display.pl
</edit file>

<search for>
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
</search for>

<add after>
			my($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispstate, $dispflag, $disptext);
</add after>

<search for>
			@userprofile = @{$userprofile{$musername}};
</search for>

<add after>
	($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispstate) = split(/\|/, $userprofile[15]);
	if($dispcountry ne "") {
		if($view_flag) {
			if($loccode eq "x1") { $dispflag = qq~<a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}#mmap"><img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0 align="absmiddle" alt="$dispcountry"></a>&nbsp;~; }
			elsif($loccode eq "x0") { $dispflag = qq~<img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0 align="absmiddle" alt="$dispcountry">&nbsp;~; }
			else { $dispflag = ""; }
		}
		if($view_text) {
			my($initstat, $namestat, $disploc);
			if($dispstate ne "") { ($initstat, $namestat) = split(/\,/, $dispstate); }
			if($displocal ne "") { $disploc = qq~$displocal $initstat~; }
			if($loccode eq "x1") { $disptext = qq~<nobr><font size="1"><a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}#mmap">$disploc</a></font></nobr>~; }
			elsif($loccode eq "x0") { $disptext = qq~<nobr><font size="1">$disploc</font></nobr>~; }
			else { $disptext = ""; }
		}
	}
</add after>

<search for>
	if($musername ne "Guest") {
		$yymain .= qq~
</search for>

<add after>
~;
	if($view_flag) {
	$yymain .= qq~
		$dispflag
~;
		if(!$view_text) {
		$yymain .= qq~
			<br>
	~;
		}
	}
	if($view_text) {
	$yymain .= qq~
		$disptext<br>
~;
	}
	$yymain .= qq~
</add after>


<edit file>
Sources/Profile.pl
</edit file>

<search for>
	else { $tsl1 = ' selected'; }
</search for>

<add after>
	my($maptest);
	if($memsettings[15] ne "") {
		$maptest = substr($memsettings[15],0,2);
	}
</add after>

<search for>
	<td width="320"><font size=2><b>$txt{'227'}: </b></font></td>
	<td><font size=2><input type="text" maxlength="30" name="location" size="50" value="$memsettings[15]"></font></td>
      </tr><tr>
</search for>

<replace>
~;
if($maptest eq "x0") {

	my($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate);
	($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate) = split(/\|/, $memsettings[15]);

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			if($curcountry eq $profcountry) { $selektet = ' selected' }
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}

	if($profcountry eq "") { $thisflag = "Noflag" }
	else { $thisflag = $profcountry }

	fopen(FILE, "$vardir/state.txt");
	@state = <FILE>;
	fclose(FILE);
	chomp @state;
	foreach $curstate (@state) {
		$curstate =~ s/ //gi;
		$curstate =~ s/\n//gi;
		$curstate =~ s/\r//gi;
		$selektet = "";
		($stateval, $stateopt) = split(/\,/, $curstate);
		if($profstate eq $curstate) { $selektet = ' selected' }
		$stateopt =~ s/\_/ /g;
		if($stateval eq "xxx") {
			$statopt .= qq~<option value="">\n~;
			$statopt .= qq~<option value="">$stateopt\n~;
			$statopt .= qq~<option value="">---------------\n~;
		}
		else { $statopt .= qq~<option value="$curstate"$selektet>$stateopt\n~; }
	}

	$yymain .= qq~
	<td width="320"><font size=2><b>$maptxt{'03'}: </b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24" value="$proflocal"></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td width="320"><font size=2><b>$maptxt{'21'}: </b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
	      </tr>
		~;
	}
	$yymain .= qq~
	<tr>
	<td width="320"><font size=2><b>$maptxt{'04'}: </b></font></td>
	<td>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>

	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border=0 hspace=15>
	<input type="hidden" name="kode" value="$loccode">

	<input type="hidden" name="contselect" value="$profcontin">
	<input type="hidden" name="xcoord" value="$profx">
	<input type="hidden" name="ycoord" value="$profy"></td>
      </tr><tr>
~;

}
elsif($maptest eq "x1") {
	my($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate, $initstate, $namestate, $viewloc);
	($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate) = split(/\|/, $memsettings[15]);
	$thiscountry = $profcountry;
	$thiscountry =~ s/\_/ /g;
	($initstate, $namestate) = split(/\,/, $profstate);
	my($prlocal, $inistate);
	if($proflocal ne "") { $prlocal .= qq~$proflocal,~; } else { $prlocal = ""; }
	if($initstate ne "") { $inistate .= qq~$initstate,~; } else { $inistate = ""; }
	$viewloc = qq~$prlocal $inistate $thiscountry~;

	$yymain .= qq~
	<td width="320"><font size=2><b>$txt{'227'}:</b> $maptxt{'11'}</font></td>
	<td><font size=2>$viewloc</font><img src="$imagesdir/flag/$profcountry.gif" border=0 hspace=15>
	<input type="hidden" name="kode" value="$loccode">
	<input type="hidden" name="cityloc" value="$proflocal">
	~;
	if($view_state) {
		$yymain .= qq~
		<input type="hidden" name="mapstate" value="$profstate">
		~;
	}
	$yymain .= qq~
	<input type="hidden" name="mapcountry" value="$profcountry">
	<input type="hidden" name="contselect" value="$profcontin">
	<input type="hidden" name="xcoord" value="$profx">
	<input type="hidden" name="ycoord" value="$profy"></td>
      </tr><tr>
~;
}
else {
	my($loccode, $profcontin, $profx, $profy, $profstate);

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}
	if($view_state) {
		fopen(FILE, "$vardir/state.txt");
		@state = <FILE>;
		fclose(FILE);
		chomp @state;
			foreach $curstate (@state) {
				$curstate =~ s/ //gi;
				$curstate =~ s/\n//gi;
				$curstate =~ s/\r//gi;
				($stateval, $stateopt) = split(/\,/, $curstate);
				$stateopt =~ s/\_/ /g;
				if($stateval eq "xxx") {
					$statopt .= qq~<option value="">\n~;
					$statopt .= qq~<option value="">$stateopt\n~;
					$statopt .= qq~<option value="">---------------\n~;
				}
				else { $statopt .= qq~<option value="$curstate">$stateopt\n~; }
			}
	}

	$thisflag = "Noflag";

	$yymain .= qq~
	<td width="320"><font size=2><b>$maptxt{'03'}: </b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24"></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td width="320"><font size=2><b>$maptxt{'21'}: </b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
      	</tr>
		~;
	}
	$yymain .= qq~

	<tr>
	<td width="320"><font size=2><b>$maptxt{'04'}: </b></font></td>
	<td>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>
	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border=0 hspace=15>
	<input type="hidden" name="kode" value="x0">

	<input type="hidden" name="contselect" value="$profcontin">
	<input type="hidden" name="xcoord" value="$profx">
	<input type="hidden" name="ycoord" value="$profy"></td>
      </tr><tr>
~;

}
	$yymain .= qq~
</replace>

<search for>
		&ToHTML($member{'location'});
</search for>

<replace>
		if($member{'mapcountry'} eq "Noflag") { $member{'mapcountry'} = "" }
		&ToHTML($member{'cityloc'});
		if($view_state) { &ToHTML($member{'mapstate'}); }
		&ToHTML($member{'mapcountry'});
		&ToHTML($member{'contselect'});
		&ToHTML($member{'xcoord'});
		&ToHTML($member{'ycoord'});
</replace>

<search for>
		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
</search for>

<add before>
if($member{'kode'} eq "x0" || $member{'kode'} eq "x1") {
	$memblocal = $member{'cityloc'};
	if($view_state) { $membstate = $member{'mapstate'} }
	else { $membstate = "" }
	$membcountry = $member{'mapcountry'};
	$membcontinent = $member{'contselect'};
	$membx = $member{'xcoord'};
	$memby = $member{'ycoord'};
	$loccode = $member{'kode'};
	$member{'location'} .= qq($loccode|$memblocal|$membcountry|$membcontinent|$membx|$memby|$membstate);
}
else {
	$member{'location'} = "x0";
}
</add before>

<search for>
	my($memberinfo, $modify, $email, $gender, $pic);
</search for>

<replace>
	my($memberinfo, $modify, $email, $gender, $pic, $modifyloc, $prolocal, $prostate, $procountry, $initstate, $namestate);
</replace>

<search for>
	&FormatUserName($INFO{'username'});
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
		$modify = qq~&#171; <a href="$cgi;action=profile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
	}
</search for>

<replace>
	&FormatUserName($INFO{'username'});
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
		$theuser = $INFO{'username'};
		$modify = qq~&#171; <a href="$cgi;action=profile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
		$modifyloc = qq~&#171; <a href=javascript:MapEditwin('$cgi&action=mmedit&username=$theuser')><font size=2 class="text1" color="$color{'titletext'}">$maptxt{'12'}</font></a> &#187;~;
		$modifyloc1 = qq~&#171; <a href=javascript:MapEditwin('$cgi&action=mmedit&username=$theuser')><font size=2>$maptxt{'12'}</font></a> &#187;~;
	}
</replace>


<search for>
      </tr><tr>
        <td><font size=2><b>$txt{'227'}: </b></font></td>
        <td><font size=2>$memsettings[15]</font></td>
      </tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font></td>
  </tr><tr height="25">
</search for>

<replace>
<script language="JavaScript1.2" type="text/javascript">
<!--
	function MapEditwin(FileName,WindowName) {
		WindowFeature="Resizable=No,ScrollBars=No,MenuBar=No,Directories=No,ToolBar=No,Location=No,Status=No,Width=762,Height=431,ScreenX=0,ScreenY=0,Top=0,Left=0"
		newWindow=open(FileName,WindowName,WindowFeature);
		if (newWindow.opener == null) { newWindow.opener = self; }
		if (newWindow.focus) { newWindow.focus(); }
	}
//-->
</script>
~;
if($view_mapgender) {
	if($memsettings[11] eq "Male") {
		$pin = "bpin";
	}
	elsif($memsettings[11] eq "Female") {
		$pin = "rpin";
	}
	else {
		$pin = "gpin";
	}
}
else {
	$pin = $mappin;
}

my($loccode, $memblocal, $membcountry, $membcontinent, $membx, $memby, $membstate, $initstate, $namestate, $viewmembname, $viewloc);
$membx = 0; $memby = 0; $membcontinent = "";
($loccode, $memblocal, $membcountry, $membcontinent, $membx, $memby, $membstate) = split(/\|/, $memsettings[15]);
($initstate, $namestate) = split(/\,/, $membstate);
my($prlocal, $inistate);
if($memblocal ne "") { $prlocal .= qq~$memblocal,~; } else { $prlocal = ""; }
if($initstate ne "") { $inistate .= qq~$initstate,~; } else { $inistate = ""; }

if($view_flag) {
	if($membcountry ne "") { $theflag = qq~<img src="$imagesdir/flag/$membcountry.gif" border="0" hspace="5" align="absmiddle">~; }
}
else { $theflag = ""; }

$thiscountry = $membcountry;
$thiscountry =~ s/\_/ /g;

if($loccode eq "x0" || $loccode eq "x1") {
	my($thislocal, $thisstate);
	if($memblocal ne "") { $thislocal .= qq~$memblocal,~; }
	else { $thislocal = ""; }
	if($initstate ne "") { $thisstate .= qq~$initstate,~; }
	else { $thisstate = ""; }
	$viewloc = qq~<font size=2>$thislocal $thisstate $thiscountry</font>$theflag~;
}
else { $viewloc = qq~<font size=2>&nbsp;</font>~; }

if($loccode eq "x1") {
$yymain .= qq~
      </tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font></td>
  </tr>
~;

if($membcontinent eq "") {
	fopen(FILE, "$vardir/continent.txt");
	@continent = <FILE>;
	fclose(FILE);
	foreach (@continent) { $_ =~ s~[\n\r]~~g; }
	$memcontinent = lc($continent[0]);
}
else {
	$memcontinent = lc($membcontinent);
}

$yymain .= qq~

<tr>
<td class="titlebg" colspan="2" bgcolor="$color{'titlebg'}">
    <table border="0" cellspacing="0" cellpadding="4" width="100%">
      <tr>
	<td align="left" width="25%">
        <a name="mmap"><font size="2" class="text1" color="$color{'titletext'}">$txt{'227'}:</font></a></td>
	<td align="left" width="45%">
        <font size=2 class="text1" color="$color{'titletext'}">$viewloc</font></td>
	<td align="center" width="30%">
        <font size=2 class="text1" color="$color{'titletext'}">$modifyloc</font></td>
      </tr>
    </table>
</td>
</tr><tr>
<td bgcolor="#F0F0F0" colspan="2" align="center">
<div id="map" style="position: relative; overflow: hidden; background-color: #F0F0F0; width: 550px; height: 430px; cursor: default;">
	<img src="$imagesdir/$memcontinent.gif" id="aktmap" name="mapview" width="550" height="430" style="position: relative; z-index: 0;" GALLERYIMG="no">
	<img src="$imagesdir/$pin.gif" id="memloc" style="z-index: 1; border: 0;">
</div>
</td>
</tr>

<script language="JavaScript1.2" type="text/javascript">

var useNS6 = document.getElementById && !document.all ? 1:0;

	document.images.mapview.src="$imagesdir/$memcontinent.gif";

	if (document.all) {
		document.all.map.style.cursor = "default";
		document.all.memloc.style.position = "absolute";
		document.all.memloc.style.top = $memby - 9;
		document.all.memloc.style.left = $membx - 3;
		document.all.memloc.style.visibility="visible";
	}
	if(useNS6) {
		document.getElementById("map").style.cursor = "default";
		document.getElementById("memloc").style.position = "absolute";
		document.getElementById("memloc").style.top = $memby - 9;
		document.getElementById("memloc").style.left = $membx - 3;
		document.getElementById("memloc").style.visibility = "visible";
	}

</script>
~;
}
else {
$yymain .= qq~
      </tr><tr>
        <td><font size=2><b>$txt{'227'}:</b></font></td>
        <td>$viewloc</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>$modifyloc1</td>
	</tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font></td>
  </tr>
~;
}
$yymain .= qq~
  <tr height="25">
</replace>


<edit file>
Sources/Register.pl
</edit file>

<search for>
        <td><font size=2><input type=password maxlength="30" name=passwrd2 size=30></font></td>
      </tr>
~;
}
</search for>

<add after>
if($req_location) {
	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}
	if($view_state) {
		fopen(FILE, "$vardir/state.txt");
		@state = <FILE>;
		fclose(FILE);
		chomp @state;
			foreach $curstate (@state) {
				$curstate =~ s/ //gi;
				$curstate =~ s/\n//gi;
				$curstate =~ s/\r//gi;
				($stateval, $stateopt) = split(/\,/, $curstate);
				$stateopt =~ s/\_/ /g;
				if($stateval eq "xxx") {
					$statopt .= qq~<option value="">\n~;
					$statopt .= qq~<option value="">$stateopt\n~;
					$statopt .= qq~<option value="">---------------\n~;
				}
				else { $statopt .= qq~<option value="$curstate">$stateopt\n~; }
			}
	}

	$thisflag = "Noflag";

	$yymain .= qq~
	<tr><td><font size=2>* <b>$maptxt{'03'}:</b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24"></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td><font size=2><b>$maptxt{'21'}:</b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
      	</tr>
		~;
	}
	$yymain .= qq~

	<tr>
	<td><font size=2>* <b>$maptxt{'04'}:</b></font></td>
	<td>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>
	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border=0 hspace=15>
      </tr>
~;
}
</add after>

<search for>
	&fatal_error("($member{'username'}) $txt{'76'}") if($member{'email'} eq "");
	&fatal_error("($member{'username'}) $txt{'100'}") if(-e ("$memberdir/$member{'username'}.dat"));
</search for>

<add after>
if($req_location) {
	&fatal_error("($member{'username'}) $maptxt{'24'}") if($member{'cityloc'} eq '');
	&fatal_error("($member{'username'}) $maptxt{'25'}") if($member{'cityloc'} eq '_' || $member{'cityloc'} eq '|');
	&fatal_error("$txt{'240'} $maptxt{'03'} $txt{'241'}") if($member{'cityloc'} !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);
	&fatal_error("($member{'username'}) $maptxt{'26'}") if($member{'mapcountry'} eq '');
}
</add after>

<search for>
	print FILE "\n\n\n0\n\n\n\n\n\n$txt{'209'}\nblank.gif\n$date\n\n\n\n\n";
</search for>

<replace>
if($req_location) {
	$memblocal = $member{'cityloc'};
	if($view_state) { $membstate = $member{'mapstate'} }
	else { $membstate = "" }
	$membcountry = $member{'mapcountry'};
	$membcontinent = "";
	$membx = 0;
	$memby = 0;
	$loccode = "x0";
	$member{'location'} .= qq($loccode|$memblocal|$membcountry|$membcontinent|$membx|$memby|$membstate);
	print FILE "\n\n\n0\n\n\n\n\n\n$txt{'209'}\nblank.gif\n$date\n";
	print FILE "$member{'location'}\n\n\n\n";
}
else {
	print FILE "\n\n\n0\n\n\n\n\n\n$txt{'209'}\nblank.gif\n$date\n\n\n\n\n";
}
</replace>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";
</search for>

<add before>
fopen(FILE, "$vardir/continent.txt");
@continent = <FILE>;
fclose(FILE);
chomp @continent;
$defaultmap = $continent[0];
$defaultmap = lc($defaultmap);
</add before>

<search for>
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
</search for>

<add before>
		$yymenu .= qq~$menusep<a href="$cgi;action=mmall;defmap=$defaultmap">$img{'membermap'}</a>~;
</add before>
