<id>
attach_move_bugfix
</id>

<version>
1.0
</version>

<mod info>
Fixes a bug in file_attachment.mod (upto V2.3)

If a message with an attachment is moved to another board, the file will also be attached to the "Moved: the subject" message. If this message is deleted later, also the attached file will be deleted - and will therefor be not available for the original message, i.e. is lost.

This bugfix deletes the link to the attachment in the 'Moved: the subject" message.

</mod info>

<author>
Boris Cornet
</author>

<homepage>

</homepage>

<edit file>
SOURCES/MoveThread.pl
</edit file>

<search for>
	$movedpost = join("|", @movedthread);

</search for>

<replace>

	if ($movedthread[12] ne "") {
		#fix attachment info
		fopen(AMP, "$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		my @attachinfo = <AMP>;
		fclose(AMP);
		foreach (@attachinfo) {
			$row = $_;
			chomp $row;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$row);
			if ($amfn eq $movedthread[13]) { 
				$_ = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$toboard|$amkb|$amdate|$amfn\n~;
				last;
			}
		}
		fopen(AMP, ">$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
		print AMP @attachinfo;
		fclose(AMP);

		#remove attachment from old post
		$movedthread[12] = "";
		$movedthread[13] = "";
	}

	$movedpost = join("|", @movedthread);

</replace>