<id>
More Board and Category Options SP1.1 Polls Patch
</id>

<version>
2.0
</version>

<mod info>
The mod gives you a new link on the admin-Center - "More Options for Boards/Categories", which allows you to:
	1. Password protect boards
	2. Set an icon for every board/category which will be displayed on the BoardIndex
	3. Define which membergroups/users are allowed to start topics, post replies, and view topics for each board of your forum.

	This patch extends these options to include which membergroups/users are allowed to start polls on each board


Instructions:
	Only apply this patch if you have BOTH Polls (version 2.0 or higher) and More Board and Category Options (version 2.0 or higher) installed.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

###############################################################################

<edit file>
english.lng
</edit file>

<search for>
$mbco{'32'} = "If this option is selected, boards that are unable to be viewed by users will still be shown on boardindex but not allowed to be entered.";
</search for>

<add after>
$mbco{'33'} = "who can start polls:";
$mbco{'34'} = "Specify which Users can start polls in this board";
$mbco{'35'} = "Specify which Membergroups can start polls in this board";
</add after>

###############################################################################

<edit file>
Sources/MBCoptions.pl
</edit file>

<search for>
          <td width="60%" valign="top"><font size="2"><b>$mbco{'16'} $mbco{'17'}</b></font><br><font size="1">$mbco{'27'}</font></td>
          <td width="40%" valign="middle" align="right"><input type="text" name="stallowedgroups" value="$start_groups{$currentboard}" size="40"></td>
        </tr><tr>
</search for>

<add after>
          <td width="60%" valign="top"><font size="2"><b>$txt{'142'} $mbco{'33'}</b></font><br><font size="1">$mbco{'34'}</font></td>
          <td width="40%" valign="middle" align="right"><input type="text" name="pusers" value="$poll_users{$currentboard}" size="40"></td>
        </tr><tr>
          <td width="60%" valign="top"><font size="2"><b>$mbco{'16'} $mbco{'33'}</b></font><br><font size="1">$mbco{'35'}</font></td>
          <td width="40%" valign="middle" align="right"><input type="text" name="pgroups" value="$poll_groups{$currentboard}" size="40"></td>
       </tr><tr>
</add after>

<search for>
		$start_users{$currentboard} = $FORM{"stdusers"};
</search for>

<add after>
		$poll_groups{$currentboard} = $FORM{'pgroups'};
		$poll_users{$currentboard} = $FORM{"pusers"};
</add after>


<search for>
			print FILE qq~\$start_groups{'$currentboard'} = "$start_groups{$currentboard}";\n~;
			print FILE qq~\$start_users{'$currentboard'} = "$start_users{$currentboard}";\n~;
</search for>

<add after>
			print FILE qq~\$poll_groups{'$currentboard'} = "$poll_groups{$currentboard}";\n~;
			print FILE qq~\$poll_users{'$currentboard'} = "$poll_users{$currentboard}";\n~;
</add after>

###############################################################################

<edit file>
Sources/Load.pl
</edit file>

<search for>
			if ($action eq "post") { $accesstype = $INFO{'num'} ? 2 : 1; }
</search for>

<replace>
			if ($action eq "post") {
				if ($INFO{'title'} eq $polltxt{'1'} || $INFO{'title'} eq $polltxt{'3'}) { $accesstype = 3; } # Post Poll
				elsif ($INFO{'num'}) { $accesstype = 2; } # Post Reply
				else { $accesstype = 1; } # Post Thread
			}
</replace>

###############################################################################

<edit file>
Sources/Security.pl
</edit file>

<search for>
	} elsif ($checktype == 2){ # Reply access check
		@allowed_users = split(/,/,$reply_users{$curboard});
		@allowed_groups = split(/,/,$reply_groups{$curboard});
		if ($reply_users{$curboard} eq "" && $reply_groups{$curboard} eq "") {$access = "granted";}  
</search for>

<add after>
	} elsif ($checktype == 3){ # Poll access check
		@allowed_users = split(/,/,$poll_users{$curboard});
		@allowed_groups = split(/,/,$poll_groups{$curboard});
		if ($poll_users{$curboard} eq "" && $poll_groups{$curboard} eq "") {$access = "granted";}  
</add after>