<id>
NewcalendarSP1
</id>

<version>
3.51
</version>

<mod info>
Features:

Works with YaBB SP1 and SP 1.1

The mod provides a month view calendar with event names appearing on 
the date they occur.  Clicking on events opens details for viewing.

Optionally, member birthdays are added to the calendar and Info Center.
Clicking on a member's name opens the profile page for that member.

Upcoming events and birthdays appear in the Info Center.  Clicking on
events in the Info Center opens event details.

All members may add/modify/delete their own events.  Admins and Calendar Moderators may edit/delete
all events.  Guests may add/edit/delete guest events if guest event posting
is enabled in Newcalendar Settings in the Admin Center.

Optionally, posting events may be limited to Admin and Calendar Moderators
with viewing by all users.

If activated, the calendar may be limited to viewing by specified member groups
by unchecking box in Newcalendar Settings in the Admin Center and entering
the member group names.

UBBC tags are allowed in event names and descriptions.

Supports multiday events and recurring events (weekly, monthly, yearly, and
"3rd Tuesday on Month").

Upcoming Events can be added to any HTML page on the host server.

First day of week can be Sunday or Monday.

Date formats "Friday, November 15, 2002" or "Friday 15. November 2002".

Full and new moon can be displayed on main calendar.

Optionally, daily moon phases can be shown in Info Center
in place of regular calendar icon and on Who's on and SSI pages.

Optionally, users may send event notices via email.

Users may search calendar events.

Optional YaBB FrontEnd(whoson) mod addon.

Calendar compatible with Media Player mod version 1.1+.

See readme3_51.txt for installation instructions.

See NewcalendarHelp.html for use instructions and more detailed installation instructions.

-------------------------------------------------------------------------
Authors: Ironwing, GauGau, & Nermware

Author homepages:
http://www.mineralarts.com/cgi/yabbsp1/YaBB.pl (for Ironwing, direct questions to Ironwing)
http://gaugau.de/  (GauGau)
http://www.nermware.com (Nermware)
--------------------------------------------------------------------------
Installation

See readme3_51.txt file.

-------------------------------------------------------------------------------
</mod info>

<author>
Ironwing
</author>

<homepage>
http://www.mineralarts.com/cgi/yabbsp1/YaBB.pl
</homepage>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
</search for>

<add before>
	chomp $newcalgroup;
	@newcalgrouplist = split(",",$newcalgroup);
	$newcalgroupflag = 0;
	foreach $newcalgroupitem (@newcalgrouplist) {
		if ($settings[7] eq $newcalgroupitem) { $newcalgroupflag = 1; }
	}
	if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $newcalgroupflag == 1 ) {
		$yymenu .= qq~$menusep<a href="$cgi;action=newcalendar">$img{'newcalendar'}</a>~;
	}
</add before>


<edit file>
YaBB.pl
</edit file>

<search for>
require "$sourcedir/Security.pl";
</search for>

<add after>
if (!-e("$vardir/eventcal.txt"))  {
fopen(FILE, ">>$vardir/eventcal.txt");
print FILE "1;";
fclose(FILE);
}
require "$vardir/eventcal.txt";
</add after>

<search for>
	elsif ($action eq 'ipban2') { require "$sourcedir/Admin.pl"; &ipban2; }
</search for>
<add after>
	elsif ($action eq 'includecal') { require "$sourcedir/Newcalendar.pl"; &IncludeCal; }
</add after>

<search for>
	elsif ($action eq 'notify4') { require "$sourcedir/Notify.pl"; &Notify4; }
</search for>
<add after>
	elsif ($action eq 'newcalendar') { require "$sourcedir/Newcalendar.pl"; &CalMain; }
	elsif ($action eq 'newcalset') { require "$sourcedir/Newcalendar.pl"; &CalSettings; }
	elsif ($action eq 'newcalset2') { require "$sourcedir/Newcalendar.pl"; &CalSettings2; }	
	elsif ($action eq 'newcalsearch2') { require "$sourcedir/Newcalendar.pl"; &NewCalSearch2; }
</add after>

<search for>
	elsif ($action eq 'sendtopic2') { require "$sourcedir/SendTopic.pl"; &SendTopic2; }
</search for>
<add after>
	elsif ($action eq 'sendevent') { require "$sourcedir/SendEvent.pl"; &SendEvent; }
	elsif ($action eq 'sendevent2') { require "$sourcedir/SendEvent.pl"; &SendEvent2; }
	elsif ($action eq 'newcalsearch2') { require "$sourcedir/Newcalendar.pl"; &NewCalSearch2; }
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>

$ecaltxt{'01'} = "January";
$ecaltxt{'02'} = "February";
$ecaltxt{'03'} = "March";
$ecaltxt{'04'} = "April";
$ecaltxt{'05'} = "May";
$ecaltxt{'06'} = "June";
$ecaltxt{'07'} = "July";
$ecaltxt{'08'} = "August";
$ecaltxt{'09'} = "September";
$ecaltxt{'10'} = "October";
$ecaltxt{'11'} = "November";
$ecaltxt{'12'} = "December";
$ecaltxt{'13'} = "Sunday";
$ecaltxt{'14'} = "Monday";
$ecaltxt{'15'} = "Tuesday";
$ecaltxt{'16'} = "Wednesday";
$ecaltxt{'17'} = "Thursday";
$ecaltxt{'18'} = "Friday";
$ecaltxt{'19'} = "Saturday";
$ecaltxt{'20'} = "PREV";
$ecaltxt{'21'} = "NEXT";
$ecaltxt{'22'} = "RETURN";
$ecaltxt{'23'} = "Return to the "; 
$ecaltxt{'24'} = "To view an event, click on the event.";
$ecaltxt{'25'} = "Members may add/modify/delete their own events by clicking on the date.";
$ecaltxt{'26'} = "Select the Month";
$ecaltxt{'27'} = "Select the Year";
$ecaltxt{'28'} = "Now View It";
$ecaltxt{'29'} = "View Calendar";
$ecaltxt{'30'} = "Back";
$ecaltxt{'31'} = "Name:";
$ecaltxt{'32'} = "Enter the name of the event (up to 18 letters).  This is what is displayed on the calendar view.";
$ecaltxt{'33'} = "Type of Event:";
$ecaltxt{'34'} = "Select a subject from the menu.";
$ecaltxt{'35'} = "Description:";
$ecaltxt{'36'} = "Enter a description of the event (location, time, etc.).<br>UBBC tags can be added to the descriptions.";
$ecaltxt{'37'} = "Repeat for:";
$ecaltxt{'38'} = "For multiday events, enter number of days.<br>For weekly, monthly, or yearly events, enter number of weeks, months, or years to repeat.<br>Note that the calendar uses dates, not <i>Third Sunday</i> to set recurring events.";
$ecaltxt{'39'} = "Daily";
$ecaltxt{'40'} = "Select Daily, Weekly, Monthly, or Yearly for multiday or recurring events.";
$ecaltxt{'41'} = "Entry #";
$ecaltxt{'42'} = " for ";
$ecaltxt{'43'} = "Day";
$ecaltxt{'44'} = "Week";
$ecaltxt{'45'} = "Month";
$ecaltxt{'46'} = "Year";
$ecaltxt{'46a'} = "3rdTues";
$ecaltxt{'47'} = "Delete Entry #";
$ecaltxt{'48'} = "Add or Change Entry #";
$ecaltxt{'49'} = "Notices for ";
$ecaltxt{'50'} = "Type:";
$ecaltxt{'51'} = " adapted for YaBB by ";
$ecaltxt{'52'} = "Calendar";
$ecaltxt{'53'} = "How To Use";
$ecaltxt{'54'} = "Entered By:";
$ecaltxt{'55'} = "Upcoming Events";
$ecaltxt{'56'} = "Birthdays: ";
$ecaltxt{'57'} = "Birthday: ";
$ecaltxt{'58'} = "Based on ";
$ecaltxt{'59'} = " by NermWare";
$ecaltxt{'60'} = "Newcalendar Settings";
$ecaltxt{'61'} = "You may customize calendar options here. Click Save when finished.";
$ecaltxt{'62'} = "Calendar Window Title";
$ecaltxt{'63'} = "Calendar Title";
$ecaltxt{'64'} = "Type of Event Pick List Options";
$ecaltxt{'65'} = "Default Event Type (from list above)";
$ecaltxt{'66'} = "View Event Page Window Title";
$ecaltxt{'67'} = "View Event Page Title";
$ecaltxt{'68'} = "Edit Event Page Window Title";
$ecaltxt{'69'} = "Edit Event Page Title";
$ecaltxt{'70'} = "Time offset from GMT (in minutes, positive for west of GTM)";
$ecaltxt{'71'} = "Limit Calendar Access?<br>Checked - visible to all<br>Unchecked - only to Admins & Newcal Group";
$ecaltxt{'72'} = "Newcal Group:";
$ecaltxt{'73'} = "No Upcoming Events";
$ecaltxt{'74'} = "Date Format:<br>Uncheck for 12/31/2002<br>Check for 31/12/2002";
$ecaltxt{'75'} = "Maximum number of events per day<br>(must be 1 or greater)";
$ecaltxt{'76'} = "First day of week<br>Unchecked - Sunday<br>Checked - Monday";
$ecaltxt{'77'} = "New Moon";
$ecaltxt{'78'} = "Full Moon";
$ecaltxt{'79'} = "Moon Phases on Main Calendar:<br>Checked - on, Unchecked - off";
$ecaltxt{'80'} = "Guest Event Posting:<br>Checked - on, Unchecked - off";
$ecaltxt{'81'} = "Moon Phases on BoardIndex, Who's on, and SSI:<br> Checked - on, Unchecked - off";
$ecaltxt{'82'} = "Show birthdays on calendar:<br>Checked - on, Unchecked - off";
$ecaltxt{'83'} = "Event";
$ecaltxt{'84'} = "I want you to check out the following event notice on the";
$ecaltxt{'85'} = "Date of Event";
$ecaltxt{'86'} = "Send Event to a Friend";
$ecaltxt{'87'} = "To view details, please click the link below";
$ecaltxt{'88'} = "Allow event notices via email:<br>Checked - on, Unchecked - off";
$ecaltxt{'89'} = "Search Calendar Events";
$ecaltxt{'90'} = "Event Name";
$ecaltxt{'91'} = "Event Description";
$ecaltxt{'92'} = "No matching events found.<br>Please modify your search and try again.";
$ecaltxt{'93'} = "Limit event posting to Admins and Calendar Moderators only?";
$ecaltxt{'94'} = "Display events for how many days?<br><I>For BoardIndex, SSI, and Whoson<br>(must be 1 or greater)</I>";
$ecaltxt{'95'} = "Calendar Moderators:";
$ecaltxt{'96'} = "Calendar Help";
$ecaltxt{'97'} = "Show Calendar Help Link?";

</add after>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'newcalendar'} = qq~<font size="1" class="imgmenu">$ecaltxt{'52'}</font>~;
</add after>

<search for>
	$img{'website_sm'} = qq~<img src="$imagesdir/www.gif" alt="$txt{'515'}" border="0">~;
</search for>

<add after>
	$img{'newcalendar'} = qq~<img src="$imagesdir/newcal.gif" alt="$ecaltxt{'52'}" border="0"> <font size="1" class="imgmenu">$ecaltxt{'52'}</font>~;
</add after>


<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
            $guests $txt{'141'}, $numusers $txt{'142'}<BR>$users
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
</search for>

<add after>
########### Newcalendar mod start #######################
	chomp $newcalgroup;
	@newcalgrouplist = split(",",$newcalgroup);
	$newcalgroupflag = 0;
	foreach $newcalgroupitem (@newcalgrouplist) {
		if ($settings[7] eq $newcalgroupitem) { $newcalgroupflag = 1; }
	}
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $newcalgroupflag ==1 ) {
	if ($newcalmoon2 == 1) {
		require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;

		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$moonpict = qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$moonpict = qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$moonpict = qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	} else {
		$moonpict = qq~<img src="$imagesdir/newcal.gif" alt="" border="0">~;
	}
	$yymain .=qq~
       <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$ecaltxt{'55'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><a href="$cgi;action=newcalendar">$moonpict</a></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
require "$sourcedir/Newcalendar.pl";
&IndexCal;
$yymain .=qq~  
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########### Newcalendar mod end #######################
</add after>


<edit file>
template.html
</edit file>

<search for>
-->
</style>
</search for>

<add before>
.newcal1 {background-color: #D9F7FF; font-size: 14px} /* Background on Prev and Next Buttons, Name and Entered By on Notice Page, Name on Event Entry Page */
.newcal5 {background-color: #D9F7FF} /*  Select the Month, Year, View It Now text on main page, */
.newcal13 {font-size:30px; font-weight:bold} /*Main page Month name */
.newcal16 {color: black;font-size: 36px} /*Name of Calendar on main page*/
.newcal2 {background-color: #D9F7FF} /* Type of Event text on View Event and Edit Event Pages*/
.newcal3 {background-color: #FFFFDD} /* Description of Event text on View Event, Search Results, and Edit Event Pages*/
.newcal6 {background-color: #FCFFD1;font-weight:bold} /* Weekdays on Main Calendar Page*/
.newcal7 {background-color: #CFE6FB} /* Background color of month view*/
.newcal15 {color: blue;font-size: 24px} /*Dates on Main Calendar */
.newcal14 {color: #000080;font-size: 24px; font-weight:bold} /*Actual date on Main Calendar and Heading on Search Results Page*/
.newcal19 {color: black;font-size: 10px} /* Instructions on Edit Event Page*/
.newcal20 {color: black;font-size: 12px} /* Instructions Heading on Edit Event Page*/
.newcal8 {background-color: #F8F8F8} /*Repeat For text on Edit Event Page */
.newcal10 {background-color: #F8F8F8} /*Entered By text on Edit Event Page */
.newcal11 {background-color: #F8F8F8} /*Background color for Add Event button area on Edit Event Page*/
.newcal17 {color: black;font-size: 10px} /* Event Names on Main Calendar, Comment "click on event..." on Main Calendar */
.newcal18 {color: black;font-size: 12px} /* Entry Number and Date text on Edit Event Page */
.newcal4 {background-color: white} /* Horizontal line on View Events and Search Results Pages*/
.newcal9 {background-color: #F8F8F8} /* Background behind Delete Button on Edit Events Page  */
.newcal12 {color: black;font-size: 12px} /* Button Text on Prev and Next Buttons*/
.newcal21 {font-size: 14px} /* Search Text on Main Calendar*/
.newcal22 {font-size: 16px} /* Return to Forum Text on Main Calendar*/
.newcal23 {color: black;font-size: 10px} /* Credits Text*/
</add before>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=modagreement">$txt{'764'}</a><br>
</search for>

<add after>
        - <a href="$cgi;action=newcalset">$ecaltxt{'60'}</a><br>
</add after>
