#################################################
#Newcalendar for SP1 mod by Ironwing and GauGau.#
#Based on Event Calendar by Nermware		#
#Support: boardmod.yabbforums.com			#
#Version 3.51 				      	#
#################################################
$Newcalendarplver = 'NewcalendarSP1 3.51 for SP1';
# CalMain is the main calendar routine, called by YaBB
sub CalMain {
	$rev = "1.3.1";					#This is the Nermware calendar ver num, must not change
	require "$vardir/eventcal.txt";		#This is the settings file
	@sbjlist = split(" ",$sbjlist);
	$yytitle = $calpagetitle;
	$dbfile = "$vardir/eventcaldb";		#This is the database file
	$origcom = qq~$ecaltxt{'58'}eventcalendar.pl v$rev$ecaltxt{'59'}~;# Nermware credit must remain
	$adaptcom = 'Ironwing';
	use Time::Local;
	use CGI;
	$webpage_obj = new CGI;
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	if($acttype =~ /display/) {
		CalBDay2();
		DisCalendar();
		DisCalForm();
	}
	EnterData() if($acttype =~ /enterdata/);
	ViewData() if($acttype =~ /viewdata/);
	NewCalSearch() if($acttype =~ /search/);
	if(($acttype =~ /newdata/) || ($acttype =~ /deldata/)) {
		NewData();
		$acttype = display;
		GetDbData();
		if ($addbdays == 1) { 
			CalBDay2();
		}
		DisCalendar();
		DisCalForm();
	}
	SendTrailer();
	&template;
	exit;
}
# GetActType determines type of action selected by user
# called by CalMain sub and IndexCal sub
sub GetActType {
	my($type) = "display";
	$type = $webpage_obj->param('acttype') if(defined($webpage_obj->param('acttype')));
	$type = newdata if(defined($webpage_obj->param('newdata')));
	$type = deldata if(defined($webpage_obj->param('deldata')));
	return('display') if ($type =~ /display/);
	return('enterdata') if ($type =~ /enterdata/);
	return('viewdata') if($type =~/viewdata/);
	return('newdata') if($type =~/newdata/);
	return('deldata') if($type =~/deldata/);
	return('search') if($type =~/search/);
	return('badtype');
}
# GetSelDate determines current time/date or selected time/date to display
# called by CalMain sub and IndexCal sub
sub GetSelDate {
	(my($selmonth),my($selday),my($selyear)) = (localtime(time + (3600*($timeoffset + $settings[18]))))[4,3,5];
	$selyear = $selyear+1900;
	$selmonth = $webpage_obj->param('selmonth') if (defined($webpage_obj->param('selmonth')));
	$selday = $webpage_obj->param('selday') if (defined($webpage_obj->param('selday')));
	$selyear = $webpage_obj->param('selyear') if (defined($webpage_obj->param('selyear')));
	return($selmonth,$selday,$selyear);
}
# GetDbData gets event data from database and builds recurring event data,
# called by CalMain sub and IndexCal sub
sub GetDbData {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	my($selmonfst) = timegm(0,0,0,1,$thismonth,$thisyear);
#	my($nextmonth) = $thismonth+1;
	my($nextmonth) = $thismonth+2;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($nxtmonfst) = timegm(0,0,0,1,$nextmonth,$nextyear);
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,$dbfile);
	while ($strline=<DBFILE>) {
		chop($strline);
		@line = split(/\|/,$strline);
		my($index) = shift(@line);
		$dayinfo{$index} = [ @line ] if($index < $nxtmonfst);
	}
	fclose(DBFILE);
	return if(($acttype !~ /display/) && ($acttype !~ /viewdata/));
	my($daysecs) = 24*60*60;
	my($weeksecs) = 168*60*60;
	my(@dayinfokeys) = keys(%dayinfo);
	foreach $index (@dayinfokeys) {
		my($element) = "";
		my(@entry) = ();
		foreach $element (@{ $dayinfo{$index} }) {
			my(@entry) = split('{',$element);
			my($repeatfor) = $entry[$#entry];
			if($repeatfor > 1) {
				my($newindex) = $index;
				$addsecs = $daysecs if($entry[$#entry-1] =~ /$ecaltxt{'43'}/);
				$addsecs = $weeksecs if($entry[$#entry-1] =~ /$ecaltxt{'44'}/);
				if(($entry[$#entry-1] =~ /$ecaltxt{'43'}/) || ($entry[$#entry-1] =~ /$ecaltxt{'44'}/)) {
					for($i=2;$i<=$repeatfor;$i++) {
						$newindex = $newindex + $addsecs;
						$entry[$#entry] = 0;
						${$dayinfo{$newindex}}[++$#{$dayinfo{$newindex}}] = join('{',@entry) if(($newindex < $nxtmonfst) && ($newindex >= $selmonfst));
					}
					next;
				}
				my($addyears) = my($addmonths) = 0;
				$addyears = 1 if($entry[$#entry-1] =~ /$ecaltxt{'46'}/);
				$addmonths = 1 if($entry[$#entry-1] =~ /$ecaltxt{'45'}/);

				my(@thisdate) = gmtime($index);
### added for holder
				$addmonths = 1 if($entry[$#entry-1] =~ /$ecaltxt{'46a'}/);
# find day of week of this event
				my ($dayofweek) = $thisdate[6];
# find week of month of this event
				my ($weekofmonth) = int( ($thisdate[3] - 1) / 7 );
###
				splice(@thisdate,-1,3);
				for($i=2;$i<=$entry[$#entry];$i++) {
					$thisdate[4] = $thisdate[4] + $addmonths;
					$thisdate[5] = $thisdate[5] + $addyears;
					if($thisdate[4] > 11) {
						$thisdate[4]=0;
						$thisdate[5]++;
					}
### added for holder
# find day of week of first day of new month
					$tstring = timegm(0,0,0,1,$thisdate[4],$thisdate[5]);
					my (@newmonth1st) = gmtime($tstring);
					my ($wdaynewmonth1st) = $newmonth1st[6];
# calculate new month day
					if ( $entry[$#entry-1] =~ /$ecaltxt{'46a'}/ ) {
						if ( $wdaynewmonth1st <= $dayofweek ) {
							$thisdate[3] = ( $weekofmonth * 7 ) + 1 + $dayofweek - $wdaynewmonth1st;
						} else {
							$thisdate[3] = ( $weekofmonth * 7 ) + 8 + $dayofweek - $wdaynewmonth1st;
						}
					}
###
					$newindex = timegm(@thisdate);
### Test if new date is in same month
					if ( $entry[$#entry-1] =~ /$ecaltxt{'46a'}/ ) {
						$testindexflag = 1;
						my (@testindex) = gmtime($newindex);
						if ( $testindex[4] != $thisdate[4] ) {
							$testindexflag = 0;
						}
					}
###
					${$dayinfo{$newindex}}[++$#{$dayinfo{$newindex}}] = $element if( ($newindex < $nxtmonfst) && ($newindex >= $selmonfst) && ($testindexflag == 1) );
				}
			}
		}
	}
}
#DisCalendar generates month view calendar page, called by CalMain sub
sub DisCalendar {
	require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	my($thisdaysecs) = timegm(0,0,0,1,$thismonth,$thisyear);
	my($thisdayweek) = (gmtime($thisdaysecs))[6];
	if ($mondayfirst == 1) {
		if ($thisdayweek == 0) {
			$thisdayweek = 6;
		} else {
			$thisdayweek = $thisdayweek - 1;
		}
	}
	my($daysecs) = 24*60*60;
	my(@today) = localtime(time + (3600*($timeoffset + $settings[18])));
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($nextmonth) = $thismonth+1;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($prevmonth) = $thismonth-1;
	my($prevyear) = $thisyear;
	if($prevmonth < 0) {
		$prevmonth = 11;
		$prevyear = $thisyear-1;
	}
###### newcaladmingroup stuff
	chomp $newcaladmingroup;
	@newcaladmingrouplist = split(",",$newcaladmingroup);
	$newcaladmingroupflag = 0;
	foreach $newcaladmingroupitem (@newcaladmingrouplist) {
		if ($settings[7] eq $newcaladmingroupitem) { $newcaladmingroupflag = 1; }
	}
############


	$yymain .= qq~
<CENTER>
  <TABLE border="2" cellpadding="2" cellspacing="3" width="90%">
    <CAPTION class="newcal16">$caltitle</CAPTION>
    <TR>
      <FORM>
        <TD class="newcal1">
          <CENTER>
            <INPUT class="newcal12" type=BUTTON value=$ecaltxt{'20'} onClick='location ="$scripturl?action=newcalendar&selmonth=$prevmonth&selyear=$prevyear"'>
          </CENTER>
        </TD>
      </FORM>
      <TD class="newcal5" colspan=5>
        <CENTER>
          <SPAN class="newcal13">$monthname &nbsp; &nbsp; &nbsp; &nbsp; $thisyear</SPAN>
        </CENTER>
      </TD>
      <FORM>
        <TD class="newcal1">
          <CENTER>
            <INPUT class="newcal12" type=BUTTON value=$ecaltxt{'21'} onClick='location="$scripturl?action=newcalendar&selmonth=$nextmonth&selyear=$nextyear"'>
          </CENTER>
        </TD>
      </FORM>
    </TR>~;
	if ($mondayfirst == 1) {
		$yymain .= qq~
    <TR>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'14'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'15'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'16'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'17'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'18'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'19'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'13'}</CENTER></TD>
    </TR>~;
	} else {
		$yymain .= qq~
    <TR>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'13'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'14'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'15'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'16'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'17'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'18'}</CENTER></TD>
      <TD class="newcal6" width="14%" nowrap><CENTER>$ecaltxt{'19'}</CENTER></TD>
    </TR>~;
	}
	$yymain .= qq~<TR><TD colspan=$thisdayweek></TD>~ if($thisdayweek > 0);
	my($thisdaymonth) = 1;
	for($thisdaysecs;$thisdaysecs <= $thisdaysecs+$daysecs*31;$thisdaysecs=$thisdaysecs+$daysecs) {
		$thismoonsecs = $thisdaysecs + $daysecs;
		last if ((gmtime($thisdaysecs))[4] != $thismonth);
		$data="";
		($thisdaymonth,$thisdayweek) = (gmtime($thisdaysecs))[3,6];
		if ($mondayfirst == 1) {
			if ($thisdayweek == 0) {
				$thisdayweek = 6;
			} else {
				$thisdayweek = $thisdayweek - 1;
			}
		}
		if (defined($dayinfo{$thisdaysecs})) {
			$data = "<SPAN class=newcal17>";
			foreach $info (@{ $dayinfo{$thisdaysecs} }) {
				@daydata = split(/\{/,$info);
				next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
				$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
				&wrap;
				if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
				&wrap2;
				$daydata[0] = $message;
# End UBBC
				$data = $data . qq~ <LI><A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A></LI>~;
			}
			$data = $data . "</SPAN><BR>";
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
# End censor subject routine
		}
# Add bday code
		if ($addbdays == 1) {
			while (($bdaykey, $bdayindex) = each %bdayshash) {
				if ($bdayindex == $thisdaysecs) {
					$data .= qq~<SPAN class=newcal17><LI>$ecaltxt{'57'}$bdaykey</LI></SPAN><BR>~;
				}
			}
		}
# End bday code
# Add moon phase info
		if ($newcalmoon == 1) {
			( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase($thismoonsecs);
			if ( ($MoonPhase >= 0.48305) && ( $MoonPhase <= 0.51695) ){
				$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moonfull.gif" alt="" border="0"><SPAN class=newcal17> $ecaltxt{'78'}</SPAN>~;
			}
			if ( ($MoonPhase <= 0.01695) || ( $MoonPhase >= 0.98305) ){
				$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moonnew.gif" alt="" border="0"><SPAN class=newcal17> $ecaltxt{'77'}</SPAN>~;
			}
		}
# end moon phase info
		if($thisdayweek == 0) {
			$yymain .= qq~</TR><TR><TD class="newcal7" valign=top align=left>~;
		}
		else {
			$yymain .= qq~  <TD class="newcal7" valign=top align=left>~;
		}
		if( $username ne "Guest" || $newcalguest == 1 ){
#			if ($newcaladmin != 1 || $settings[7] eq 'Administrator' ) {
			if ($newcaladmin != 1 || $newcaladmingroupflag == 1 || $settings[7] eq 'Administrator' ) {
				if($todaysecs == $thisdaysecs) {
					$yymain .= qq~<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=enterdata"><SPAN class="newcal14">$thisdaymonth</SPAN></A>$data</TD>~;
				} else {
					$yymain .= qq~<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=enterdata"><SPAN class="newcal15">$thisdaymonth</SPAN></A>$data</TD>~;
				}
			} else {
				if($todaysecs == $thisdaysecs) {
					$yymain .= qq~<SPAN class="newcal14">$thisdaymonth</SPAN>$data</TD>~;
				} else {
					$yymain .= qq~<SPAN class="newcal15">$thisdaymonth</SPAN>$data</TD>~;
				}
			}
		} else {
			if($todaysecs == $thisdaysecs) {
					$yymain .= qq~<SPAN class="newcal14">$thisdaymonth</SPAN>$data</TD>~;
			} else {
					$yymain .= qq~<SPAN class="newcal15">$thisdaymonth</SPAN>$data</TD>~;
			}
		}
	}
	$yymain .= qq~</TR></TABLE><BR>~;
	$yymain .= qq~<SPAN class="newcal17">$ecaltxt{'24'}<BR>$ecaltxt{'25'}</SPAN>~;
}
# DisCalForm displays select month-year form at bottom of month view page, called by CalMain
sub DisCalForm {
	$yymain .= qq~
<FORM method="post" action="$scripturl?action=newcalendar" enctype="application/x-www-form-urlencoded" name="calform">
  <TABLE border="2" cellpadding="2" cellspacing="3" width="90%">
    <TR>
      <TD class="newcal5"><CENTER>$ecaltxt{'26'}</CENTER></TD>
      <TD class="newcal5"><CENTER>$ecaltxt{'27'}</CENTER></TD>
      <TD class="newcal5"><CENTER>$ecaltxt{'28'}</CENTER></TD>
    </TR><TR>
      <TD class="newcal2" align=center Valign=MIDDLE>
        <SELECT name="selmonth" size="1">
          <OPTION SELECTED value="0">$ecaltxt{'01'}
          <OPTION  value="1">$ecaltxt{'02'}
          <OPTION  value="2">$ecaltxt{'03'}
          <OPTION  value="3">$ecaltxt{'04'}
          <OPTION  value="4">$ecaltxt{'05'}
          <OPTION  value="5">$ecaltxt{'06'}
          <OPTION  value="6">$ecaltxt{'07'}
          <OPTION  value="7">$ecaltxt{'08'}
          <OPTION  value="8">$ecaltxt{'09'}
          <OPTION  value="9">$ecaltxt{'10'}
          <OPTION  value="10">$ecaltxt{'11'}
          <OPTION  value="11">$ecaltxt{'12'}
        </SELECT>
      </TD>
      <TD class="newcal2" align=center Valign=MIDDLE>
        <SELECT name="selyear" size="1">
          <OPTION  value="2001">2001
          <OPTION SELECTED value="2002">2002
          <OPTION  value="2003">2003
          <OPTION  value="2004">2004
          <OPTION  value="2005">2005
          <OPTION  value="2006">2006
          <OPTION  value="2007">2007
          <OPTION  value="2008">2008
          <OPTION  value="2009">2009
          <OPTION  value="2010">2010
        </SELECT>
      </TD>
      <TD class="newcal2" align=center Valign=MIDDLE>
        <INPUT type="submit" name="$ecaltxt{'29'}" value="$ecaltxt{'29'}">
      </TD>
    </TR>
  </TABLE>
</FORM>
	~;
}
# EnterData generates Edit Events page, called by CalMain
sub EnterData {
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	if (defined($dayinfo{$daynum})) {
		my($entrynum) = 0;
		foreach $entry (@{ $dayinfo{$daynum} }) {
			my(@daydata) = split(/\{/,$entry);
			$dayvars[$entrynum] = [ @daydata ];
			$entrynum++;
		}
	}
	($thisdaymonth,$thismonth,$thisyear,$thisdayweek) = (gmtime($daynum))[3,4,5,6];
	$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	$thisyear += 1900;
	if ($newcaldate == 1) {
		$newcaldatestring = qq~$thisweekdayname $thisdaymonth. $monthname $thisyear~;
	} else {
		$newcaldatestring = qq~$thisweekdayname, $monthname $thisdaymonth, $thisyear~;
	}
	my($entrynumstr)=1;
	my($title) = "";
	my($subject) = "$sbjdefault";
	my($repeatnum) = 1;
	my($repeatby) = "Daily";
	my($comment) = "";
	my($eventusername) = 'Invalid user name placeholder'; #Sets variable to string no legitimate user name could possibly be.
###### newcaladmingroup stuff
	chomp $newcaladmingroup;
	@newcaladmingrouplist = split(",",$newcaladmingroup);
	$newcaladmingroupflag = 0;
	foreach $newcaladmingroupitem (@newcaladmingrouplist) {
		if ($settings[7] eq $newcaladmingroupitem) { $newcaladmingroupflag = 1; }
	}
############
	$yymain .= qq~
<CENTER>
  <H2>$entitle</H2>
  <FORM method="POST"  enctype="application/x-www-form-urlencoded">
    <INPUT type="button" name="Back" value="$ecaltxt{'22'}" onclick="self.history.back()">
  </FORM>
  <HR width="80%">
</CENTER>
	~;
	$newcalmax2 = $newcalmax - 1;
	for ($entrynum=0;$entrynum<=$newcalmax2;$entrynum++) {
		if (${$dayvars[$entrynum]}[1] !~ /DELETED/) {
			$title = ${$dayvars[$entrynum]}[0] if (defined(${$dayvars[$entrynum]}[0]));
			$subject = ${$dayvars[$entrynum]}[1] if (defined(${$dayvars[$entrynum]}[1]));
			$comment = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
			$comment =~ s~<br>~\n~g;
			$eventusername = ${$dayvars[$entrynum]}[3] if (defined(${$dayvars[$entrynum]}[3]));
			$repeatby = ${$dayvars[$entrynum]}[4] if (defined(${$dayvars[$entrynum]}[4]));
			$repeatnum = ${$dayvars[$entrynum]}[5] if (defined(${$dayvars[$entrynum]}[5]));
		}
		if($username eq $eventusername || $settings[7] eq 'Administrator' || $newcaladmingroupflag == 1 || $eventusername eq 'Invalid user name placeholder') {
			if($eventusername eq 'Invalid user name placeholder') {$eventusername = $username};  #Sets new events to current username
##### Get Display name
		# Load the current nickname of the account name of the event poster.
		if( $eventusername ne 'Guest' && -e "$memberdir/$eventusername.dat" ) {
			&LoadUser($eventusername);
			$mname2 = $userprofile{$eventusername}->[1] || $mname2 || $txt{'28'};
		}
		else {
			$mname2 ||= $txt{'28'};
		}
##### Get Display name end
			$yymain .= qq~
<FORM method="post" action="$scripturl?action=newcalendar" enctype="application/x-www-form-urlencoded">
  <INPUT name="formnum" type=HIDDEN value="$entrynum">
  <INPUT name="selmonth" type=HIDDEN value="$seldate[0]">
  <INPUT name="selday" type=HIDDEN value="$seldate[1]">
  <INPUT name="selyear" type=HIDDEN value="$seldate[2]">
  <INPUT name="eventusername" type=HIDDEN value="$eventusername">
  <TABLE border=2 width=90%>
    <CAPTION class="newcal18">$ecaltxt{'41'}$entrynumstr$ecaltxt{'42'}$newcaldatestring</CAPTION>
    <TR>
      <TD class="newcal1">$ecaltxt{'31'}</TD>
      <TD class="newcal1" align=center>
        <INPUT name="title" type=text size=14 maxlength=18 value="$title">
      </TD>
      <TD class="newcal8">$ecaltxt{'37'}</TD>
      <TD class="newcal8" align=center>
        <INPUT name="repeatnum" type=text size=2  maxlength=2 value="$repeatnum">
      </TD>
      <TD class="newcal8" align=center>
        <SELECT name="repeatby" size=1 value="$repeatby">
			~;
			foreach $item ($ecaltxt{'43'},$ecaltxt{'44'},$ecaltxt{'45'},$ecaltxt{'46'},$ecaltxt{'46a'}) {
				if($repeatby =~ /$item/) {
					$yymain .= qq~	  <OPTION selected>$item(s)<BR>~;
				}
				else {
					$yymain .= qq~	  <OPTION>$item(s)<BR>~;
				}
			}
			$yymain .= qq~
        </SELECT>
      </TD>
    </TR><TR>
      <TD class="newcal2">$ecaltxt{'50'}</TD>
      <TD class="newcal2" align=center>
        <SELECT name="subject" size=4 value="$subject">
			~;
			foreach $item (@sbjlist) {
#fix problem with similar event types
				chomp $item;
				if( $subject eq $item ) {
					$yymain .= qq~	  <OPTION selected>$item<BR>~;
				}
				else {
					$yymain .= qq~	  <OPTION>$item<BR>~;
				}
			}
			$yymain .= qq~
        </SELECT>
      </TD>
      <TD class="newcal3">$ecaltxt{'35'}</TD>
      <TD class="newcal3" colspan=2 align=center>
        <TEXTAREA name="comment" rows=4 cols=70 wrap="physical">$comment</TEXTAREA>
      </TD>
    </TR><TR>
      <TD class="newcal9" colspan=2>
        <INPUT name="deldata" type=submit value="$ecaltxt{'47'}$entrynumstr">
      </TD>
      <TD class="newcal10">$ecaltxt{'54'}</TD>
      <TD class="newcal10" colspan=1>$mname2</TD>
      <TD class="newcal11" colspan=1>
        <INPUT name="newdata" type=submit value="$ecaltxt{'48'}$entrynumstr">
      </TD>
    </TR>
  </TABLE>
</FORM>
			~;
		}
# The above closing bracket is the end of the username controlled exclusion
		$entrynumstr++;
		$title = "";
		$subject = "$sbjdefault";
		$repeatnum = 1;
		$repeatby = "Daily";
		$comment = "";
		$eventusername = 'Invalid user name placeholder'; #reset the variable for the next iteration
	}
	$yymain .=qq~
<SPAN class="newcal20">$ecaltxt{'53'}</SPAN>
<BR>
<TABLE border="0">
    <TR>
      <TD valign=top class="newcal19">$ecaltxt{'31'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'32'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'33'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'34'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'35'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'36'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'37'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'38'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'39'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'40'}</TD>
    </TR>
</TABLE>
<CENTER>
  <HR width="80%">
</CENTER>
	~;
}
# ViewData shows Events Details page, called by CalMain
sub ViewData {
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	if (defined($dayinfo{$daynum})) {
		my($entrynum) = 0;
		foreach $entry (@{ $dayinfo{$daynum} }) {
			my(@daydata) = split(/\{/,$entry);
			$dayvars[$entrynum] = [ @daydata ];
			$entrynum++;
		}
	}
#### new date string stuff
	($thisdaymonth,$thismonth,$thisyear,$thisdayweek) = (gmtime($daynum))[3,4,5,6];
	$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	$thisyear += 1900;
	if ($newcaldate == 1) {
		$newcaldatestring = qq~$thisweekdayname $thisdaymonth. $monthname $thisyear~;
	} else {
		$newcaldatestring = qq~$thisweekdayname, $monthname $thisdaymonth, $thisyear~;
	}
	my($subject) = "";
	my($commentview) = "";
	$yymain .= qq~
<CENTER>
  <H2>$vwtitle</H2>
  <FORM method="POST"  enctype="application/x-www-form-urlencoded">
    <INPUT type="button" name="Back" value="$ecaltxt{'22'}" onclick="self.history.back()">
  </FORM>
  <HR width="80%">
  <TABLE border=0 width=80%>
    <CAPTION>$ecaltxt{'49'}$newcaldatestring</CAPTION>
    <TR>
      <TD class="newcal4" colspan=2><HR width=97% size=4></TD>
    </TR>
	~;
	$newcalmax2 = $newcalmax - 1;
	for ($entrynum=0;$entrynum<=$newcalmax2;$entrynum++) {
		next if !(defined(${$dayvars[$entrynum]}[0]));
		next if(${$dayvars[$entrynum]}[1] =~ /DELETED/);
# Addon for user security
		$commentview = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
		$eventusername = ${$dayvars[$entrynum]}[3] if (defined(${$dayvars[$entrynum]}[3]));
# Censor the subject and message.
		&LoadCensorList;
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$commentview =~ s~\Q$tmpa\E~$tmpb~gi;
			${$dayvars[$entrynum]}[0] =~ s~\Q$tmpa\E~$tmpb~gi;
		}
##### Get Display name
		# Load the current nickname of the account name of the event poster.
		if( $eventusername ne 'Guest' && -e "$memberdir/$eventusername.dat" ) {
			&LoadUser($eventusername);
			$mname = $userprofile{$eventusername}->[1] || $mname || $txt{'28'};
			$mname2 = $mname;
			$mname = qq~<A HREF="$scripturl?action=viewprofile;username=$useraccount{$eventusername}" alt="$txt{'27'}: $eventusername">$mname</A>~;
		}
		else {
			$mname = $txt{'28'};
			$mname2 = $mname;
		}
##### Get Display name end
####### Media Player mod
		$mediausername = $mname2;
####### Media Player mod end
# Run UBBC interpreter on the description.
		$message = $commentview; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$commentview = $message;
# Run UBBC interpreter on the event name.
		$eventnamesend = ${dayvars[$entrynum]}[0];    #bypass UBBC for SendEvent
		$message = ${dayvars[$entrynum]}[0]; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		${dayvars[$entrynum]}[0] = $message;
# End UBBC
#End addon for user security
		$yymain .= qq~
  <TR>
    <TD class="newcal1" width="20%">$ecaltxt{'31'}</TD>
    <TD class="newcal1" align=left>  ${$dayvars[$entrynum]}[0]</TD>
  </TR><TR>
    <TD class="newcal2" width="20%">$ecaltxt{'50'}</TD>
    <TD class="newcal2" align=left>${$dayvars[$entrynum]}[1]</TD>
  </TR><TR>
    <TD class="newcal3" width="20%">$ecaltxt{'35'}</TD>
    <TD class="newcal3" align=left>$commentview</TD>
  </TR><TR>
    <TD class="newcal1" width="20%">$ecaltxt{'54'}</TD>
    <TD class="newcal1" align=left> $mname</TD>
  </TR>
		~;
#### send event form
		if ($newcalsend == 1) {
			my($eventday) = $seldate[1];
			my($eventmonth) = $seldate[0];
			my($eventyear) = $seldate[2];
			$yymain .= qq~
  <TR>
    <TD colspan="2">
      <FORM action="$cgi;action=sendevent" method="POST">
	  <INPUT TYPE="hidden" NAME="eventdate" VALUE="$newcaldatestring">
	  <INPUT TYPE="hidden" NAME="eventday" VALUE="$eventday">
	  <INPUT TYPE="hidden" NAME="eventmonth" VALUE="$eventmonth">
	  <INPUT TYPE="hidden" NAME="eventyear" VALUE="$eventyear">
	  <INPUT TYPE="hidden" NAME="eventname" VALUE="$eventnamesend">
	  <INPUT TYPE="hidden" NAME="eventauthor" VALUE="$mname2">
	  <INPUT TYPE="hidden" NAME="eventtype" VALUE="${$dayvars[$entrynum]}[1]">
	  <INPUT type=submit value="$ecaltxt{'86'}">
      </FORM>
    </TD>
  </TR>
  <TR>
    <TD class="newcal4" colspan=2><HR width=97% size=4></TD>
  </TR>
			~;
		}
#### end send event form
	}
	$yymain .= qq~
</TABLE>
<BR>
	~;
}
# NewData writes new enteries to database file, called by CalMain sub
sub NewData {
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	my($arrayloc) = $webpage_obj->param('formnum');
	my($title) = $webpage_obj->param('title');
	my($subject) = $webpage_obj->param('subject');
	my($comment) = $webpage_obj->param('comment');
	my($eventusername) = $webpage_obj->param('eventusername');
	my($repeatby) = $webpage_obj->param('repeatby');
	my($repeatnum) = $webpage_obj->param('repeatnum');
# Addon for user security
	$title =~ s/\cM//g;
	$title =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$title =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$title =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	$eventusername =~ tr/!-~/ /cs;
	if (length($comment)>$MaxMessLen) { &fatal_error($txt{'499'}); }
	&spam_protection;
	$comment =~ s/\cM//g;
	$comment =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$comment =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$comment =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($comment);
	$comment =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$comment =~ s~\n~<br>~g;
# End addon for user security
#	$repeatby =~ tr/!-~/ /cs;
	$repeatnum =~ tr/!-~/ /cs;
	$title =~ s/[\{\|]//g;
	$subject =~ s/[\{\|]//g;
	$comment =~ s/[\{\|]//g;
	$eventusername =~ s/[\{\|]//g;
	$repeatby =~ s/[\{\|]//g;
	$repeatnum =~ s/[\{\|]//g;
	$subject = "DELETED" if($acttype=~/deldata/);
	my($dbentry) = join( '{',$title,$subject,$comment,$eventusername,$repeatby,$repeatnum);
	${$dayinfo{$daynum}}[$arrayloc]="$dbentry";
	my($dbrow) = "$daynum";
	foreach $one (@{$dayinfo{$daynum}}) {
		$dbrow = join('|',$dbrow,$one);
	}
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,">>$dbfile");
	print(DBFILE "$dbrow\n");
	fclose(DBFILE);
	CompactCal();
}
# SendTrailer puts footer at bottom of all calendar pages.
# Nermware credit must be shown on all calendar pages.
sub SendTrailer {
	my $helpfile2 = $helpfile;
	$helpfile2 =~ m/(.+)(\/.+$)/;
	my $newcalhelpfile = $1 . qq~/NewcalendarHelp.html~;
	$yymain .= qq~
<BR>
<CENTER>
  <A HREF="$scripturl?action=newcalendar&acttype=search"><SPAN class=newcal21>$ecaltxt{'89'}</SPAN></A>~;
	if ($newcalhelp == 1) {
		$yymain .= qq~&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="$newcalhelpfile" target=_blank><SPAN class=newcal21>$ecaltxt{'96'}</SPAN></A>~;
	}
	$yymain .= qq~
  <BR>
  <A HREF="$scripturl"><SPAN class=newcal22>$ecaltxt{'23'}$mbname</SPAN></A>
  <BR><BR>
  <SPAN class=newcal23>
  <A HREF="http://www.nermware.com">$origcom</A>
  <BR>$Newcalendarplver$ecaltxt{'51'}<A HREF="mailto:admin\@mineralarts.com?SUBJECT=The Newcalendar mod $Newcalendarplver">$adaptcom</A>
  </SPAN>
</CENTER>
	~;
}
#CompactCal removes duplicate calendar entries.  Called by sub NewData.
sub CompactCal {
# Only last record for a date is kept in hash since index is reused.
# Since this sub is run each time NewData is called, the database should never contain duplicate date info.
# In campactdayinfo hash: keys are index dates and values are complete date-event strings
my %compactdayinfo;
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,$dbfile);
	$dummy=<DBFILE>; # read first line which is always empty
	while ($strline=<DBFILE>) {
		chop($strline);
		@line = split(/\|/,$strline);
		my($index) = shift(@line);
		$compactdayinfo{$index} = $strline;
	}
	fclose(DBFILE);
# now write events back to dbfile without duplicates.
	fopen(DBFILE, ">$dbfile");
	print DBFILE qq~\n~;
	while (($dateindex, $dayevents) = each %compactdayinfo) {
		print DBFILE qq~$dayevents\n~;
	}
	fclose(DBFILE);
}
# CalSettings generates edit settings page for Newcalendar in the Admin Center.  Calls CalSettings2.
sub CalSettings {
	&is_admin;
	require "$vardir/eventcal.txt";
	my($newcalopenchecked);
	my($newcaldatechecked);
	my($newcalmoonchecked);
	my($newcalmoon2checked);
	my($newcalguestchecked);
	my($mondayfirstchecked);
	my($newcalsendchecked);
	my($addbdayschecked);	
	my($newcaladminchecked);
	my($newcalhelpchecked);
	if ($newcalopen) { $newcalopenchecked = ' checked'; }
	if ($newcaldate) { $newcaldatechecked = ' checked'; }
	if ($newcalmoon) { $newcalmoonchecked = ' checked'; }
	if ($newcalmoon2) { $newcalmoon2checked = ' checked'; }
	if ($newcalguest) { $newcalguestchecked = ' checked'; }
	if ($mondayfirst) { $mondayfirstchecked = ' checked'; }
	if ($addbdays) { $addbdayschecked = ' checked'; }
	if ($newcalsend) { $newcalsendchecked = ' checked'; }
	if ($newcaladmin) { $newcaladminchecked = ' checked'; }
	if ($newcalhelp) { $newcalhelpchecked = ' checked'; }
	my $helpfile2 = $helpfile;
	$helpfile2 =~ m/(.+)(\/.+$)/;
	my $newcalhelpfile = $1 . qq~/NewcalendarHelp.html~;
	$yymain .= qq~
<FORM action="$cgi;action=newcalset2" method="POST">
<TABLE width="90%" border="0" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <TR>
  <TD>
  <TABLE border="0" cellspacing="0" cellpadding="4" align="center">
  <TR>
    <TD class="titlebg" bgcolor="$color{'titlebg'}" colspan=2>
    <IMG SRC="$imagesdir/preferences.gif" alt="" border="0">
    <FONT size=2 class="text1" color="$color{'titletext'}"><B>$ecaltxt{'60'}</B></FONT></TD>
  </TR><TR>
    <TD class="windowbg" bgcolor="$color{'windowbg'}" colspan="2" align="right"><FONT size="1"><A HREF="$newcalhelpfile" target=_blank>$ecaltxt{'96'}</A></FONT></TD>
  </TR><TR>
    <TD class="windowbg" bgcolor="$color{'windowbg'}" colspan="2"><FONT size="1">$ecaltxt{'61'}</FONT></TD>
  </TR><TR>
    <TD class="windowbg" bgcolor="$color{'windowbg'}" colspan="2" align="right"><A HREF="$cgi;action=rebuildmemlist"><FONT size="1">$txt{'593'}</A><FONT size="1"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'62'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="calpagetitle" size="35" value="$calpagetitle"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'63'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="caltitle" size="45" value="$caltitle"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'64'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text size="50" name="sbjlist" value="$sbjlist"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'65'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="sbjdefault" size="15" value="$sbjdefault"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'66'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="vwpgtitle" size="40" value="$vwpgtitle"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'67'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="vwtitle" size="40" value="$vwtitle"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'68'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="enpgtitle" size="30" value="$enpgtitle"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'69'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="entitle" size="30" value="$entitle"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'75'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="newcalmax" size="5" value="$newcalmax"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'94'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="newcalspread" size="5" value="$newcalspread"></TD>
  </TR><TR>
    <TD colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'93'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcaladmin" value="1" $newcaladminchecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'95'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="newcaladmingroup" size="30" value="$newcaladmingroup"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'71'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcalopen" value="1" $newcalopenchecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'72'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=text name="newcalgroup" size="30" value="$newcalgroup"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'80'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcalguest" value="1" $newcalguestchecked></TD>
  </TR><TR>
    <TD colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'74'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcaldate" value="1" $newcaldatechecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'76'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="mondayfirst" value="1" $mondayfirstchecked></TD>
  </TR><TR>
    <TD colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'79'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcalmoon" value="1" $newcalmoonchecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'81'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcalmoon2" value="1" $newcalmoon2checked></TD>
  </TR><TR>
    <TD colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'82'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="addbdays" value="1" $addbdayschecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'88'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcalsend" value="1" $newcalsendchecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><FONT size="2">$ecaltxt{'97'}</FONT></TD>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT type=checkbox name="newcalhelp" value="1" $newcalhelpchecked></TD>
  </TR><TR>
    <TD class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center" valign="middle">
    <BR><INPUT type=submit value="$txt{'10'}">
    </TD>
  </TR>
</TABLE>
</TD>
</TR>
</TABLE>
</FORM>
~;
	$yytitle = $ecaltxt{'60'};
	&template;
	exit;
}
# CalSettings2 saves changes to Newcalendar settings in eventcal.txt.  Called by CalSettings.
sub CalSettings2 {
	&is_admin;
	my @onoff = qw/ newcaladmin newcalopen newcalguest newcaldate mondayfirst newcalmoon newcalmoon2 addbdays newcalsend/;
	# Set as 0 or 1 if box was checked or not
	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;
	$newcalopen = $FORM{'newcalopen'} || 0;
	$newcaldate = $FORM{'newcaldate'} || 0;
	$newcalmoon = $FORM{'newcalmoon'} || 0;
	$newcalmoon2 = $FORM{'newcalmoon2'} || 0;
	$newcalguest = $FORM{'newcalguest'} || 0;
	$mondayfirst = $FORM{'mondayfirst'} || 0;
	$addbdays = $FORM{'addbdays'} || 0;	
	$newcalsend = $FORM{'newcalsend'} || 0;
	$newcaladmin = $FORM{'newcaladmin'} || 0;
	$newcalhelp = $FORM{'newcalhelp'} || 0;		
	$calpagetitle = $FORM{'calpagetitle'} || 'My Calendar Page';
	$caltitle = $FORM{'caltitle'} || 'My Calendar';
	$sbjlist = $FORM{'sbjlist'} || 'Meeting Game Birthday Anniversary Other';
	$sbjdefault = $FORM{'sbjdefault'} || 'Meeting';
	$vwpgtitle = $FORM{'vwpgtitle'} || 'Notices for Selected Date';
	$vwtitle = $FORM{'vwtitle'} || 'Notices for Selected Date';
	$enpgtitle = $FORM{'enpgtitle'} || 'Edit Notices Page';
	$entitle = $FORM{'entitle'} || 'Edit Notices Page';
	$newcalmax = $FORM{'newcalmax'} || 5;
	if ($newcalmax < 1) {$newcalmax = 1};
	$newcalspread = $FORM{'newcalspread'} || 1;
	if ($newcalspread < 1) {$newcalspread = 1};
	$newcalgroup = $FORM{'newcalgroup'} || 'Newcalendar Group';
	$newcaladmingroup = $FORM{'newcaladmingroup'} || 'Newcalendar Moderators';
	my $filler = q~										      ~;
	my $setfile = << "EOF";
###############################################################################
# eventcal.txt - Settings for Newcalendar 3.51				      #
###############################################################################

\$calpagetitle = "$calpagetitle";	# Title of the calendar page (window title)
\$caltitle = "$caltitle";		# Title of the calendar (not the window title)
\$sbjlist = "$sbjlist";			# Selection for subject (type) menu, modify to suit event types desired
\$sbjdefault = "$sbjdefault";		# Default subject list selection
\$vwpgtitle = "$vwpgtitle";		# Viewer page title (window title)
\$vwtitle = "$vwtitle";			# Viewer table title (not the window title)
\$enpgtitle = "$enpgtitle";		# Edit page title (window title)
\$entitle = "$entitle";			# Edit table title (not the window title)
\$newcalmax = $newcalmax;		# Maximum number of events per date (default = 5)
\$newcalspread = $newcalspread;	# Number of days of events to display on BoardIndex, Whoson, and SSI (default = 1)
\$newcaladmin = $newcaladmin;		# Set to 1 to limit event posting to Admins and Cal Moderators only, 0 for all members
\$newcaladmingroup = "$newcaladmingroup"; 	# Names of groups to allow event posting if newcaladmin = 1
\$newcalgroup = "$newcalgroup"; 	# Names of groups to give exclusive calendar access if newcalopen = 0
\$newcalopen = $newcalopen;		# Newcalendar open to all or just admin + group Newcalgroup
\$newcaldate = $newcaldate;		# Newcalendar Date Format: Check for 31/12/2002,<BR>uncheck for 12/31/2002
\$newcalmoon = $newcalmoon;		# Newcalendar moon phase on/off switch for main calendar
\$newcalmoon2 = $newcalmoon2;		# Newcalendar moon phase on/off switch for BoardIndex, Who'on, and SSI
\$newcalguest = $newcalguest;		# Newcalendar guest event posting on/off switch
\$mondayfirst = $mondayfirst;		# First day of week: Checked - Sunday, Unchecked - Monday
\$addbdays = $addbdays;			# Add birthdays to calendar: checked on, unchecked off
\$newcalsend = $newcalsend;		# Allow users to send event notices via email: checked on, unchecked off
\$newcalhelp = $newcalhelp;		# Show Calendar Help file link next to Calendar Search: checked on, unchecked off
1;
EOF

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(FILE, ">$vardir/eventcal.txt");
	print FILE $setfile;
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}
# IndexCal and IndexCal2 show today's events in Info Center on BoardIndex
# Split into two subs to allow for addon mods (like CalBDay), called by YaBB
sub IndexCal {
	require "$vardir/eventcal.txt";				       #This is the settings file
	@sbjlist = split(" ",$sbjlist);
	$yytitle = $calpagetitle;
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	IndexCal2();
}
# IndexCal2 shows today's events in Info Center on BoardIndex, called by IndexCal sub
sub IndexCal2 {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	my($newcalspread2) = 24*60*60*($newcalspread-1);
	my($daysecs) = 24*60*60;
	my(@today) = localtime(time + (3600*($timeoffset + $settings[18])));
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($thisdaysecs) = $todaysecs;
	my($thisdaymonth) = 1;
	my ($addbdaytext) = 0;
	$data = "";
	for ($thisdaysecs = $todaysecs; $thisdaysecs <= $todaysecs+$newcalspread2; $thisdaysecs += $daysecs) {
		$data2 = "";
		if (defined($dayinfo{$thisdaysecs})) {
			($thisdaymonth,$thismonth,$thisdayweek) = (gmtime($thisdaysecs))[3,4,6];
			foreach $item (@sbjlist) {
				$itemcount=0;
				foreach $info (@{ $dayinfo{$thisdaysecs} }) {
					@daydata = split(/\{/,$info);
					next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
					$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
					&wrap;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					&wrap2;
					$daydata[0] = $message;
# End UBBC
					$daydata[0] =~ s/(^.+)( $)/$1/; 
					chomp $item;
					if($daydata[1] eq $item) {
						if ($itemcount == 0) {
							$data2 = $data2 . qq~<LI>$daydata[1]:&nbsp;<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A>~;
							$itemcount++;
						} else {
							$data2 = $data2 . qq~,&nbsp;<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A>~;
							$itemcount++;
						}
					}
				}
			}
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
		}
####  new b-day stuff
		if ($addbdays == 1) {
			my($bdaymonth,$bmonth,$byear,$bdayweek) = (gmtime($thisdaysecs))[3,4,5,6];
			$bmonth += 1;
			$byear += 1900;
			$calwhobg = "";
			$countbd = 0;
			fopen(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
			@members = <FILE>;
			fclose(FILE);
			foreach $usernames (@members) {
				chomp $usernames;
	      		if ( -e "$memberdir/$usernames.dat") {
					fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
					@userbd = <FILE>;
					fclose(FILE);
					chomp $userbd[16];
					($matchm, $matchd, $useryear) = split(/\//, $userbd[16]);
					if(($bmonth == $matchm) && ($bdaymonth == $matchd)) {
						$age = $byear - $useryear;
						$calwhobg .=qq~<A HREF=$cgi&action=viewprofile&username=$usernames>$userbd[1]</A> ($age) ~;
						$countbd++;
					}
				}
			}
			chomp $calwhobg;
			if ($calwhobg ne "") {
				$calwhobg = qq~<LI>$ecaltxt{'56'}$calwhobg</LI>~;
			}
		}
###  end new b-day stuff
		if ( $calwhobg ne "" || $data2 ne "" ) {
			if ( $todaysecs == $thisdaysecs) {
				$data .= qq~<b>$txt{'769'}:</b>~ . $data2 . $calwhobg;
			} else {
				$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
				$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
				if ($newcaldate == 1) {
					$data .= qq~<br><b>$thisweekdayname $thisdaymonth. $monthname:</b>~ . $data2 . $calwhobg;
				} else {
					$data .= qq~<br><b>$thisweekdayname, $monthname $thisdaymonth:</b>~ . $data2 . $calwhobg;
				}
			}
		}

	} # end of loop for each date
	if ($data ne "") {
		$yymain .= qq~$data~;
	} else {
		$yymain .= qq~$ecaltxt{'73'}~;
	}
}
# CalBDay adds Today's Birthdays to Info Center and SSI script, called by IndexCal and IncludeCal subs
sub CalBDay {
	&timeformat($date);
	($tocheckm, $tocheckd, $years) = split(/\//, $date);
	($year, $trash) = split(/ /, $years);


	$calwhobd = "";
	$countbd = 0;
	fopen(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	fclose(FILE);
	foreach $usernames (@members) {
		chomp $usernames;
	      if ( -e "$memberdir/$usernames.dat") {
			fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			fclose(FILE);
			chomp $userbd[16];
			($matchm, $matchd, $useryear) = split(/\//, $userbd[16]);
			if(($tocheckm == $matchm) && ($tocheckd == $matchd)) {
			$age = $year - $useryear + 2000;
				$calwhobg .=qq~<A HREF=$cgi&action=viewprofile&username=$usernames>$userbd[1]</A> ($age) ~;
				$countbd++;
			}
		}
	}#end foreach
	chomp $calwhobg;
	if ($calwhobg ne "") {$calwhobg = qq~<LI>$ecaltxt{'56'}$calwhobg</LI>~;}
}
# CalBDay2 adds All Birthdays to Calendar, called by CalMain sub
sub CalBDay2 {
	%bdayshash;  #keys are userprofstrings, values are birthdays in timegm format
	my $thisyear = $seldate[2];
	$userprofstring = "";
	open(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	close(FILE);
	foreach $usernames (@members) {
		chomp $usernames;
	      if ( -e "$memberdir/$usernames.dat") {
			fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			fclose(FILE);
			chomp $userbd[16];
#skip user if no birthday in file or birthday date invalid.
			if ($userbd[16] ne "") {
				($usermonth, $userday, $dummyyear) = split(/\//, $userbd[16]);
				if ($usermonth > 0 && $usermonth < 13) {
					if ($userday > 0 && $userday < 32) {
						$usermonth = $usermonth - 1;
						$bdayindex = timegm(0,0,0,$userday,$usermonth,$thisyear);
						$userprofstring = qq~<A HREF=$cgi&action=viewprofile&username=$usernames>$userbd[1]</A>~;
						$bdayshash{$userprofstring} = $bdayindex;
					}
				}
			}
		}# end file exists
	}#end foreach
}
# IncludeCal and IncludeCal2 show today's events on any HTML page through include virtual
# Split into two subs to allow for addon mods (like CalBDay), called by YaBB
sub IncludeCal {
	require "$vardir/eventcal.txt";				       #This is the settings file
	require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
	@sbjlist = split(" ",$sbjlist);
	$yytitle = $calpagetitle;
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	IncludeCal2();
	exit;
}
# IncludeCal2 shows today's events as SSI call on html pages, called by IncludeCal sub
sub IncludeCal2 {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	my($newcalspread2) = 24*60*60*($newcalspread-1);
	my($daysecs) = 24*60*60;
	my(@today) = localtime(time + (3600*($timeoffset + $settings[18])));
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($thisdaysecs) = $todaysecs;
	my($thisdaymonth) = 1;
	my ($addbdaytext) = 0;
	$data = "";
	for ($thisdaysecs = $todaysecs; $thisdaysecs <= $todaysecs+$newcalspread2; $thisdaysecs += $daysecs) {
		$data2 = "";
		if (defined($dayinfo{$thisdaysecs})) {
			($thisdaymonth,$thismonth,$thisdayweek) = (gmtime($thisdaysecs))[3,4,6];
			foreach $item (@sbjlist) {
				$itemcount=0;
				foreach $info (@{ $dayinfo{$thisdaysecs} }) {
					@daydata = split(/\{/,$info);
					next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
					$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
					&wrap;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					&wrap2;
					$daydata[0] = $message;
# End UBBC
					$daydata[0] =~ s/(^.+)( $)/$1/; 
					chomp $item;
					if($daydata[1] eq $item) {
						if ($itemcount == 0) {
							$data2 = $data2 . qq~<LI>$daydata[1]:&nbsp;<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A>~;
							$itemcount++;
						} else {
							$data2 = $data2 . qq~,&nbsp;<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A>~;
							$itemcount++;
						}
					}
				}
			}
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
		}
####  new b-day stuff
		if ($addbdays == 1) {
			my($bdaymonth,$bmonth,$byear,$bdayweek) = (gmtime($thisdaysecs))[3,4,5,6];
			$bmonth += 1;
			$byear += 1900;
			$calwhobg = "";
			$countbd = 0;
			fopen(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
			@members = <FILE>;
			fclose(FILE);
			foreach $usernames (@members) {
				chomp $usernames;
	      		if ( -e "$memberdir/$usernames.dat") {
					fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
					@userbd = <FILE>;
					fclose(FILE);
					chomp $userbd[16];
					($matchm, $matchd, $useryear) = split(/\//, $userbd[16]);
					if(($bmonth == $matchm) && ($bdaymonth == $matchd)) {
						$age = $byear - $useryear;
						$calwhobg .=qq~<A HREF=$cgi&action=viewprofile&username=$usernames>$userbd[1]</A> ($age) ~;
						$countbd++;
					}
				}
			}
			chomp $calwhobg;
			if ($calwhobg ne "") {
				$calwhobg = qq~<LI>$ecaltxt{'56'}$calwhobg</LI>~;
			}
		}
###  end new b-day stuff
		if ( $calwhobg ne "" || $data2 ne "" ) {
			if ( $todaysecs == $thisdaysecs) {
				$data .= qq~<b>$txt{'769'}:</b>~ . $data2 . $calwhobg;
			} else {
				$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
				$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
				if ($newcaldate == 1) {
					$data .= qq~<br><b>$thisweekdayname $thisdaymonth. $monthname:</b>~ . $data2 . $calwhobg;
				} else {
					$data .= qq~<br><b>$thisweekdayname, $monthname $thisdaymonth:</b>~ . $data2 . $calwhobg;
				}
			}
		}

	} # end of loop for each date
# Add moon phase info
	if ($newcalmoon2 == 1) {
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;
	
		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	}
# end moon phase info
	print qq~Content-type: text/html\n\n~;
	if ($data ne "") {
		print qq~$data~;
	} else {
		print qq~$ecaltxt{'73'}~;
	}
}
# WhosCal and WhosCal2 show today's events in the modified Whoson mod
# Split into two subs to allow for addon mods (like WhosBDay), called by Whoson SSI mod
sub WhosCal {
	require "$vardir/eventcal.txt";				       #This is the settings file
	@sbjlist = split(" ",$sbjlist);
	require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	WhosCal2();
}
# WhosCal2 shows today's events in the modified Whoson mod, called by WhosCal sub
sub WhosCal2 {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	my($newcalspread2) = 24*60*60*($newcalspread-1);
	my($daysecs) = 24*60*60;
	my(@today) = localtime(time + (3600*($timeoffset + $settings[18])));
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($thisdaysecs) = $todaysecs;
	my($thisdaymonth) = 1;
	my ($addbdaytext) = 0;
	$data = "";
	for ($thisdaysecs = $todaysecs; $thisdaysecs <= $todaysecs+$newcalspread2; $thisdaysecs += $daysecs) {
		$data2 = "";
		if (defined($dayinfo{$thisdaysecs})) {
			($thisdaymonth,$thismonth,$thisdayweek) = (gmtime($thisdaysecs))[3,4,6];
			foreach $item (@sbjlist) {
				$itemcount=0;
				foreach $info (@{ $dayinfo{$thisdaysecs} }) {
					@daydata = split(/\{/,$info);
					next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
					$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
					&wrap;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					&wrap2;
					$daydata[0] = $message;
# End UBBC
					$daydata[0] =~ s/(^.+)( $)/$1/; 
					chomp $item;
					if($daydata[1] eq $item) {
						if ($itemcount == 0) {
							$data2 = $data2 . qq~<LI>$daydata[1]:&nbsp;<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A>~;
							$itemcount++;
						} else {
							$data2 = $data2 . qq~,&nbsp;<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata">$daydata[0]</A>~;
							$itemcount++;
						}
					}
				}
			}
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
		}
####  new b-day stuff
		if ($addbdays == 1) {
			my($bdaymonth,$bmonth,$byear,$bdayweek) = (gmtime($thisdaysecs))[3,4,5,6];
			$bmonth += 1;
			$byear += 1900;
			$calwhobg = "";
			$countbd = 0;
			fopen(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
			@members = <FILE>;
			fclose(FILE);
			foreach $usernames (@members) {
				chomp $usernames;
	      		if ( -e "$memberdir/$usernames.dat") {
					fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
					@userbd = <FILE>;
					fclose(FILE);
					chomp $userbd[16];
					($matchm, $matchd, $useryear) = split(/\//, $userbd[16]);
					if(($bmonth == $matchm) && ($bdaymonth == $matchd)) {
						$age = $byear - $useryear;
						$calwhobg .= qq~<A HREF=$cgi&action=viewprofile&username=$usernames>$userbd[1]</A><BR>~;
						$countbd++;
					}
				}
			}
			chomp $calwhobg;
			if ($calwhobg ne "") {
				$calwhobg = qq~<LI>$ecaltxt{'56'}$calwhobg</LI>~;
			}
		}
###  end new b-day stuff
		if ( $calwhobg ne "" || $data2 ne "" ) {
			if ( $todaysecs == $thisdaysecs) {
				$data .= qq~<b>$txt{'769'}:</b>~ . $data2 . $calwhobg;
			} else {
				$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
				$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
				if ($newcaldate == 1) {
					$data .= qq~<br><b>$thisweekdayname $thisdaymonth. $monthname:</b>~ . $data2 . $calwhobg;
				} else {
					$data .= qq~<br><b>$thisweekdayname, $monthname $thisdaymonth:</b>~ . $data2 . $calwhobg;
				}
			}
		}

	} # end of loop for each date
# Add moon phase info
	if ($newcalmoon2 == 1) {
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;

		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$data = $data . '<BR>' . qq~<IMG SRC="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	}
# end moon phase info
	print qq~$data~;
}
sub NewCalSearch {
	$yytitle = "$ecaltxt{'89'}";
 	$yymain .= qq~
<FORM action="$scripturl?action=newcalsearch2" method="post" name="searchform">
  <TABLE border=0 width="80%" cellspacing="2" cellpadding="0" bgcolor="$color{'bordercolor'}" align="center">
    <TR>
      <TD bgcolor="$color{'bordercolor'}">
        <TABLE class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
          <TR>
            <TD><IMG SRC="$imagesdir/search.gif" alt=""> <FONT size=2 class="text1" color="$color{'titletext'}"><B>$txt{'183'}</B></FONT></TD>
          </TR>
        </TABLE>
      </TD>
    </TR><TR>
      <TD bgcolor="$color{'bordercolor'}">
        <TABLE width="100%" cellpadding="4" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
          <TR>
            <TD class="windowbg" bgcolor="$color{'windowbg'}"><FONT size=2><B>$txt{'582'}:</B></FONT></TD>
            <TD class="windowbg" bgcolor="$color{'windowbg'}">
            <FONT size=2>
              <INPUT type=text size=30 name="search">&nbsp;
                <SELECT name="searchtype">
                  <OPTION value="allwords" selected>$txt{'343'}</option>
                  <OPTION value="anywords">$txt{'344'}</option>
                  <OPTION value="asphrase">$txt{'345'}</option>
                </SELECT>
            </FONT>
            </TD>
          </TR><TR>
            <TD class="windowbg" bgcolor="$color{'windowbg'}"><FONT size=2><B>$txt{'573'}:</B></FONT></TD>
            <TD class="windowbg" bgcolor="$color{'windowbg'}">
            <FONT size=2>
              <TABLE border="0" cellpadding="4" cellspacing="0">
                <TR>
                  <TD><FONT size="2"><INPUT type=checkbox name=subfield value=on checked><SPAN id="spansubfield" style="cursor:hand;" onClick="changeBox('document.searchform.subfield')">$ecaltxt{'90'}</SPAN></FONT></TD>
                  <TD><FONT size="2"><INPUT type=checkbox name=msgfield value=on checked><SPAN id="spanmsgfield" style="cursor:hand;" onClick="changeBox('document.searchform.msgfield')">$ecaltxt{'91'}</SPAN></FONT></TD>
                </TR>
              </TABLE>
            </FONT>
            </TD>
          </TR><TR>
            <TD class="windowbg" bgcolor="$color{'windowbg'}" colspan="2" align="center">
            <FONT size="2">
              <INPUT type=hidden name=action value=dosearch>
              <INPUT type="submit" name="submit" value="$txt{'182'}"><BR><BR>
            </FONT>
            </TD>
          </TR>
        </TABLE>
      </TD>
    </TR>
  </TABLE>
</FORM>
<BR>
~;
	SendTrailer();
	&template;
	exit;
}

sub NewCalSearch2 {
	my($eventsfound) = 0;
	my $searchtype = $FORM{'searchtype'};
	my $search = $FORM{'search'};
	if( $searchtype eq 'anywords' ) { $searchtype = 2; }
	elsif( $searchtype eq 'asphrase' ) { $searchtype = 3; }
	else { $searchtype = 1; }
	if ($search eq ""){ &fatal_error($txt{'754'}); }
	if ($search =~ m~/~){ &fatal_error($txt{'397'}); }
	if ($search =~ m~\\~){ &fatal_error($txt{'397'}); }
	
	my $searchsubject = $FORM{'subfield'} eq 'on';
	my $searchmessage = $FORM{'msgfield'} eq 'on';

	$search =~ s/\A\s+//;
	$search =~ s/\s+\Z//;
	&ToHTML($search);
	$search =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$search =~ s/\cM//g;
	$search =~ s/\n/<br>/g;
	if( $searchtype != 3 ) { @search = split( /\s+/, $search ); }
	else { @search = ( $search ); }

	require "$vardir/eventcal.txt";				       #This is the settings file
	@sbjlist = split(" ",$sbjlist);
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
# at this point each key in $dayinfo{$index} holds the
# date index of an event and the value is string holding
# each event field, separated by {.

	$yymain .= qq~
<CENTER>
  <TABLE border="0" cellpadding="2" cellspacing="3" width="90%">
    <CAPTION class="newcal14">$txt{'166'}</CAPTION>
	~;


####snippet one####
	my(@searchdayinfokeys) = keys(%dayinfo);
	foreach $searchindex (@searchdayinfokeys) {
		my($searchmonth, $searchday, $searchyear) = (gmtime($searchindex))[4,3,5];
		$searchyear += 1900; 
		$searchmonth += 1;
		my($searchelement) = "";
		my(@searchentry) = ();
		my($entrynum) = 0;
		foreach $searchelement (@{ $dayinfo{$searchindex} }) {
			my(@searchentry) = split('{',$searchelement);
			$dayvars[$entrynum] = [ @searchentry ];
			$entrynum++;
		}
		eventcheck:	for ($entrynum=0;$entrynum<=$newcalmax2;$entrynum++) {
			next if !(defined(${$dayvars[$entrynum]}[0]));
			next if(${$dayvars[$entrynum]}[1] =~ /DELETED/);
			$eventname = ${$dayvars[$entrynum]}[0] if (defined(${$dayvars[$entrynum]}[0]));
			$eventmessage = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
			if( $searchsubject ) {
				if( $searchtype == 2 ) {
					$subfound = 0;
					foreach( @search ) {
						if( $eventname =~ m~\Q$_\E~i ) { $subfound = 1; last; }
					}
				}
				else {
					$subfound = 1;
					foreach( @search ) {
						if( $eventname !~ m~\Q$_\E~i ) { $subfound = 0; last; }
					}
				}
			}
			if( $searchmessage && ! $subfound ) {
				if( $searchtype == 2 ) {
					$msgfound = 0;
					foreach( @search ) {
						if( $eventmessage =~ m~\Q$_\E~i ) { $msgfound = 1; last; }
					}
				}
				else {
					$msgfound = 1;
					foreach( @search ) {
						if( $eventmessage !~ m~\Q$_\E~i ) { $msgfound = 0; last; }
					}
				}
			}
			unless( $msgfound || $subfound ) { next eventcheck; }
			if( $subfound || $msgfound ) {
				$eventsfound = 1;
# this is what to do with matching events:
###########
				# Censor the subject and message.
				&LoadCensorList;
				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$eventmessage =~ s~\Q$tmpa\E~$tmpb~gi;
					$eventname =~ s~\Q$tmpa\E~$tmpb~gi;
				}

				# Run UBBC interpreter on the description.
				$message = $eventmessage; # put the message back into the proper variable to do ubbc on it
				&wrap;
				if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
				&wrap2;
				$eventmessage = $message;
				# Run UBBC interpreter on the event name.
				$eventnamesend = ${dayvars[$entrynum]}[0];    #bypass UBBC for SendEvent
				$message = $eventname; # put the message back into the proper variable to do ubbc on it
				&wrap;
				if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
				&wrap2;
				$eventname = $message;
				# End UBBC
				foreach( @search ) {
					$eventmessage =~ s~(\Q$_\E)~<FONT size="2"><B>$_</B></FONT>~ig;
					$eventname =~ s~(\Q$_\E)~<FONT size="2"><B>$_</B></FONT>~ig;
				}
##### Get Display name
		$eventusername = ${$dayvars[$entrynum]}[3];
		# Load the current nickname of the account name of the event poster.
		if( $eventusername ne 'Guest' && -e "$memberdir/$eventusername.dat" ) {
			&LoadUser($eventusername);
			$mname = $userprofile{$eventusername}->[1] || $mname || $txt{'28'};
			$mname2 = $mname;
			$mname = qq~<A HREF="$scripturl?action=viewprofile;username=$useraccount{$eventusername}" alt="$txt{'27'}: $eventusername">$mname</A>~;
		}
		else {
			$mname = $txt{'28'};
			$mname2 = $mname;
		}
##### Get Display name end
####### Media Player mod
				$mediausername = $mname2;
####### Media Player mod end
				$yymain .= qq~
  <TR>
    <TD class="newcal20" width="20%">$ecaltxt{'85'}</TD>
    <TD class="newcal20" align=left>$searchmonth/$searchday/$searchyear</SPAN></TD>
  </TR><TR>
    <TD class="newcal20" width="20%">$ecaltxt{'31'}</TD>
    <TD class="newcal20" align=left>$eventname</TD>
  </TR><TR>
    <TD class="newcal20" width="20%">$ecaltxt{'50'}</TD>
    <TD class="newcal20" align=left>${$dayvars[$entrynum]}[1]</TD>
  </TR><TR>
    <TD class="newcal20" width="20%">$ecaltxt{'35'}</TD>
    <TD class="newcal3" align=left>$eventmessage</TD>
  </TR><TR>
    <TD class="newcal20" width="20%">$ecaltxt{'54'}</TD>
    <TD class="newcal20" align=left> $mname</TD>
  </TR><TR>
    <TD class="newcal4" colspan=2><HR width=97% size=4></TD>
  </TR>
				~;
			}
		}
	}
	if ($eventsfound == 0) {
		$yymain .= qq~
  <TR>
    <TD class="newcal4" colspan=2><CENTER>$ecaltxt{'92'}</CENTER></TD>
  </TR>
		~;
	}
	$yymain .= qq~
</TABLE>
<BR>
~;
	$yytitle = "$txt{'166'}";
	&template;
	exit;
}
1;
