<id>
Rebuild Message Index SP1/1.1 Topic Ratings Patch
</id>

<version>
1.0
</version>

<mod info>
This mod adds an admin function to rebuild damaged message index files. It does this by storing the id of the board each thread is on in the data file for that thread. By reading this information, YaBB can determine which board to place the threads on when rebuilding the index files for each board.

This is a Patch file for the Topic Ratings Mod. 

Only apply this mod if you have both the Rebuild Message Index Mod and Topic Ratings Mod installed.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

#############################################################################################################

<edit file>
Sources\Rate.pl
</edit file>

<search for>
	open(FILE, "$datadir/$viewnum.data") || &fatal_error("$txt{'23'} $viewnum.data");
	$tmpa = <FILE>;
	close(FILE);
</search for>

<replace>
	open(FILE, "$datadir/$viewnum.data") || &fatal_error("$txt{'23'} $viewnum.data");
	$tmpa = <FILE>;
	@other_stuff = <FILE>;
	close(FILE);
	chomp $tmpa;
</replace>

<search for>
	open(FILE,"+>$datadir/$viewnum.data") || &fatal_error("$txt{'23'} $viewnum.data");
	print FILE qq~$tmpa|$tmpb|$newrating|$votes~;
	close(FILE);
</search for>

<replace>
	open(FILE,"+>$datadir/$viewnum.data") || &fatal_error("$txt{'23'} $viewnum.data");
	print FILE qq~$tmpa|$tmpb|$newrating|$votes\n~;
	print FILE @other_stuff;
	close(FILE);
</replace>