<id>
Rebuild Message Index SP1/1.1 Message Index Thread Summary Patch
</id>

<version>
1.0
</version>

<mod info>
This mod adds an admin function to rebuild damaged message index files. It does this by storing the id of the board each thread is on in the data file for that thread. By reading this information, YaBB can determine which board to place the threads on when rebuilding the index files for each board.

This is a Patch file for the Message Index Thread Summary Mod. 

Only apply this mod if you have both the Rebuild Message Index Mod and Message Index Thread Summary Mod installed.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

#############################################################################################################

<edit file>
Sources\RebuildIndex.pl
</edit file>

<search for>
			$mstate = <FILE> || "0";
</search for>

<add after>
			$msummary = <FILE> || "";
</add after>

<search for>
			chomp $mstate;
</search for>

<add after>
			chomp $msummary;
</add after>

<search for>
			$threadLine = qq~$result|$mnum|$msubthread|$mname|$memail|$date1|$mreplies|$musername|$micon|$mstate\n~;
</search for>

<replace>
			$threadLine = qq~$result|$mnum|$msubthread|$mname|$memail|$date1|$mreplies|$musername|$micon|$mstate|$msummary\n~;
</replace>

<search for>
				($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $thread );
</search for>

<replace>
				($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate,$msummary) = split( /\|/, $thread );
</replace>

<search for>
				$other_stuff[2] = qq~$mstate\n~;
</search for>

<add after>
				$other_stuff[3] = qq~$msummary\n~;
</add after>

#############################################################################################################

<edit file>
Sources\Post.pl
</edit file>

<search for>
	$other_stuff[0] = qq~$currentboard\n~;
</search for>

<add after>
	$other_stuff[2] = qq~$msummary\n~;
</add after>

#############################################################################################################

<edit file>
Sources\ModifyMessage.pl
</edit file>

<search for>
			$tsummary = $summary;
</search for>

<add after>
			fopen(FILE, "$datadir/$tnum.data");
			@other_stuff = <FILE>;
			fclose(FILE);
			$other_stuff[3] = qq~$tsummary\n~;
			fopen(FILE, "+>$datadir/$tnum.data");
			print FILE @other_stuff;
			fclose(FILE);
</add after>
