<id>
Search Log SP1/1.1
</id>

<version>
1.0
</version>

<mod info>
This mod adds a log of the search strings used on your forum.

An admin option has been added to select the "Search Log Display Type", which has four options: None, Last 10 Searches, Top 10 Searches, Both.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

###############################################################################

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
</search for>

<add after>
	elsif ($action eq 'clean_search_log') { require "$sourcedir/Search.pl"; &clean_search_log; }
</add after>

###############################################################################

<edit file>
english.lng
</edit file>

<search for>
$txt{'187'} = "Search for topics posted in by someone";
</search for>

<add after>
$txt{'1870'} = "None";
$txt{'1871'} = "Last 10 Searches";
$txt{'1872'} = "Top 10 Searches";
$txt{'1873'} = "Both";
$txt{'1874'} = "Clean Search Log";
$txt{'1875'} = "Search Log Display Type";
</add after>

###############################################################################

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	if ($allowpics) { $allowpicschecked = "checked" }
</search for>

<add after>
	if ($search_log_display == 0) { $sld1 = " selected" } elsif ($search_log_display == 1) { $sld2 = " selected" } elsif ($search_log_display == 2) { $sld3 = " selected" } elsif ($search_log_display == 3) { $sld4 = " selected" }
</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'408'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeout" size="5" value="$timeout"></td>
  </tr><tr>
</search for>

<add after>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'1875'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="search_log_display" size=1>
    <option value="0"$sld1>$txt{'1870'}
    <option value="1"$sld2>$txt{'1871'}
    <option value="2"$sld3>$txt{'1872'}
    <option value="3"$sld4>$txt{'1873'}
    </select>
    </td>
  </tr><tr>
</add after>

<search for>
	$timeout = $FORM{'timeout'} || 5;
</search for>

<add after>
	$search_log_display = $FORM{'search_log_display'} || 0;
</add after>

<search for>
\$timeout = $timeout;					# Minimum time between 2 postings from the same IP
</search for>

<add after>
\$search_log_display = $search_log_display;		# Select type of search log to display: 0=none, 1=Last 10, 2=Top 10
</add after>

###############################################################################

<edit file>
Sources/Search.pl
</edit file>

<search for>
<script language="JavaScript"> <!--
	document.searchform.search.focus();
//--> </script>
~;
</search for>

<add after>

#	if ($settings[7] ne "Administrator") { $search_log_display = 0; }
	if ($search_log_display) {
		fopen(FILE, "$vardir/search_log.txt");
		@searches = <FILE>;
		fclose(FILE);
		@last_searches = @searches;
		@top_searches = sort {$b <=> $a} @searches;

		for( $i = 0; $i < @searches; $i++ ) {
			chomp $searches[$i];
			($dummy, $last_searches[$i]) = split(/\|/, $last_searches[$i]);
			($tmp_number, $top_searches[$i]) = split(/\|/, $top_searches[$i]);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$last_searches[$i] =~ s~\Q$tmpa\E~$tmpb~gi;
				$top_searches[$i] =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$top_searches[$i] = qq~$top_searches[$i] ($tmp_number)~;
		}

		if ($search_log_display == 2 || $search_log_display == 3) { $yymain .= qq~
<br><table border="0" width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
      <font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'1872'}</b></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2" align="center">
    <table width="100%" cellpadding="2" cellspacing="0">
~;
		for( $i = 1; $i <= 5; $i++ ) {
			$j = $i + 5;
			$yymain .= qq~
      <tr>
        <td width="5%" align="right"><font size="1">$i. </font></td>
        <td width="45%" align="left"><font size="1">$top_searches[$i-1]</font></td>
        <td width="5%" align="right"><font size="1">$j. </font></td>
        <td width="45%" align="left"><font size="1">$top_searches[$j-1]</font></td>
      </tr>
~;
		}
$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;}
		if ($search_log_display == 1 || $search_log_display == 3) { $yymain .= qq~
<br><table border="0" width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
      <font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'1871'}</b></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2" align="center">
    <table width="100%" cellpadding="2" cellspacing="0">
~;
		for( $i = 1; $i <= 5; $i++ ) {
			$j = $i + 5;
			$yymain .= qq~
      <tr>
        <td width="5%" align="right"><font size="1">$i. </font></td>
        <td width="45%" align="left"><font size="1">$last_searches[$i-1]</font></td>
        <td width="5%" align="right"><font size="1">$j. </font></td>
        <td width="45%" align="left"><font size="1">$last_searches[$j-1]</font></td>
      </tr>
~;
		}
$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;}
		if ($settings[7] eq "Administrator") {
			$yymain .= qq~<br><center><font size="1"><b>$txt{'137'}</b> - <a href="$cgi;action=clean_search_log">$txt{'1874'}</a></font></center>~;
		}
	}
</add after>

<search for>
	my $oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");
</search for>

<add after>
	if ($search_log_display) {
		fopen(FILE, "$vardir/search_log.txt");
		@searches = <FILE>;
		fclose(FILE);
		foreach $cursearch (@searches){
			chomp $cursearch;
			($tmp_number, $tmp_search) = split(/\|/, $cursearch);
			if (lc $tmp_search eq lc $search) {$number = $tmp_number;}
		}
		$number++;
		fopen(FILE, ">$vardir/search_log.txt");
		print FILE "$number|$search\n";
		foreach $cursearch (@searches){
			chomp $cursearch;
			($tmp_number, $tmp_search) = split(/\|/, $cursearch);
			if (lc $tmp_search ne lc $search) {print FILE "$tmp_number|$tmp_search\n";}
		}
		fclose(FILE);
	}
</add after>

<search for>
1;
</search for>

<add before>
sub clean_search_log {
	&is_admin;
	unlink("$vardir/search_log.txt");
	&plushSearch1;
}
</add before>