<id>
YaMS - Yet another Memberlist for SP1.1 with AMM installed
</id>

<version>
4.0 amm
</version>

<mod info>

- Red/green "led" indication for members online/offline
- Admin select Pics or Text in columns for e-mail, WWW, IM, ICQ, YIM, AIM and MSN
- View/hide e-mail, WWW, IM, ICQ, YIM, AIM columns in memberlist from admin-center
- View/hide MSN column in member list from admin-center (if MSN mod by omario is installed)
- View/hide registration-date column in member list from admin-center
- View/hide member number column in member list from admin-center
- View/hide IP-address (admin only) column in member list from admin-center
- Set default sort-column from admin-center
- Set max. bar-length to depend on top poster, 500 or 100 posts from admin-center
- Admin select different Colored bars for posts
- Add your own bars by just uploading them to YaMSbars folder
- Label on bars showing standard-membergroup
- Let users sort member list by alphabet, membergroups, number of posts or registration-date
- Let admin sort member list by IP-address or e-mail (domain)
- Let admin search members by IP-address
- When sorted by registration-date, users can switch between "newest last" and "newest first"
- Special characters in View by letter
- Show standard-membergroup in group-column if no additional group is on
- Admin can allow/disallow guest-acces to memberlist

Instructions:

Upload .gif from the Images folder into your images dir (in binary mode)
Upload the YaMSbars folder (incl. the bar .gifs) outside your cgi-bin dir (in binary mode)

Apply mod.
Upload (in ASCII mode):
english.lng
Settings.pl
YaBB.pl
Sources/Admin.pl
Sources/AdminEdit.pl
Sources/Display.pl
Sources/LogInOut.pl
Sources/Memberlist.pl
Sources/Profile.pl
Sources/Register.pl
Sources/Subs.pl

</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>


<edit file>
english.lng
</edit file>

<search for>
$txt{'373'} = "Members Per Page in Member List (All & by Letter)";
</search for>

<replace>
$txt{'373'} = "Members Per Page in Member List";
</replace>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>

$lngtxt{'01uc'} = "";  # Sepcial char1 uppercase, blank if none
$lngtxt{'01lc'} = "";  # Special char1 lowercase, blank if none
$lngtxt{'02uc'} = "";  # Special char2 uppercase, blank if none
$lngtxt{'02lc'} = "";  # Special char2 lowercase, blank if none
$lngtxt{'03uc'} = "";  # Special char3 uppercase, blank if none
$lngtxt{'03lc'} = "";  # Special char3 lowercase, blank if none

$membtxt{'01'} = "E-mail column";
$membtxt{'02'} = "Max. bar-length at";
$membtxt{'03'} = "Top poster";
$membtxt{'04'} = "500 posts";
$membtxt{'05'} = "100 posts";
$membtxt{'06'} = "ICQ column";
$membtxt{'07'} = "WWW column";
$membtxt{'08'} = "Registration-date";
$membtxt{'09'} = "Registration";
$membtxt{'10'} = "Posts";
$membtxt{'11'} = "Membergroups";
$membtxt{'12'} = "Default sorting column";
$membtxt{'13'} = "Member List";
$membtxt{'14'} = "Name";
$membtxt{'15'} = "MSN column";
$membtxt{'16'} = "MSN";
$membtxt{'17'} = "YIM column";
$membtxt{'18'} = "AIM column";
$membtxt{'19'} = "Add";
$membtxt{'20'} = "to your Buddy List";
$membtxt{'21'} = "Chat to";
$membtxt{'22'} = "Member Number column";
$membtxt{'23'} = "#";
$membtxt{'24'} = "Member Number";
$membtxt{'25'} = "Reset Member Numbers";
$membtxt{'26'} = "Members registered";
$membtxt{'27'} = "Heighest member number";
$membtxt{'28'} = "No need to reset member numbers.";
$membtxt{'29'} = "Warning! When you reset member numbers, some of your members will have a new number assigned.";
$membtxt{'30'} = "Latest IP";
$membtxt{'31'} = "IP address column (admin)";
$membtxt{'32'} = "Forum start";
$membtxt{'33'} = "Search by IP:";
$membtxt{'34'} = "Please enter valid IP";
$membtxt{'35'} = "No members found using this IP";
$membtxt{'36'} = "Viewing Members By IP";
$membtxt{'37'} = "Allow Guests to view Memberlist";
$membtxt{'38'} = "Member Number in Posts and Profile";
$membtxt{'39'} = "Bars";
$membtxt{'40'} = "Posts";
$membtxt{'41'} = "Absolute Path to your bars folder";
$membtxt{'42'} = "URL to your bars folder";
$membtxt{'43'} = "IM to";
$membtxt{'44'} = "IM column";
$membtxt{'45'} = "View";
$membtxt{'46'} = "Image";
$membtxt{'47'} = "Text";
$membtxt{'48'} = "name\@maildomain.com";
$membtxt{'49'} = "member site name";
$membtxt{'50'} = "IM to Member";
$membtxt{'51'} = "99999999";
$membtxt{'52'} = "yimnick";
$membtxt{'53'} = "aimnick";
$membtxt{'54'} = "Columns";

</add after>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'mem_online'} = qq~<nobr><img src="$imagesdir/greenon.gif" alt="$txt{'686'}" border="0" align="absmiddle">~;
	$img{'mem_offline'} = qq~<nobr><img src="$imagesdir/redoff.gif" alt="$txt{'687'}" border="0" align="absmiddle">~;
</add after>

<search for>
	$img{'website_sm'} = qq~<img src="$imagesdir/www.gif" alt="$txt{'515'}" border="0">~;
</search for>

<add after>
	$img{'mem_online'} = qq~<nobr><img src="$imagesdir/greenon.gif" alt="$txt{'686'}" border="0" align="absmiddle">~;
	$img{'mem_offline'} = qq~<nobr><img src="$imagesdir/redoff.gif" alt="$txt{'687'}" border="0" align="absmiddle">~;
</add after>


<edit file>
Settings.pl
</edit file>

<search for>
########## Colors ##########
</search for>

<add before>
$barsdir = "../../YaMSbars";						# Absolute Path to your bars folder
$barsurl = "http://www.mysite.com/YaMSbars";			# URL to your bars folder

</add before>

<search for>
########## Feature Settings ##########
</search for>

<add before>

########## Memberlist Settings ##########

$view_mailcolm = 1;							# Set to 0 to hide e-mail column in Memberlist
$view_wwwcolm = 1;							# Set to 0 to hide WWW column in Memberlist
$view_imcolm = 1;								# Set to 0 to hide IM column in Memberlist
$view_icqcolm = 1;							# Set to 0 to hide ICQ column in Memberlist
$view_yimcolm = 1;							# Set to 0 to hide YIM column in Memberlist
$view_aimcolm = 1;							# Set to 0 to hide AIM column in Memberlist
$mailcol = pic;								# Set to txt for text in e-mail column
$wwwcol = pic;								# Set to txt for text in WWW column
$imcol = pic;								# Set to txt for text in IM column
$icqcol = pic;								# Set to txt for text in ICQ column
$yimcol = pic;								# Set to txt for text in YIM column
$aimcol = pic;								# Set to txt for text in AIM column
$view_msncolm = 0;							# Set to 1 to view MSN column in Memberlist
$view_regdate = 1;							# Set to 0 to hide registration-date column in Memberlist
$view_numbcolm = 1;							# Set to 0 to hide member number column in Memberlist
$view_ipcolm = 1;								# Set to 0 to hide IP number column in Memberlist
$guest_allow = 1;								# Set to 0 to disallow guests to view Memberlist
$view_numb = 1;								# Set to 0 to hide member number in posts and profile
$barmaxdepend = 0;							# Select number of post for max. bar-length in memberlist
$defaultml = 1;								# Select default sort-column
$stfaultbar = CylDarkblue;						# Select Standard Bar-color in memberlist

</add before>


<edit file>
YaBB.pl
</edit file>

<search for>
&WriteLog;		# Write to the log
</search for>

<add after>
if($username ne "Guest") { &WriteYamLog; }	# Write to the YamLog
&LoadMembNumber;		# Load membernumbers
</add after>

<search for>
		elsif ($action eq 'mlall') { require "$sourcedir/Memberlist.pl"; &MLAll; }
</search for>

<add after>
		elsif ($action eq 'mlalldes') { require "$sourcedir/Memberlist.pl"; &MLAll; }
		elsif ($action eq 'mlalfa') { require "$sourcedir/Memberlist.pl"; &MLAll; }
		elsif ($action eq 'mlemail') { require "$sourcedir/Memberlist.pl"; &MLAll; }
		elsif ($action eq 'mlgrp') { require "$sourcedir/Memberlist.pl"; &MLAll; }
		elsif ($action eq 'mlpost') { require "$sourcedir/Memberlist.pl"; &MLAll; }
		elsif ($action eq 'mlipnum') { require "$sourcedir/Memberlist.pl"; &MLAll; }
		elsif ($action eq 'mlipsearch') { require "$sourcedir/Memberlist.pl"; &MLByIP; }
</add after>


<search for>
	elsif ($action eq 'rebuildmemlist') { require "$sourcedir/Admin.pl"; &RebuildMemList; }
</search for>

<add after>
	elsif ($action eq 'rebuildmemnumb') { require "$sourcedir/Admin.pl"; &RebuildMemNumb; }
	elsif ($action eq 'rebuildmemnumb2') { require "$sourcedir/Admin.pl"; &RebuildMemNumb2; }
</add after>


<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=membershiprecount">$txt{'504'}</a><br>
</search for>

<add after>
        - <a href="$cgi;action=rebuildmemnumb">$membtxt{'25'}</a><br>
</add after>

<search for>
        <td><img src="http://yabb.xnull.com/images/versioninfo/memberlistplver.gif"></td>
</search for>

<replace>
        <td><img src="http://www.cd-profil.dk/yabb/yamsplver.gif"></td>
</replace>


<search for>
sub ViewMembers {
</search for>

<add before>
sub RebuildMemNumb {
	&is_admin;
	fopen(FILE, "$memberdir/memberlist.txt");
	@memberlist = <FILE>;
	$memcount = @memberlist;
	fclose(FILE);
	fopen(FILE, "$memberdir/membernumb.txt");
	@membernumb = <FILE>;
	$numcount = @membernumb;
	fclose(FILE);
	$membxadmin = $memcount - 1;
	$numbxadmin = $numcount - 1;
$yymain .= qq~
<table border=0 width="300" cellspacing=1 cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/guest.gif" alt="" border="0">&nbsp;
    <font size=2 class="text1" color="$color{'titletext'}"><b>$membtxt{'25'}</b></font>
    </td>
  </tr>
  <tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <font size="2">
    $membtxt{'26'}: $membxadmin<BR>
    $membtxt{'27'}: $numbxadmin
    </font>
  </td>
  </tr>
~;
	if ($membxadmin == $numbxadmin) {
	$yymain .= qq~
	  <tr>
	    <td class="windowbg" bgcolor="$color{'windowbg'}">
	    <font size="2">
	    $membtxt{'28'}
	    </font>
	    </td>
	  </tr>
	~;
	}
	else {
	$yymain .= qq~
	  <tr>
	    <td class="windowbg" bgcolor="$color{'windowbg'}">
	    <font size="2">
	    $membtxt{'29'}
	    </font>
	    </td>
	  </tr>
	  <tr>
	    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center">
          <form action="$cgi;action=rebuildmemnumb2" method="POST">
          <input type=submit value="$membtxt{'25'}">
	    </form>
	    </td>
	  </tr>
	~;
	}
$yymain .= qq~
</table>
~;
	$yytitle = "$membtxt{'25'}";
	&template;
	exit;
}


sub RebuildMemNumb2 {
	&is_admin;
	if(-e "$memberdir/membernumb.txt") { unlink("$memberdir/membernumb.txt"); }
	&LoadMembNumber;
}

</add before>


<search for>
	unlink("$memberdir/$currentmem.imconfig");
</search for>

<add after>
	unlink("$memberdir/$currentmem.yam");
</add after>


<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
<form action="$cgi;action=modsettings2" method="POST">
</search for>

<replace>
<form action="$cgi;action=modsettings2" name="modsettings" method="POST">
</replace>

<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($sviewmailcolm, $sviewicqcolm, $sviewwwwcolm, $sviewimcolm, $sviewyimcolm, $sviewaimcolm, $sviewmsncolm, $sviewregcolm, $bmd1, $bmd2, $bmd3, $defml1, $defml2, $defml3, $defml4);
	my($sviewnumbcolm, $sviewipcolm, $sguest_allow, $sviewnumb, $smailpic, $smailtxt, $swwwpic, $swwwtxt, $simpic, $simtxt, $sicqpic, $sicqtxt, $syimpic, $syimtxt, $saimpic, $saimtxt);
</add after>

<search for>
	if ($timeselected == 6) { $tsl6 = " selected" } elsif ($timeselected == 5) { $tsl5 = " selected" } elsif ($timeselected == 4) { $tsl4 = " selected" } elsif ($timeselected == 3) { $tsl3 = " selected" } elsif ($timeselected == 2) { $tsl2 = " selected" } else { $tsl1 = " selected" }
</search for>

<add after>
	if ($barmaxdepend == 0) { $bmd1 = ' selected'; } elsif ($barmaxdepend == 1) { $bmd2 = ' selected'; } elsif( $barmaxdepend == 2 ) { $bmd3 = ' selected'; }
	if ($defaultml == 0) { $defml1 = ' selected'; } elsif ($defaultml == 1) { $defml2 = ' selected'; } elsif( $defaultml == 2 ) { $defml3 = ' selected'; } elsif( $defaultml == 3 ) { $defml4 = ' selected'; }
	if ($view_mailcolm) { $sviewmailcolm = 'checked' }
	if ($view_icqcolm) { $sviewicqcolm = 'checked' }
	if ($view_wwwcolm) { $sviewwwwcolm = 'checked' }
	if ($view_imcolm) { $sviewimcolm = 'checked' }
	if ($view_yimcolm) { $sviewyimcolm = 'checked' }
	if ($view_aimcolm) { $sviewaimcolm = 'checked' }
	if ($view_msncolm) { $sviewmsncolm = 'checked' }
	if ($view_regdate) { $sviewregcolm = 'checked' }
	if ($view_numbcolm) { $sviewnumbcolm = 'checked' }
	if ($view_numb) { $sviewnumb = 'checked' }
	if ($view_ipcolm) { $sviewipcolm = 'checked' }
	if ($guest_allow) { $sguest_allow = 'checked' }
	if ($mailcol eq "pic") { $smailpic = 'checked' } else { $smailtxt = 'checked' }
	if ($wwwcol eq "pic") { $swwwpic = 'checked' } else { $swwwtxt = 'checked' }
	if ($imcol eq "pic") { $simpic = 'checked' } else { $simtxt = 'checked' }
	if ($icqcol eq "pic") { $sicqpic = 'checked' } else { $sicqtxt = 'checked' }
	if ($yimcol eq "pic") { $syimpic = 'checked' } else { $syimtxt = 'checked' }
	if ($aimcol eq "pic") { $saimpic = 'checked' } else { $saimtxt = 'checked' }
</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'363'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="imagesdir" size="45" value="$imagesdir"></td>
</search for>

<add after>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'41'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="barsdir" size="30" value="$barsdir"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'42'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="barsurl" size="45" value="$barsurl"></td>
</add after>

<search for>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'372'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="TopAmmount" size="5" value="$TopAmmount"></td>
</search for>

<replace>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/guest.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>$membtxt{'13'}</b></font></td>
  </tr><tr>
    <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <table width="100%" border="0" cellspacing="0" cellpadding="4" align="left">
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'54'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'45'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'46'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'47'}</b></font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'01'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mailcolm" $sviewmailcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="pic" $smailpic> <img src="$imagesdir/email.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="txt" $smailtxt> <font size="2">$membtxt{'48'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'07'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_wwwcolm" $sviewwwwcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="wwwcol" value="pic" $swwwpic> <img src="$imagesdir/www.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="wwwcol" value="txt" $swwwtxt> <font size="2">$membtxt{'49'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'44'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_imcolm" $sviewimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="imcol" value="pic" $simpic> <img src="$imagesdir/message.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="imcol" value="txt" $simtxt> <font size="2">$membtxt{'50'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'06'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_icqcolm" $sviewicqcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="icqcol" value="pic" $sicqpic> <img src="$imagesdir/icqflow.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="icqcol" value="txt" $sicqtxt> <font size="2">$membtxt{'51'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'17'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_yimcolm" $sviewyimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="yimcol" value="pic" $syimpic> <img src="$imagesdir/yim.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="yimcol" value="txt" $syimtxt> <font size="2">$membtxt{'52'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'18'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_aimcolm" $sviewaimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="aimcol" value="pic" $saimpic> <img src="$imagesdir/aim.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="aimcol" value="txt" $saimtxt> <font size="2">$membtxt{'53'}</font></td>
    </tr>
    ~;
    if(-e "$sourcedir/Msn.pl") {
    $yymain .= qq~
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'15'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_msncolm" $sviewmsncolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr>
    ~;
    }
    $yymain .= qq~
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'08'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_regdate" $sviewregcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'22'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_numbcolm" $sviewnumbcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'31'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_ipcolm" $sviewipcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'12'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="defaultml" size=1>
    <option value="0"$defml1>$membtxt{'09'}
    <option value="1"$defml2>$membtxt{'10'}
    <option value="2"$defml3>$membtxt{'14'}
    <option value="3"$defml4>$membtxt{'11'}
    </select>
    </td>
  </tr><tr>
    <td colspan="4" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'39'}:</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'02'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="barmaxdepend" size=1>
    <option value="0"$bmd1>$membtxt{'03'}
    <option value="1"$bmd2>$membtxt{'04'}
    <option value="2"$bmd3>$membtxt{'05'}
    </select>
    </td>
~;
	opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
	@contents = readdir(DIR);
	closedir(DIR);
	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $stfaultbar) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}
if(-e "$sourcedir/MemberGroups.pl") {
	$yymain .= qq~
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$MemStatNewbie</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	~;
}
else {
	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	chomp @membergroups;
	$yymain .= qq~
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[2]</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	~;
}
$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar() {
   document.images.icons.src="$barsurl/"+document.modsettings.defbar.options[document.modsettings.defbar.selectedIndex].value+".gif";
}
//-->
</script>
        <select name="defbar" onChange="showbar()">$bars</select>
        <img src="$barsurl/$stfaultbar.gif" name="icons" border=0 hspace=15>
    </td>

~;

	@defaultbar=();

if(-e "$sourcedir/MemberGroups.pl") {

	if (!-e "$vardir/barcolor.dat") {

		fopen(FILE, ">$vardir/barcolor.dat", 1);
		$i = 0;
		while($MemStat[$i]) {
			print FILE "CylBlue\n";
			$i++
		}
		fclose(FILE);
	}

	fopen(FILE, "$vardir/barcolor.dat");
	@defaultbar=<FILE>;
	fclose(FILE);
	chomp(@defaultbar);

	$taller = 0;

	while($MemStat[$taller]) {

		if($MemPostNum[$taller] ne 'x') {

			opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
			@contents = readdir(DIR);
			closedir(DIR);
			$bars = "";
			foreach $line (sort @contents){
				($name, $extension) = split (/\./, $line);
				$checked = "";
				if ($name eq $defaultbar[$taller]) { $checked = ' selected'; }
				if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
			}

			$yymain .= qq~

			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function showbar$taller() {
			   document.images.icons$taller.src="$barsurl/"+document.modsettings.barsel$taller.options[document.modsettings.barsel$taller.selectedIndex].value+".gif";
			}
			//-->
			</script>

		  </tr><tr>
		    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$MemStat[$taller]</font> <font size="1">($MemPostNum[$taller] $membtxt{'40'})</font></td>
		    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		        <select name="barsel$taller" onChange="showbar$taller()">$bars</select>
		        <img src="$barsurl/$defaultbar[$taller].gif" name="icons$taller" border=0 hspace=15>
		    </td>
			~;
		}
		$taller++;
	}
}
else {

	if (!-e "$vardir/barcolor.dat") {

		fopen(FILE, ">$vardir/barcolor.dat", 1);
		for($i=0;$i<4;$i++) {
			print FILE "CylBlue\n";
		}
		fclose(FILE);
	}

	fopen(FILE, "$vardir/barcolor.dat");
	@defaultbar=<FILE>;
	fclose(FILE);
	chomp(@defaultbar);

	opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
	@contents = readdir(DIR);
	closedir(DIR);

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[0]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar1() {
   document.images.icons1.src="$barsurl/"+document.modsettings.defbar1.options[document.modsettings.defbar1.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[3]</font> <font size="1">($JrPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar1" onChange="showbar1()">$bars</select>
		<img src="$barsurl/$defaultbar[0].gif" name="icons1" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[1]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar2() {
   document.images.icons2.src="$barsurl/"+document.modsettings.defbar2.options[document.modsettings.defbar2.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[4]</font> <font size="1">($FullPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar2" onChange="showbar2()">$bars</select>
		<img src="$barsurl/$defaultbar[1].gif" name="icons2" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[2]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar3() {
   document.images.icons3.src="$barsurl/"+document.modsettings.defbar3.options[document.modsettings.defbar3.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[5]</font> <font size="1">($SrPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar3" onChange="showbar3()">$bars</select>
		<img src="$barsurl/$defaultbar[2].gif" name="icons3" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[3]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar4() {
   document.images.icons4.src="$barsurl/"+document.modsettings.defbar4.options[document.modsettings.defbar4.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[6]</font> <font size="1">($GodPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar4" onChange="showbar4()">$bars</select>
		<img src="$barsurl/$defaultbar[3].gif" name="icons4" border=0 hspace=15>
    </td>

~;

}

$yymain .= qq~
  </tr><tr>
    <td colspan="4" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
</replace>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'373'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="MembersPerPage" size="5" value="$MembersPerPage"></td>
</search for>

<replace>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'37'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="guest_allow" $sguest_allow></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'38'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_numb" $sviewnumb></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'373'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="MembersPerPage" size="5" value="$MembersPerPage"></td>
    </tr>
    </table></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>YaMS 4.0</I></b> &nbsp;</font></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
</replace>

<search for>
	# Set as 0 or 1 if box was checked or not
</search for>

<add before>
	push(@onoff, "view_mailcolm", "view_wwwcolm", "view_imcolm", "view_icqcolm", "view_yimcolm", "view_aimcolm", "view_msncolm", "view_regdate", "barmaxdepend", "defaultml");
	push(@onoff, "view_numbcolm", "view_ipcolm", "guest_allow", "view_numb", "defbar", "mailcol", "wwwcol", "imcol", "icqcol", "yimcol", "aimcol");
</add before>

<search for>
	$guestaccess = $guestaccess ? 0 : 1;
</search for>

<add after>
fopen( FILE, ">$vardir/barcolor.dat", 1);
if(-e "$sourcedir/MemberGroups.pl") {
	$taller = 0;
	while($MemStat[$taller]) {
		if($MemPostNum[$taller] ne 'x') {
			$defaultbar[$taller] = $FORM{"barsel$taller"} || 'CylBlue';
			print FILE "$defaultbar[$taller]\n";
		}
		else { print FILE "CylBlue\n"; }
		$taller++
	}
}
else {
	$defaultbar[0] = $FORM{"defbar1"} || 'CylBlue';
	$defaultbar[1] = $FORM{"defbar2"} || 'CylBlue';
	$defaultbar[2] = $FORM{"defbar3"} || 'CylBlue';
	$defaultbar[3] = $FORM{"defbar4"} || 'CylBlue';
	print FILE "$defaultbar[0]\n";
	print FILE "$defaultbar[1]\n";
	print FILE "$defaultbar[2]\n";
	print FILE "$defaultbar[3]\n";
}
fclose(FILE);
</add after>

<search for>
	$imagesdir = $FORM{'imagesdir'} || "$boardurl/YaBBImages";
</search for>

<add after>
	$barsdir = $FORM{'barsdir'} || "../YaMSbars";
	$barsurl = $FORM{'barsurl'} || "$boardurl/YaMSbars";
</add after>

<search for>
	$timeselected = $FORM{'timeselect'} || 0;
</search for>

<add after>
	$mailcol = $FORM{'mailcol'} || 'pic';
	$wwwcol = $FORM{'wwwcol'} || 'pic';
	$imcol = $FORM{'imcol'} || 'pic';
	$icqcol = $FORM{'icqcol'} || 'pic';
	$yimcol = $FORM{'yimcol'} || 'pic';
	$aimcol = $FORM{'aimcol'} || 'pic';
	$barmaxdepend = $FORM{'barmaxdepend'} || 0;
	$defaultml = $FORM{'defaultml'} || 0;
	$stfaultbar = $FORM{'defbar'} || 'CylBlue';
</add after>

<search for>
\$imagesdir = "$imagesdir";				# URL to your images folder
</search for>

<add after>
\$barsdir = "$barsdir";					# Absolute Path to your YaMS bars folder
\$barsurl = "$barsurl";					# URL to your YaMS bars folder
</add after>

<search for>
\$allow_hide_email = $allow_hide_email;			# Allow users to hide their email from public. Set 0 to disable
</search for>

<add after>
\$view_mailcolm = $view_mailcolm;	     			# Set to 0 to hide e-mail column in Memberlist
\$view_wwwcolm = $view_wwwcolm;	     			# Set to 0 to hide WWW column in Memberlist
\$view_imcolm = $view_imcolm;	   	  			# Set to 0 to hide IM column in Memberlist
\$view_icqcolm = $view_icqcolm;	     			# Set to 0 to hide ICQ column in Memberlist
\$view_yimcolm = $view_yimcolm;	     			# Set to 0 to hide YIM column in Memberlist
\$view_aimcolm = $view_aimcolm;	     			# Set to 0 to hide AIM column in Memberlist
\$mailcol = $mailcol;						# Set to txt for text in e-mail column
\$wwwcol = $wwwcol;						# Set to txt for text in WWW column
\$imcol = $imcol;							# Set to txt for text in IM column
\$icqcol = $icqcol;						# Set to txt for text in ICQ column
\$yimcol = $yimcol;						# Set to txt for text in YIM column
\$aimcol = $aimcol;						# Set to txt for text in AIM column
if(-e "$sourcedir/Msn.pl") {
	\$view_msncolm = $view_msncolm;	     		# Set to 0 to hide MSN column in Memberlist
}
\$view_regdate = $view_regdate;	     			# Set to 0 to hide registration-date column in Memberlist
\$view_numbcolm = $view_numbcolm;	     			# Set to 0 to hide member number column in Memberlist
\$view_ipcolm = $view_ipcolm;	     				# Set to 0 to hide IP number column in Memberlist
\$guest_allow = $guest_allow;	     				# Set to 0 to disallow guests to view Memberlist
\$view_numb = $view_numb;		     			# Set to 0 to hide member number in posts and profile
\$barmaxdepend = $barmaxdepend;				# Select number of post for max. bar-length in memberlist
\$defaultml = $defaultml;					# Select default sort-column
\$stfaultbar = $stfaultbar;					# Select Standard Bar-color in memberlist
</add after>


<edit file>
Sources/Display.pl
</edit file>


<search for>
			$star = $memberstar{$musername};
</search for>

<add before>
			fopen(NUMBERFILEREAD,"$memberdir/$musername.yam");
			@number = <NUMBERFILEREAD>;
			fclose(NUMBERFILEREAD);
			chomp @number;
			if ($musername eq "admin") { $displaynumb = ''; }
			else { $displaynumb = qq~$membtxt{'23'} $number[0]~; }
</add before>

<search for>
			$musername = "Guest";
</search for>

<add after>
			$displaynumb = '';
</add after>

<search for>
            $star<BR><BR>
</search for>

<replace>
            $star<BR>
~;
if ($view_numb) {
	$yymain .= qq~
		$displaynumb<BR><BR>
	~;
}
else {
	$yymain .= qq~
		<BR>
	~;
}
$yymain .= qq~
</replace>


<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
	&WriteLog;
</search for>

<add after>
	&WriteYamLog;
</add after>


<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
$memberlistplver = "1 Gold - SP 1.1";
</search for>

<replace>
$memberlistplver = "1 Gold SP 1.1 - YaMS 4.0";
</replace>

<search for>
if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
</search for>

<replace>
if($username eq "Guest" && !$guest_allow) { &fatal_error("$txt{'223'}"); }
</replace>

<search for>
if($action eq "mlall") { $Sort .= qq($txt{'303'} | ); } else { $Sort .= qq(<a href="$cgi;action=mlall"><font size=2 class="text1" color="$color{'titletext'}">$txt{'303'}</font></a> | ); }
if($action eq "mlletter") { $Sort .= qq($txt{'304'} | ); } else { $Sort .= qq(<a href="$cgi;action=mlletter"><font size=2 class="text1" color="$color{'titletext'}">$txt{'304'}</font></a> | ); }
if($action eq "mltop") { $Sort .= qq($txt{'305'} $txt{'411'} $TopAmmount $txt{'306'}); } else { $Sort .= qq(<a href="$cgi;action=mltop"><font size=2 class="text1" color="$color{'titletext'}">$txt{'305'} $txt{'411'} $TopAmmount $txt{'306'}</font></a>); }

if($action eq "mlletter") {
	$page = "a"; $showpage = "A";
	while($page ne "z") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$page">$showpage&nbsp;</a> );
		$page++; $showpage++;
	}
	$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=z">Z</a> );
}

$TableHeader .= qq(
<table border=0 width=100% cellspacing=1 cellspacing="4" bgcolor="$color{'bordercolor'}" class="bordercolor">
<tr>
	<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="7"><b><font size=2 class="text1" color="$color{'titletext'}">$Sort</font></b></td>
</tr>
);
if($LetterLinks ne "") {
	$TableHeader .= qq(<tr>
		<td class="catbg" bgcolor="$color{'catbg'}" colspan="7"><b><font size=2>$LetterLinks</td>
	</tr>
	);
}
$TableHeader .= qq(<tr>
	<td class="catbg" bgcolor="$color{'catbg'}" width="200"><b><font size=2>$txt{'35'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}"><b><font size=2>$txt{'307'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}"><b><font size=2>$txt{'96'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}"><b><font size=2>$txt{'86'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}"><b><font size=2>$txt{'87'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}"><b><font size=2>$txt{'21'}</font></b></td>
</tr>
);
</search for>

<replace>
if($mailcol eq "pic") { $mailhdr .= qq(<IMG SRC="$imagesdir/email.gif" border="0" align="absmiddle" alt="$txt{'307'}">); } else { $mailhdr = "$txt{'307'}" }
if($wwwcol eq "pic") { $wwwhdr .= qq(<IMG SRC="$imagesdir/www.gif" border="0" align="absmiddle" alt="$txt{'515'}">); } else { $wwwhdr = "$txt{'515'}" }
if($imcol eq "pic") { $imhdr .= qq(<IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'321'}">); } else { $imhdr = "$txt{'321'}" }
if($icqcol eq "pic") { $icqhdr .= qq(<IMG SRC="$imagesdir/icqflow.gif" border="0" align="absmiddle" alt="$txt{'513'}">); } else { $icqhdr = "$txt{'513'}" }
if($yimcol eq "pic") { $yimhdr .= qq(<IMG SRC="$imagesdir/yim.gif" border="0" align="absmiddle" alt="$txt{'604'}">); } else { $yimhdr = "$txt{'604'}" }
if($aimcol eq "pic") { $aimhdr .= qq(<IMG SRC="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$txt{'603'}">); } else { $aimhdr = "$txt{'603'}" }

if($action eq "mlall") { 
	$sortorder = 0; 
	$smb1 = ' selected'; 
	$mlcall = "mlall"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $txt{'233'} <a href="$cgi;action=mlalldes"><IMG SRC="$imagesdir/des.gif" border="0" align="absmiddle"></a></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlalldes") { 
	$sortorder = 1; 
	$smb1 = ' selected'; 
	$mlcall = "mlalldes"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $txt{'233'} <a href="$cgi;action=mlall"><IMG SRC="$imagesdir/ass.gif" border="0" align="absmiddle"></a></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlpost") { 
	$smb2 = ' selected'; 
	$mlcall = "mlpost"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $txt{'86'} <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlgrp") { 
	$smb3 = ' selected'; 
	$mlcall = "mlgrp"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $txt{'87'} <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlalfa") { 
	$smb4 = ' selected'; 
	$mlcall = "mlalfa"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $txt{'68'} <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlletter") { 
	$smb4 = ' selected'; 
	$mlcall = "mlalfa"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlipnum") { 
	$smb5 = ' selected'; 
	$mlcall = "mlipnum"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $membtxt{'30'} <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlipsearch") { 
	$smb5 = ' selected'; 
	$mlcall = "mlipsearch"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a><IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlemail">$mailhdr</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
}
if($action eq "mlemail") { 
	$smb6 = ' selected'; 
	$mlcall = "mlemail"; 
	$reglink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlall">$txt{'233'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$alfalink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlalfa">$txt{'68'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$grplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlgrp">$txt{'87'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$postlink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlpost">$txt{'86'}</a><IMG SRC=$imagesdir/fill.gif></nobr>); 
	$iplink .= qq(<nobr><IMG SRC=$imagesdir/sort.gif> <a href="$cgi;action=mlipnum">$membtxt{'30'}</a> <IMG SRC=$imagesdir/fill.gif></nobr>); 
	$emaillink .= qq(<nobr><IMG SRC=$imagesdir/sorted.gif> $txt{'307'} <IMG SRC=$imagesdir/fill.gif></nobr>); 
}

if($settings[7] ne 'Global Moderator' ) { $allow_mod = 0; }

if ($barmaxdepend == 0) { $bmd1 = ' selected'; }
elsif ($barmaxdepend == 1) { $bmd2 = ' selected'; }
elsif ($barmaxdepend == 2) { $bmd3 = ' selected'; }

$barmax = 100;

if($bmd1)	{
	%TopMembers = ();
	
	fopen(MEMBERLISTREAD,"$memberdir/memberlist.txt");
		@member = ();
		while(chomp($membername=<MEMBERLISTREAD>)) {
			fopen(MEMBERFILE,"$memberdir/$membername.dat");
				@member = <MEMBERFILE>;
			fclose(MEMBERFILE);
			chomp @member;
	
			$TopMembers{$membername} = $member[6];
		}
	fclose(MEMBERLISTREAD);
	
	my @topbar = sort {$TopMembers{$a} <=> $TopMembers{$b}} keys %TopMembers;
	@topbar = reverse @topbar;
	
		@member = ();
		$membername = @topbar[0];
		fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
			@member = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		&FormatUserName($membername);
		chomp @member;
		if($member[6] > 0) {
			$barmax = ($member[6]);
		}
		else { $barmax = 1; }
}
elsif($bmd2)	{
	$barmax = 500;
}

if($smb4) {
	$page = "a"; $showpage = "A";
	while($page ne "z") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$page">$showpage&nbsp;</a> );
		$page++; $showpage++;
	}
	$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=z">Z&nbsp;</a> );
	if($lngtxt{'01uc'} ne "") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$lngtxt{'01lc'}">$lngtxt{'01uc'}&nbsp;</a> );
	}
	if($lngtxt{'02uc'} ne "") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$lngtxt{'02lc'}">$lngtxt{'02uc'}&nbsp;</a> );
	}
	if($lngtxt{'03uc'} ne "") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$lngtxt{'03lc'}">$lngtxt{'03uc'}</a> );
	}
}


$membspan = "5";
if ($mlcall ne "mlemail") {
	if ($view_mailcolm)	{ $membspan++; }
	if ($view_wwwcolm)	{ $membspan++; }
	if ($view_imcolm)		{ $membspan++; }
	if ($view_icqcolm)	{ $membspan++; }
	if ($view_yimcolm)	{ $membspan++; }
	if ($view_aimcolm)	{ $membspan++; }
	if ($view_msncolm)	{ $membspan++; }
}
else {
	$membspan++;
	$membspan++;
	$membspan++;
 }

if ($view_regdate) {
	$membspan++;
}
if ($view_numbcolm) {
	$membspan++;
}
if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
	$membspan++;
}


if(-e "$sourcedir/Msn.pl") {
	$TableHeader .= qq(
	<object classid="clsid:F3A614DC-ABE0-11d2-A441-00C04F795683" codebase="#Version=2,0,0,83" codetype=application/x-oleobject id=MsgrObj width=0 height=0>
	</object>
	<OBJECT classid="clsid:FB7199AB-79BF-11d2-8D94-0000F875C541" codeType=application/x-oleobject id=MsgrApp width=0 height=0></OBJECT>
	<SCRIPT LANGUAGE="JavaScript">           
	<!--            
	function stopError() {             return true;           }            
	window.onerror = stopError;            
	// -->
	</script>
	);
}

$TableHeader .= qq(
<table border=0 width=100% cellspacing=1 cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor">
);

if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
	$TableHeader .= qq(<tr>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="right" valign="middle" colspan=$membspan>
			<form action="$scripturl?action=mlipsearch" method="post" name="searchipform">
			<table align=right border=0 cellspacing=0 cellpadding=4>
			<tr>
			<td align="right">
				<font size=2>$membtxt{'33'}&nbsp;</font>
			</td>
			<td>
				<input type=text size=20 name="searchip">
			</td>
			<td>
				<input type="submit" name="submit" value="$txt{'462'}">
			</td>
			</tr>
			</table>
			</form>
			<script language="JavaScript"> <!--
			document.searchipform.searchip.focus();
			//--> </script>
		</td>
	</tr>
	);
}

if($LetterLinks ne "") {
	$TableHeader .= qq(<tr>
		<td class="catbg" bgcolor="$color{'catbg'}" colspan=$membspan><b><font size=2>$LetterLinks</b></font></td>
	</tr>
	);
}
$TableHeader .= qq(<tr>
	<td class="catbg" bgcolor="$color{'catbg'}" align="center" width="20"><IMG SRC="$imagesdir/login.gif" border="0" alt="$txt{'686'} \- $txt{'687'}"></td>
	<td class="catbg" bgcolor="$color{'catbg'}" align="center"><b><font size=2>$alfalink</font></b></td>
	);

	if ($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
		if ($view_mailcolm && $mlcall ne "mlemail")	{
		$TableHeader .= qq(
			<td class="catbg" bgcolor="$color{'catbg'}" align="center">$emaillink</td>
		);
		}
	
		if ($mlcall eq "mlemail")	{
		$TableHeader .= qq(
			<td colspan="3" class="catbg" bgcolor="$color{'catbg'}" align="center">$emaillink</td>
		);
		}
	}
	else {
		if ($view_mailcolm)	{
		$TableHeader .= qq(
			<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$mailhdr&nbsp;</td>
		);
		}
	}

	if ($view_wwwcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
	<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$wwwhdr&nbsp;</td>
	);
	}
	if ($view_imcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$imhdr&nbsp;</td>
	);
	}
	if ($view_icqcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$icqhdr&nbsp;</td>
	);
	}
	if ($view_yimcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$yimhdr&nbsp;</td>
	);
	}
	if ($view_aimcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;$aimhdr&nbsp;</td>
	);
	}
	if ($view_msncolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center">&nbsp;<IMG SRC="$imagesdir/msn.gif" border="0" align="absmiddle" alt="$membtxt{'16'}">&nbsp;</td>
	);
	}
$TableHeader .= qq(
	<td class="catbg" bgcolor="$color{'catbg'}" align="center"><b><font size=2>$grplink</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" colspan="2" align="center"><b><font size=2>$postlink</font></b></td>
	);
	if ($view_regdate)	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center"><b><font size=2>$reglink</font></b></td>
	);
	}
	if ($view_numbcolm)	{
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center"><b><font size=2>$membtxt{'23'}</font></b></td>
	);
	}
	if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
	$TableHeader .= qq(
		<td class="catbg" bgcolor="$color{'catbg'}" align="center"><b><font size=2>$iplink</font></b></td>
	);
	}
$TableHeader .= qq(
</tr>
);
</replace>

<search for>
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
</search for>

<replace>
	if($username eq "Guest" && !$guest_allow) { &fatal_error("$txt{'223'}"); }
</replace>

<search for>
	# Get the number of members
	fopen(FILE, "$memberdir/memberlist.txt");
	@memberlist = <FILE>;
	$memcount = @memberlist;
	@membername = @memberlist;
	fclose(FILE);
</search for>

<add after>
	if($smb1)	{
		&SortMemb;
		if($sortorder == 1) { 
			@membername = reverse @sortmembername;
		}
		else {
			@membername = @sortmembername;
		}
	}
	elsif($smb3)	{
		&SortGrpMemb;
		@membername = @grpmemberlist;
	}
	else	{
		&SortMemb;
		@membername = @sortmembername;
	}

	$stopflag = 0;
	$firstgrp= "";
	$firstlett = "";
</add after>

<search for>
		$name = $membername[$b];
		$b++;
</search for>


<add after>
		$hjsite = "";
		@entries = ();
</add after>

<search for>
		@member = ();
		$Bar = "";
		$ICQ = "";
		fopen(MEMBERFILEREAD,"$memberdir/$name.dat");
		@member = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @member;
</search for>

<add after>
		$viewipnumb = "";
		fopen(NUMBERFILEREAD,"$memberdir/$name.yam");
		@number = <NUMBERFILEREAD>;
		fclose(NUMBERFILEREAD);
		chomp @number;
		if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
			($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
			if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
			else {
				$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
				if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
				if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
			}
		}
		if ($number[0] == 0) { $number[0] = "&nbsp;"; }
		($e_name, $e_dom) = split(/\@/, $member[2]);
</add after>


<search for>
		$barchart = ($member[6] / 5);
		if ($barchart < 1) {$Bar = "$Bar";}
		elsif ($barchart > 100) {
			$Bar = qq~<img src="$imagesdir/bar.gif" width=100 height=15 alt="" border="0">~;
		}
		else {
			$Bar = qq~<img src="$imagesdir/bar.gif" width=$barchart height=15 alt="" border="0">~;
		}
</search for>


<replace>
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
		chomp @membergroups;
		if(!-e "$sourcedir/MemberGroups.pl") {
			if($member[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
			elsif($member[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
			elsif($member[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
			elsif($member[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
			else { $memberinfo = "$membergroups[2]"; }
		}
		else {
			$memstatcount = "0";
			if( $member[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
			while($MemStat[$memstatcount]) {
				if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
					$memberinfo = "$MemStat[$memstatcount]"; 
				}
				$memstatcount++;
			}
		}
		$memberinfo =~ s/\n//gi;
		$Bargif = "";
		$barchart = ($member[6]);
		$bartemp = ($member[6] * 100);
		$barwidth = ($bartemp / $barmax);
		$barwidth = ($barwidth + 0.5);
		$barwidth = int($barwidth);
		if($barwidth > 100) {$barwidth = 100}
		
		fopen(FILE, "$vardir/barcolor.dat");
		@grpbar=<FILE>;
		fclose(FILE);
		chomp(@grpbar);

		if(!-e "$sourcedir/MemberGroups.pl") {
			if ($barchart >= $GodPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[3].gif'";
			}
			elsif ($barchart >= $SrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[2].gif'";
			}
			elsif ($barchart >= $FullPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[1].gif'";
			}
			elsif ($barchart >= $JrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[0].gif'";
			}
			else {
				$Bargif = "img src='$barsurl/$stfaultbar.gif'";
			}
		}
		else {
			$membarcount = 0;
			$Bargif .= qq(img src="$barsurl/$stfaultbar.gif");
			while($MemStat[$membarcount]) {
				if($barchart >= $MemPostNum[$membarcount] && $MemPostNum[$membarcount] ne 'x') {
					$Bargif = "";
					$Bargif .= qq(img src="$barsurl/$grpbar[$membarcount].gif");
				}
				$membarcount++;
			}
		}
		
		if ($barwidth < 1) {$Bar = "$Bar";}
		else {
			$Bar = qq~<$Bargif width=$barwidth height=10 alt="$memberinfo" border="0">~;
		}
</replace>


<search for>
		if ($Bar eq "") { $Bar="&nbsp;"; }
		if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

		if($member[7] eq "Administrator") { $member[7] = "$membergroups[0]"; }
</search for>


<replace>
		if ($Bar eq "") { $Bar="&nbsp;"; }
		if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

		if($member[7] eq "Administrator") { $member[7] = "$MemStatAdmin"; }
		if($member[7] eq "Global Moderator") { $member[7] = "$MemStatGMod"; }

		if($member[7] eq "") { $member[7] = "$memberinfo"; }

			if ($username eq "Guest" && $guest_allow) {
				if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~; 
								  $mailjust = "center"; }
				else				{ $mailpic = "$txt{'722'}";
								  $mailjust = "left"; }
			}
			else {
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
					~;
					if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
									  $mailjust = "center"; }
					else				{ $mailpic = "$txt{'722'}";
									  $mailjust = "left"; }
				}
				else {
					if($mailcol eq "pic")	{ $mailpic = qq~<a href="mailto:$member[2]"><IMG SRC="$imagesdir/email.gif" border="0" alt="$member[2]"></a>~;
									  $mailjust = "center"; }
					else				{ $mailpic = qq~<a href="mailto:$member[2]">$member[2]</a>~;
									  $mailjust = "left"; }
				}
			}



		if($member[4] eq "")	{ $hjsite = "&nbsp;"; }
		elsif($wwwcol eq "pic")	{ $hjsite = qq~<a href="$member[4]" target="_blank"><img src="$imagesdir/www.gif" border="0" align="absmiddle" alt="$member[3]"></a>~;
						  $wwwjust = "center"; }
		else				{ $hjsite = qq~<a href="$member[4]" target="_blank">$member[3]</a>~;
						  $wwwjust = "left"; }

		if($imcol eq "pic")	{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}"><IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'148'} $txt{'311'} $member[1]"></a>~;
						  $imjust = "center"; }
		else				{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}">$membtxt{'43'} $member[1]</a>~;
						  $imjust = "left"; }

		if( $member[8] ne "" && $member[8] !~ m~\D~ ) {
		$ICQ = $member[8];
		if($icqcol eq "pic")	{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> </a>~;
						  $icqjust = "center"; }
		else				{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> $member[8]</a>~;
						  $icqjust = "left"; }
		}
		else				{ $icqimg = "&nbsp;" }

            if ($member[10] eq '')	{ $yimimg = "&nbsp"; }
		elsif($yimcol eq "pic")	{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"></a>~;
						  $yimjust = "center"; }
		else				{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"> $member[10]</a>~;
						  $yimjust = "left"; }

            if ($member[9] eq '')	{ $aimimg = "&nbsp"; }
		elsif($aimcol eq "pic")	{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"></a>~;
						  $aimjust = "center"; }
		else				{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"> $member[9]</a>~;
						  $aimjust = "left"; }

		if(-e "$sourcedir/Msn.pl") {
			fopen(FILE, "$memberdir/$name.om"); 
			@msnsettings = <FILE>;
			fclose <FILE>;
			chomp @msnsettings;
		}

		$dr = "";
		if ($member[14] eq "") { $dr = "$txt{'470'}"; }
		else { $dr = "$member[14]"; $dr = &timeformat($dr); }
		if ($number[0] eq "&nbsp;") { $dr = "$membtxt{'32'}"; }

		$onlinemem = $img{'mem_offline'};
		fopen(FILE, "$vardir/log.txt");
		@entries = <FILE>;
		fclose(FILE);
		foreach $curentry (@entries) {
			chomp $curentry;
			($onname, $onvalue) = split(/\|/, $curentry);
			if(lc $onname eq lc $name) { $onlinemem = $img{'mem_online'}; }
		}
</replace>

<search for>
		if($tempname)
		{
</search for>

<add after>
			if($smb3) {
				if($member[7] ne "") {
					$startgrp = $member[7];
					if($startgrp ne $firstgrp) {
						$firstgrp = $startgrp;
						$yymain .= qq~ 
						<tr>
							<td class="catbg" bgcolor="$color{'catbg'}" colspan=$membspan><font size=1>&nbsp; $startgrp</font></td>
						</tr>
								~;
					}
				}
				elsif($stopflag == 0) {
					$yymain .= qq~ 
					<tr>
						<td class="catbg" bgcolor="$color{'catbg'}" colspan=$membspan><font size=1>&nbsp;</font></td>
					</tr>
							~;
					$stopflag = 1;
				}
			}

			if($smb4) {
				$startlett = substr $member[1],0,1;
				if($startlett eq "$lngtxt{'01lc'}") {$startlett = "$lngtxt{'01uc'}";}
				if($startlett eq "$lngtxt{'02lc'}") {$startlett = "$lngtxt{'02uc'}";}
				if($startlett eq "$lngtxt{'03lc'}") {$startlett = "$lngtxt{'03uc'}";}
				$startlett = uc $startlett;
				if($startlett ne $firstlett) {
					$firstlett = $startlett;
					$yymain .= qq~ 
					<tr>
						<td class="catbg" bgcolor="$color{'catbg'}" colspan=$membspan><font size=1>&nbsp; $startlett</font></td>
					</tr>
					~;
				}
			}
</add after>

<search for>
				<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$name}">$member[1]</a></font></td>
				~;
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
				~; } else { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
				~; }
				$yymain .= qq~
				<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$member[4]" target="_blank">$member[3]</a></font>&nbsp;</td>
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>$member[6]</font>&nbsp;</td>
				<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>$member[7]</font>&nbsp;</td>
				<td class="windowbg" bgcolor="$color{'windowbg'}">$Bar</td>
</search for>


<replace>
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$onlinemem</td>
				<td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$name}">$member[1]</a></font></td>
				~;
				if ($view_mailcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
					~;
				}
				if ($mlcall eq "mlemail")	{
				if ($settings[7] ne "Administrator" && $member[19] eq "checked" &&  $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
						<td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$txt{'722'}</td>
					~; } else { $yymain .= qq~
						<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="right" valign="middle">
							<font size=2><nobr><a href="mailto:$member[2]">$e_name</a></nobr></font>
						</td>
						<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
							<font size=2><nobr><a href="mailto:$member[2]">@</a></nobr></font>
						</td>
						<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" valign="middle">
							<font size=2><nobr><a href="mailto:$member[2]">$e_dom</a></nobr></font>
						</td>
					~; }
				}

				if ($view_wwwcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
					~;
				}
				if ($view_imcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
					~;
				}
				if ($view_icqcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
					~;
				}
				if ($view_yimcolm && $mlcall ne "mlemail")	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$yimjust" valign="middle"><font size=2>$yimimg</font></td>
				~;
				}
				if ($view_aimcolm && $mlcall ne "mlemail")	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$aimjust" valign="middle"><font size=2>$aimimg</font></td>
				~;
				}
				if (-e "$sourcedir/Msn.pl" && $view_msncolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
					~;
					if ($msnsettings[0] ne '') {
						$yymain .= qq~
						<nobr>
						<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
						<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
						</nobr>
						~;
					}
					else { 
						$yymain .= qq~
						&nbsp;
					~;
					}
					$yymain .= qq~
					</td>
					~;
				}
				$yymain .= qq~
				<td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle"><font size=2>$member[7]</font>&nbsp;</td>
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$member[6]</font></td>
				<td class="windowbg" bgcolor="$color{'windowbg'}" width="104" align="absmiddle">$Bar</td>
				~;
				if ($view_regdate)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$dr</font></td>
					~;
				}
				if ($view_numbcolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
					~;
				}
				if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$viewipnumb</font></td>
					~;
				}
			$yymain .= qq~
</replace>


<search for>
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=mlall;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=mlall;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=mlall;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage) + 0;
	$lastpn = int($memcount / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $max - ($MembersPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=mlall;start=$lastptn">$lastpn</a>~;}
</search for>


<replace>
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=$mlcall;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=$mlcall;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=$mlcall;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage) + 0;
	$lastpn = int($memcount / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $max - ($MembersPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=$mlcall;start=$lastptn">$lastpn</a>~;}
</replace>


<search for>
	<table border=0 width=100% cellpadding=0 cellspacing=0>
	<tr>
		<td><font size=2><b>$txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
</search for>

<replace>
	<table border=0 width=100% cellspacing=1 cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr>
		<td class="catbg" bgcolor="$color{'catbg'}"><font size=2><b> $txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
</replace>


<search for>
sub MLByLetter {
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
	$yymain .= qq~$TableHeader~;
</search for>


<replace>
sub MLByLetter {
	if($username eq "Guest" && !$guest_allow) { &fatal_error("$txt{'223'}"); }
	$yymain .= qq~$TableHeader~;
	fopen(FILE, "$memberdir/memberlist.txt");
	@memberlist = <FILE>;
	$memcount = @memberlist;
	@membername = @memberlist;
	fclose(FILE);


	for($i=0;$i<$memcount;$i++) {
		chomp(@membername);
		$membname = $membername[$i];
		fopen(MEMBERFILE,"$memberdir/$membname.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		chomp(@member);
		$templist[$i] .= qq($member[1] | $membname);
	}
	@SortAList = sort{lc($a) cmp lc($b)} (@templist);
	for($i=0;$i<$memcount;$i++) {
		chomp(@SortAList);
		($indxname[$i], $SortList[$i]) = split(/\|/, $SortAList[$i]);
	}
	chomp(@SortList);
	@lmemberfile = @SortList;
</replace>

<search for>
		fopen(MEMBERSLISTREAD,"$memberdir/memberlist.txt");
		while(chomp($memberfile=<MEMBERSLISTREAD>)) {
			fopen(MEMBERFILEREAD,"$memberdir/$memberfile.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;

			$SearchName = $member[1];
			$SearchName = substr $SearchName,0,1;
			$SearchName = lc $SearchName;
			if($SearchName eq $letter) {push(@ToShow,$memberfile);}
		}
		fclose(MEMBERSLISTREAD);
		@ToShow = sort(case_insensitive(@ToShow));
</search for>


<replace>
		for($i=0;$i<$memcount;$i++) {
			chomp(@lmemberfile);
			$lmemberfile[$i] =~ s/ //gi;
			$lmemberfile[$i] =~ s/\n//gi;
			$memberfile = $lmemberfile[$i];
			fopen(MEMBERFILEREAD,"$memberdir/$memberfile.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;

			$SearchName = $member[1];
			$SearchName = substr $SearchName,0,1;
			if($SearchName eq "$lngtxt{'01uc'}") {$SearchName = "$lngtxt{'01lc'}";}
			if($SearchName eq "$lngtxt{'02uc'}") {$SearchName = "$lngtxt{'02lc'}";}
			if($SearchName eq "$lngtxt{'03uc'}") {$SearchName = "$lngtxt{'03lc'}";}
			$SearchName = lc $SearchName;
			if($SearchName eq $letter) {push(@ToShow,$memberfile);}
		}
</replace>


<search for>
			$membername=@ToShow[$b];
			if ($membername ne "")
			{
			@member = ();
			$Bar = "";
			$ICQ = "";
</search for>


<add after>
			$hjsite = "";
</add after>

<search for>
			fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;
</search for>

<add after>
			$viewipnumb = "";
			fopen(NUMBERFILEREAD,"$memberdir/$membername.yam");
			@number = <NUMBERFILEREAD>;
			fclose(NUMBERFILEREAD);
			chomp @number;
			if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
				($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
				if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
				else {
					$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
					if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
					if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
				}
			}
			if ($number[0] == 0) { $number[0] = "&nbsp;"; }
</add after>

<search for>
			$barchart = ($member[6] / 5);
			if ($barchart < 1) {$Bar = "$Bar";}
			elsif ($barchart > 100) {$Bar = qq~<img src="$imagesdir/bar.gif" width=100 height=15 alt="" border="0">~;}
			else {
			$Bar = qq~<img src="$imagesdir/bar.gif" width=$barchart height=15 alt="" border="0">~;
			}
</search for>


<replace>
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
		chomp @membergroups;
		if(!-e "$sourcedir/MemberGroups.pl") {
			if($member[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
			elsif($member[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
			elsif($member[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
			elsif($member[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
			else { $memberinfo = "$membergroups[2]"; }
		}
		else {
			$memstatcount = "0";
			if( $member[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
			while($MemStat[$memstatcount]) {
				if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
					$memberinfo = "$MemStat[$memstatcount]"; 
				}
				$memstatcount++;
			}
		}
		$memberinfo =~ s/\n//gi;
		$Bargif = "";
		$barchart = ($member[6]);
		$bartemp = ($member[6] * 100);
		$barwidth = ($bartemp / $barmax);
		$barwidth = ($barwidth + 0.5);
		$barwidth = int($barwidth);
		if($barwidth > 100) {$barwidth = 100}
		
		fopen(FILE, "$vardir/barcolor.dat");
		@grpbar=<FILE>;
		fclose(FILE);
		chomp(@grpbar);

		if(!-e "$sourcedir/MemberGroups.pl") {
			if ($barchart >= $GodPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[3].gif'";
			}
			elsif ($barchart >= $SrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[2].gif'";
			}
			elsif ($barchart >= $FullPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[1].gif'";
			}
			elsif ($barchart >= $JrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[0].gif'";
			}
			else {
				$Bargif = "img src='$barsurl/$stfaultbar.gif'";
			}
		}
		else {
			$membarcount = 0;
			$Bargif .= qq(img src="$barsurl/$stfaultbar.gif");
			while($MemStat[$membarcount]) {
				if($barchart >= $MemPostNum[$membarcount] && $MemPostNum[$membarcount] ne 'x') {
					$Bargif = "";
					$Bargif .= qq(img src="$barsurl/$grpbar[$membarcount].gif");
				}
				$membarcount++;
			}
		}
		
		if ($barwidth < 1) {$Bar = "$Bar";}
		else {
			$Bar = qq~<$Bargif width=$barwidth height=10 alt="$memberinfo" border="0">~;
		}
</replace>


<search for>
			if($member[7] eq "Administrator") { $member[7] = "$membergroups[0]"; }
</search for>


<replace>
			if($member[7] eq "Administrator") { $member[7] = "$MemStatAdmin"; }
			if($member[7] eq "Global Moderator") { $member[7] = "$MemStatGMod"; }

			if($member[7] eq "") { $member[7] = "$memberinfo"; }

			if ($username eq "Guest" && $guest_allow) {
				if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~; 
								  $mailjust = "center"; }
				else				{ $mailpic = "$txt{'722'}";
								  $mailjust = "left"; }
			}
			else {
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
					~;
					if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
									  $mailjust = "center"; }
					else				{ $mailpic = "$txt{'722'}";
									  $mailjust = "left"; }
				}
				else {
					if($mailcol eq "pic")	{ $mailpic = qq~<a href="mailto:$member[2]"><IMG SRC="$imagesdir/email.gif" border="0" alt="$member[2]"></a>~;
									  $mailjust = "center"; }
					else				{ $mailpic = qq~<a href="mailto:$member[2]">$member[2]</a>~;
									  $mailjust = "left"; }
				}
			}



		if($member[4] eq "")	{ $hjsite = "&nbsp;"; }
		elsif($wwwcol eq "pic")	{ $hjsite = qq~<a href="$member[4]" target="_blank"><img src="$imagesdir/www.gif" border="0" align="absmiddle" alt="$member[3]"></a>~;
						  $wwwjust = "center"; }
		else				{ $hjsite = qq~<a href="$member[4]" target="_blank">$member[3]</a>~;
						  $wwwjust = "left"; }

		if($imcol eq "pic")	{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$membername}"><IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'148'} $txt{'311'} $member[1]"></a>~;
						  $imjust = "center"; }
		else				{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$membername}">$membtxt{'43'} $member[1]</a>~;
						  $imjust = "left"; }

		if( $member[8] ne "" && $member[8] !~ m~\D~ ) {
		$ICQ = $member[8];
		if($icqcol eq "pic")	{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> </a>~;
						  $icqjust = "center"; }
		else				{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> $member[8]</a>~;
						  $icqjust = "left"; }
		}
		else				{ $icqimg = "&nbsp;" }

            if ($member[10] eq '')	{ $yimimg = "&nbsp"; }
		elsif($yimcol eq "pic")	{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"></a>~;
						  $yimjust = "center"; }
		else				{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"> $member[10]</a>~;
						  $yimjust = "left"; }

            if ($member[9] eq '')	{ $aimimg = "&nbsp"; }
		elsif($aimcol eq "pic")	{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"></a>~;
						  $aimjust = "center"; }
		else				{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"> $member[9]</a>~;
						  $aimjust = "left"; }


			if(-e "$sourcedir/Msn.pl") {
				fopen(FILE, "$memberdir/$membername.om"); 
				@msnsettings = <FILE>;
				fclose <FILE>;
				chomp @msnsettings;
			}

			$dr = "";
			if ($member[14] eq "") { $dr = "$txt{'470'}"; }
			else { $dr = "$member[14]"; $dr = &timeformat($dr); }
			if ($number[0] eq "&nbsp;") { $dr = "$membtxt{'32'}"; }

			$onlinemem = $img{'mem_offline'};
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			foreach $curentry (@entries) {
				chomp $curentry;
				($onname, $onvalue) = split(/\|/, $curentry);
				if(lc $onname eq lc $membername) { $onlinemem = $img{'mem_online'}; }
			}
</replace>


<search for>
				<tr>
					<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
			~;
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
			~; } else { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
			~; }
			$yymain .= qq~
			<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$member[4]" target="$member[3]">$member[3]</a></font>&nbsp;</td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>$member[6]</font>&nbsp;</td>
			<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>$member[7]</font>&nbsp;</td>
			<td class="windowbg" bgcolor="$color{'windowbg'}">$Bar</td>
			</tr>
</search for>


<replace>
			<tr>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$onlinemem</td>
			<td valign="middle" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
			~;
			if ($view_mailcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
				~;
			}

			if ($view_wwwcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
				~;
			}
				if ($view_imcolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
					~;
				}
				if ($view_icqcolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
					~;
				}
				if ($view_yimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$yimjust" valign="middle"><font size=2>$yimimg</font></td>
				~;
				}
				if ($view_aimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="aimjust" valign="middle"><font size=2>$aimimg</font></td>
				~;
				}
				if (-e "$sourcedir/Msn.pl" && $view_msncolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
					~;
					if ($msnsettings[0] ne '') {
						$yymain .= qq~
						<nobr>
						<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
						<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
						</nobr>
						~;
					}
					else { 
						$yymain .= qq~
						&nbsp;
					~;
					}

					$yymain .= qq~
					</td>
					~;
				}
				$yymain .= qq~
			<td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle"><font size=2>$member[7]</font>&nbsp;</td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$member[6]</font></td>
			<td class="windowbg" bgcolor="$color{'windowbg'}" width="104" align="absmiddle">$Bar</td>
			~;
			if ($view_regdate)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$dr</font></td>
				~;
			}
			if ($view_numbcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
				~;
			}
			if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$viewipnumb</font></td>
				~;
			}
			$yymain .= qq~
			</tr>
</replace>


<search for>
	if(!$letter) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="7" align="center"><br><b>$txt{'759'}</b><br><br></td>~;}
	if($memcount == 0 && $letter) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="7" align="center"><br><b>$txt{'760'}</b><br><br></td>~;}
</search for>


<replace>
	if(!$letter) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$txt{'759'}</b><br><br></td>~;}
	if($memcount == 0 && $letter) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$txt{'760'}</b><br><br></td>~;}
</replace>

<search for>
	<table border=0 width=100% cellpadding=0 cellspacing=0>
	<tr>
		<td><font size=2><b>$txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
</search for>

<replace>
	<table border=0 width=100% cellspacing=1 cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr>
		<td class="catbg" bgcolor="$color{'catbg'}"><font size=2><b> $txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
</replace>

<search for>
sub MLTop {
</search for>

<add before>
sub MLByIP {
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
	$yymain .= qq~$TableHeader~;
	fopen(FILE, "$memberdir/memberlist.txt");
	@memberlist = <FILE>;
	$memcount = @memberlist;
	@imemberfile = @memberlist;
	fclose(FILE);

	if ($FORM{'searchip'} ne "") { $ipaddr = $FORM{'searchip'}; }
	else { $ipaddr = $INFO{'searchip'}; }

	$ipaddr =~ s/ //gi;
	$ipaddr =~ s/\n//gi;

	if($INFO{'start'} eq "") { $start=0; } 
	else { $start="$INFO{'start'}"; }

	unless(!$ipaddr)
	{
		for($i=0;$i<$memcount;$i++) {
			chomp(@imemberfile);
			$imemberfile[$i] =~ s/ //gi;
			$imemberfile[$i] =~ s/\n//gi;
			$memberfile = $imemberfile[$i];
			fopen(MEMBERFILEREAD,"$memberdir/$memberfile.yam");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;

			($SearchName1, $SearchName2, $SearchName3) = split(/\|/, $member[1]);

			if ($SearchName1 eq $ipaddr) {push(@ToShow,$memberfile);}
			elsif ($SearchName2 eq $ipaddr) {push(@ToShow,$memberfile);}
			elsif ($SearchName3 eq $ipaddr) {push(@ToShow,$memberfile);}
		}
		$memcount=@ToShow;
		$numshown=0; $b=$start;

		unless ($memcount == 0)	{
		while(($numshown < $MembersPerPage))
		{
			$membername=@ToShow[$b];
			if ($membername ne "")
			{
			@member = ();
			$Bar = "";
			$ICQ = "";
			$hjsite = "";
			fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;
			$viewipnumb = "";
			fopen(NUMBERFILEREAD,"$memberdir/$membername.yam");
			@number = <NUMBERFILEREAD>;
			fclose(NUMBERFILEREAD);
			chomp @number;
			if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
				($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
				if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
				else {
					$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
					if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
					if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
				}
			}
			if ($number[0] == 0) { $number[0] = "&nbsp;"; }
			&FormatUserName($membername);
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
		chomp @membergroups;
		if(!-e "$sourcedir/MemberGroups.pl") {
			if($member[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
			elsif($member[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
			elsif($member[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
			elsif($member[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
			else { $memberinfo = "$membergroups[2]"; }
		}
		else {
			$memstatcount = "0";
			if( $member[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
			while($MemStat[$memstatcount]) {
				if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
					$memberinfo = "$MemStat[$memstatcount]"; 
				}
				$memstatcount++;
			}
		}
		$memberinfo =~ s/\n//gi;
		$Bargif = "";
		$barchart = ($member[6]);
		$bartemp = ($member[6] * 100);
		$barwidth = ($bartemp / $barmax);
		$barwidth = ($barwidth + 0.5);
		$barwidth = int($barwidth);
		if($barwidth > 100) {$barwidth = 100}
		
		fopen(FILE, "$vardir/barcolor.dat");
		@grpbar=<FILE>;
		fclose(FILE);
		chomp(@grpbar);

		if(!-e "$sourcedir/MemberGroups.pl") {
			if ($barchart >= $GodPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[3].gif'";
			}
			elsif ($barchart >= $SrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[2].gif'";
			}
			elsif ($barchart >= $FullPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[1].gif'";
			}
			elsif ($barchart >= $JrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[0].gif'";
			}
			else {
				$Bargif = "img src='$barsurl/$stfaultbar.gif'";
			}
		}
		else {
			$membarcount = 0;
			$Bargif .= qq(img src="$barsurl/$stfaultbar.gif");
			while($MemStat[$membarcount]) {
				if($barchart >= $MemPostNum[$membarcount] && $MemPostNum[$membarcount] ne 'x') {
					$Bargif = "";
					$Bargif .= qq(img src="$barsurl/$grpbar[$membarcount].gif");
				}
				$membarcount++;
			}
		}
		
		if ($barwidth < 1) {$Bar = "$Bar";}
		else {
			$Bar = qq~<$Bargif width=$barwidth height=10 alt="$memberinfo" border="0">~;
		}
			$member[8] =~ s/[\n\r]//g;
			if ($Bar eq "") { $Bar="&nbsp;"; }

			if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

			if($member[7] eq "Administrator") { $member[7] = "$MemStatAdmin"; }
			if($member[7] eq "Global Moderator") { $member[7] = "$MemStatGMod"; }
			if($member[7] eq "") { $member[7] = "$memberinfo"; }

			if ($username eq "Guest" && $guest_allow) {
				if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~; 
								  $mailjust = "center"; }
				else				{ $mailpic = "$txt{'722'}";
								  $mailjust = "left"; }
			}
			else {
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
					~;
					if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
									  $mailjust = "center"; }
					else				{ $mailpic = "$txt{'722'}";
									  $mailjust = "left"; }
				}
				else {
					if($mailcol eq "pic")	{ $mailpic = qq~<a href="mailto:$member[2]"><IMG SRC="$imagesdir/email.gif" border="0" alt="$member[2]"></a>~;
									  $mailjust = "center"; }
					else				{ $mailpic = qq~<a href="mailto:$member[2]">$member[2]</a>~;
									  $mailjust = "left"; }
				}
			}



		if($member[4] eq "")	{ $hjsite = "&nbsp;"; }
		elsif($wwwcol eq "pic")	{ $hjsite = qq~<a href="$member[4]" target="_blank"><img src="$imagesdir/www.gif" border="0" align="absmiddle" alt="$member[3]"></a>~;
						  $wwwjust = "center"; }
		else				{ $hjsite = qq~<a href="$member[4]" target="_blank">$member[3]</a>~;
						  $wwwjust = "left"; }

		if($imcol eq "pic")	{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}"><IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'148'} $txt{'311'} $member[1]"></a>~;
						  $imjust = "center"; }
		else				{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}">$membtxt{'43'} $member[1]</a>~;
						  $imjust = "left"; }

		if( $member[8] ne "" && $member[8] !~ m~\D~ ) {
		$ICQ = $member[8];
		if($icqcol eq "pic")	{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> </a>~;
						  $icqjust = "center"; }
		else				{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> $member[8]</a>~;
						  $icqjust = "left"; }
		}
		else				{ $icqimg = "&nbsp;" }

            if ($member[10] eq '')	{ $yimimg = "&nbsp"; }
		elsif($yimcol eq "pic")	{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"></a>~;
						  $yimjust = "center"; }
		else				{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"> $member[10]</a>~;
						  $yimjust = "left"; }

            if ($member[9] eq '')	{ $aimimg = "&nbsp"; }
		elsif($aimcol eq "pic")	{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"></a>~;
						  $aimjust = "center"; }
		else				{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"> $member[9]</a>~;
						  $aimjust = "left"; }


			if(-e "$sourcedir/Msn.pl") {
				fopen(FILE, "$memberdir/$membername.om"); 
				@msnsettings = <FILE>;
				fclose <FILE>;
				chomp @msnsettings;
			}

			$dr = "";
			if ($member[14] eq "") { $dr = "$txt{'470'}"; }
			else { $dr = "$member[14]"; $dr = &timeformat($dr); }
			if ($number[0] eq "&nbsp;") { $dr = "$membtxt{'32'}"; }

			$onlinemem = $img{'mem_offline'};
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			foreach $curentry (@entries) {
				chomp $curentry;
				($onname, $onvalue) = split(/\|/, $curentry);
				if(lc $onname eq lc $membername) { $onlinemem = $img{'mem_online'}; }
			}

			$yymain .= qq~
			<tr>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$onlinemem</td>
			<td valign="middle" class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
			~;
			if ($view_mailcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
				~;
			}
			if ($view_wwwcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
				~;
			}
			if ($view_imcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
				~;
			}
			if ($view_icqcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
				~;
			}
			if ($view_yimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$yimimg</font></td>
				~;
			}
			if ($view_aimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$aimimg</font></td>
				~;
			}
				if (-e "$sourcedir/Msn.pl" && $view_msncolm)	{
					$yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
					~;
					if ($msnsettings[0] ne '') {
						$yymain .= qq~
						<nobr>
						<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
						<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
						</nobr>
						~;
					}
					else { 
						$yymain .= qq~
						&nbsp;
					~;
					}

					$yymain .= qq~
					</td>
					~;
				}
				$yymain .= qq~
			<td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle"><font size=2>$member[7]</font>&nbsp;</td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$member[6]</font></td>
			<td class="windowbg" bgcolor="$color{'windowbg'}" width="104" align="absmiddle">$Bar</td>
			~;
			if ($view_regdate)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$dr</font></td>
				~;
			}
			if ($view_numbcolm)	{
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
				~;
			}
			if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
				$yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><font size=1>$viewipnumb</font></td>
				~;
			}
			$yymain .= qq~
			</tr>
			~;
			}
			$numshown++;
			$b++;
		}
		}
	}
	if(!$ipaddr) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$membtxt{'34'}</b><br><br></td>~;}
	if($memcount == 0 && $ipaddr) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$membtxt{'35'}</b><br><br></td>~;}
	$yymain .= qq~$TableFooter~;

unless ($memcount == 0)
{
	# Build the page links list.
	$postdisplaynum = 4;	# max number of pages to display
	$max = $memcount;
	$start = $INFO{'start'} || 0;
	$start = ( int( $start / $MembersPerPage ) ) * $MembersPerPage;
	$tmpa = 1;
	$tmpx = int( $max / $MembersPerPage );
	if ($start >= (($postdisplaynum-1) * $MembersPerPage)) { $startpage = $start - (($postdisplaynum-1) * $MembersPerPage); $tmpa = int( $startpage /$MembersPerPage ) + 1; }
	if ($max >= $start + ($postdisplaynum * $MembersPerPage)) { $endpage = $start + ($postdisplaynum * $MembersPerPage); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage) + 0;
	$lastpn = int($memcount / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $max - ($MembersPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	$yymain .= qq~
	<table border=0 width=100% cellspacing=1 cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr>
		<td class="catbg" bgcolor="$color{'catbg'}"><font size=2><b> $txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
	~;
}
	$yytitle = "$membtxt{'36'}";
	&template;
	exit;
}
</add before>

<search for>
	$yytitle = "$txt{'313'} $TopAmmount $txt{'314'}";
	&template;
	exit;
}
</search for>

<add after>

sub SortGrpMemb	{
	if(!-e "$sourcedir/MemberGroups.pl") {
		fopen(GRPFILE, "$vardir/membergroups.txt");
		@membergroup = <GRPFILE>;
		$grpcount = @membergroup;
		fclose(GRPFILE);
		foreach (@membergroup) { $_ =~ s~[\n\r]~~g; }
		$grpcount = $grpcount + 2;
	}
	else {
		$membergroup[0] = "$MemStatAdmin";
		$membergroup[1] = "$MemStatGMod";
		$membergroup[2] = "$MemStatNewbie";
		$grpcount = "0";
		while($MemStat[$grpcount]) { 
			$membergroup[$grpcount + 3] = $MemStat[$grpcount];
			$grpcount++;
		}
		$grpcount = $grpcount + 5;
	}
	for($i=0;$i<$memcount;$i++) {
		chomp(@membername);
		$membername[$i] =~ s/ //gi;
		$membername[$i] =~ s/\n//gi;
		$membname = $membername[$i];
		@member = ();
		fopen(MEMBERFILE,"$memberdir/$membname.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		foreach (@member) { $_ =~ s~[\n\r]~~g; }
		$realmembname = lc $member[1];
		$memberinf = $member[7];
		if($memberinf eq "") { 
			if(!-e "$sourcedir/MemberGroups.pl") {
				if($member[6] >= $GodPostNum) { $memberinf = "$membergroup[6]"; }
				elsif($member[6] >= $SrPostNum) { $memberinf = "$membergroup[5]"; }
				elsif($member[6] >= $FullPostNum) { $memberinf = "$membergroup[4]"; }
				elsif($member[6] >= $JrPostNum) { $memberinf = "$membergroup[3]"; }
				else { $memberinf = "$membergroup[2]"; }
			}
			else {
				$memstatcount = "0";
				if( $member[6] >= $MemPostNewbie) { $memberinf = "$MemStatNewbie"; }
				while($MemStat[$memstatcount]) {
					if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
						$memberinf = "$MemStat[$memstatcount]";
					}
					$memstatcount++;
				}
			}
		} 
		$amember = lc $memberinf;
		for($grp=0;$grp<$grpcount;$grp++) {
			$agroup = lc $membergroup[$grp];
			if($agroup eq $amember) { $grpnr = $grpcount - $grp; }
		}
		if($member[7] eq "Administrator") { $grpnr = 0; }
		if($member[7] eq "Global Moderator") { $grpnr = 1; }
		$SortNumm = ($grpnr + 100);
		$GrpMembers[$i] .= qq($SortNumm | $realmembname | $membname);
	}
	@grplist = sort{ $a cmp $b } (@GrpMembers);
	for($i=0;$i<$memcount;$i++) {
		chomp(@grplist);
		($dummynum[$i], $dummyname[$i], $SortList[$i]) = split(/\|/, $grplist[$i]);
	}
	chomp(@SortList);
	@grpmemberlist = @SortList;
}

sub SortMemb	{
		for($i=0;$i<$memcount;$i++) {
			chomp(@membername);
			$membname = $membername[$i];
			fopen(MEMBERFILE,"$memberdir/$membname.dat");
			@member = <MEMBERFILE>;
			fclose(MEMBERFILE);
			chomp(@member);
			if($smb1) {
				$date1 = $member[14];
				if ($membname eq "admin") { $date1 = qq~01/01/01 $txt{'107'} 00:00:00~; }
				&calcdaystime;
				$templist[$i] .= qq($result | $membname);
			}
			if($smb2)	{
				$templist[$i] .= qq($member[6] | $membname);
			}
			if($smb4)	{
				$templist[$i] .= qq($member[1] | $membname);
			}
			if($smb5)	{
				fopen(NUMBERFILEREAD,"$memberdir/$membname.yam");
				@number = <NUMBERFILEREAD>;
				fclose(NUMBERFILEREAD);
				chomp @number;
				($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
				if ($ipnumb1 == 0) { $ipnumb1 = 999.999.999.999; }
				else {
					@ippart = ();
					($ippart[0], $ippart[1], $ippart[2], $ippart[3]) = split(/\./, $ipnumb1);
					for($x=0;$x<4;$x++) {
						if($ippart[$x] < 10) { $ippart[$x] = "00$ippart[$x]"; }
						elsif($ippart[$x] < 100) { $ippart[$x] = "0$ippart[$x]"; }
					}
					$ipnumb1 = "$ippart[0]\.$ippart[1]\.$ippart[2]\.$ippart[3]";
				}
				$templist[$i] .= qq($ipnumb1 | $membname);
			}
			if($smb6)	{
				($ename, $edom) = split(/\@/, $member[2]);
				$templist[$i] .= qq($edom $ename | $membname);
			}
		}
		if($smb4 || $smb5 || $smb6) { @SortAList = sort{lc($a) cmp lc($b)} (@templist); }
		else { @SortAList = sort{$b<=>$a} (@templist); }
		for($i=0;$i<$memcount;$i++) {
			chomp(@SortAList);
			($indxname[$i], $SortList[$i]) = split(/\|/, $SortAList[$i]);
		}
		chomp(@SortList);
		@sortmembername = @SortList;
}
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	                unlink("$memberdir/$member{'username'}.imconfig");
</search for>

<add after>
	                unlink("$memberdir/$member{'username'}.yam");
</add after>

<search for>
	                unlink("$memberdir/$username.imconfig");
</search for>

<add after>
	                unlink("$memberdir/$username.yam");
</add after>

<search for>
	chomp @memsettings;
</search for>

<add after>
	fopen(NUMBERFILEREAD,"$memberdir/$INFO{'username'}.yam");
	@number = <NUMBERFILEREAD>;
	fclose(NUMBERFILEREAD);
	chomp @number;
</add after>

<search for>
	<td><font size=2>$memsettings[1]</font></td>
      </tr><tr>
</search for>

<add after>
	~;
	if ($view_numb) {
		if ($number[0] > 0) {
		$yymain .= qq~
		<td><font size=2><b>$membtxt{'24'}: </b></font></td>
		<td><font size=2>$number[0]</font></td>
	      </tr><tr>
		~;
		}
	}
	$yymain .= qq~
</add after>


<edit file>
Sources/Register.pl
</edit file>

<search for>
	print FILE qq~$membershiptotal|$member{'username'}~;
	fclose(FILE);
</search for>

<add after>
	###### Start YaMS add-on Member-number ######
	fopen(FILE, "$memberdir/membernumb.txt");
	@membernumb = <FILE>;
	$membernumber = @membernumb;
	fclose(FILE);
	fopen(FILE, ">$memberdir/membernumb.txt", 1);
	foreach $curnum (@membernumb) {
		chomp $curnum;
		print FILE "$curnum\n";
	}
	print FILE "$membernumber|$member{'username'}\n";
	fclose(FILE);

	fopen(FILE, ">$memberdir/$member{'username'}.yam");
	print FILE "$membernumber\n";
	print FILE "0|0|0\n";
	fclose(FILE);
	chmod(0666,"$memberdir/$member{'username'}.yam");
	###### End YaMS add-on Member-number ######
</add after>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";
</search for>

<add after>
	if ($defaultml == 0) { $mldefault = "mlall"; }
	elsif ($defaultml == 1) { $mldefault = "mlpost"; }
	elsif ($defaultml == 2) { $mldefault = "mlalfa"; }
	elsif ($defaultml == 3) { $mldefault = "mlgrp"; }
</add after>

<search for>
	$yymenu = qq~<a href="$scripturl">$img{'home'}</a>$menusep<a href="$helpfile" target="_blank" style="cursor:help;">$img{'help'}</a>$menusep<a href="$cgi;action=search">$img{'search'}</a>$menusep<a href="$scripturl?action=mlall">$img{'memberlist'}</a>~;
</search for>

<replace>
	$yymenu = qq~<a href="$scripturl">$img{'home'}</a>$menusep<a href="$helpfile" target="_blank" style="cursor:help;">$img{'help'}</a>$menusep<a href="$cgi;action=search">$img{'search'}</a>$menusep<a href="$scripturl?action=$mldefault">$img{'memberlist'}</a>~;
</replace>

<search for>
sub fatal_error {
</search for>

<add before>
sub calcdaystime {  # Input: $date1 $date2
	my( $dates, $times, $month, $day, $year, $hour, $min, $sek, $dnumber1, $dnumber2, $tnumber1 );
	($dates, $times) = split(/ $txt{'107'} /, $date1);
	($month, $day, $year) = split(/\//, $dates);
	($hour, $min, $sec) = split(/\:/, $times);
	$dnumber1=($year*365)+($month*30)+$day;
	$tnumber1 = ($hour*60)+$min+($sec/60);
	($dates, $times) = split(/ $txt{'107'} /, $date2);
	($month, $day, $year) = split(/\//, $dates);
	$dnumber2=($year*365)+($month*30)+$day;
	$dresult = $dnumber2 - $dnumber1;
	$tresult = $tnumber1/1440;
	$tresult = 1-$tresult;
	$result = $dresult + $tresult;
}
</add before>


<search for>

1;
</search for>

<add before>
sub WriteYamLog {
	chomp $username;
	$yamname = $username;

	$yamip1 = $user_ip;
	$yamip2 = 0;
	$yamip3 = 0;

	fopen(FILE, "$memberdir/$yamname.yam");
	@yaminfo = <FILE>;
	fclose(FILE);
	chomp(@yaminfo);
	$yamnumber = $yaminfo[0];
	($yamip2, $yamip3, $yamdummy) = split(/\|/, $yaminfo[1]);

	if($yamip1 ne $yamip2) {
		fopen(FILE, ">$memberdir/$yamname.yam");
		print FILE "$yamnumber\n";
		print FILE "$yamip1|$yamip2|$yamip3\n";
		fclose(FILE);
	}
}

sub LoadMembNumber {
	if(!-e "$memberdir/membernumb.txt") {
		fopen(FILE, "$memberdir/memberlist.txt");
		@memberlist = <FILE>;
		$memcount = @memberlist;
		@membername = @memberlist;
		fclose(FILE);
		for($i=0;$i<$memcount;$i++) {
			chomp(@membername);
			$membname = $membername[$i];
			fopen(MEMBERFILE,"$memberdir/$membname.dat");
			@member = <MEMBERFILE>;
			fclose(MEMBERFILE);
			chomp(@member);
			$date1 = $member[14];
			&calcdaystime;
			$templist[$i] .= qq($result|$membname);
		}
		@SortAReg = sort{$b<=>$a} (@templist);
		$newnumber = 0;
		fopen(FILE2, ">$memberdir/membernumb.txt", 1);
		for($i=0;$i<$memcount;$i++) {
			$ipyam = "";
			$newnumber++;
			chomp(@SortAReg);
			($indxname[$i], $SortReg[$i]) = split(/\|/, $SortAReg[$i]);
			if ($SortReg[$i] eq "admin") { $newnumber = 0; }
			if (-e "$memberdir/$SortReg[$i].yam") {
				fopen(FILE, "$memberdir/$SortReg[$i].yam");
				@yaminfo = <FILE>;
				fclose(FILE);
				chomp(@yaminfo);
				$ipyam = $yaminfo[1];
				if ($yaminfo[1] eq "") { $ipyam .= qq(0|0|0); }
			}
			else {
				$ipyam .= qq(0|0|0);
			}
			fopen(FILE, ">$memberdir/$SortReg[$i].yam");
			print FILE "$newnumber\n";
			print FILE "$ipyam\n";
			fclose(FILE);
			chmod(0666,"$memberdir/$SortReg[$i].yam");
			print FILE2 "$newnumber|$SortReg[$i]\n";
			if ($newnumber == 0) { $newnumber = $i; }
		}
		fclose(FILE2);
		chmod(0666,"$memberdir/membernumb.txt");
	}
}

</add before>




