#!/usr/bin/perl

require "Settings.pl";
require "grafik.pl";

eval {
        ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
        ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
};

$SAVE_DIRECTORY = "/home/kknd2-de/htdocs/yabb/images"; # Absoluter Pfad zum Image Verzeichnis mit CHMOD 777
$SAVE_HTTP = "$imagesdir/images"; # This is the HTTP location of the saved files directory.
$MAXIMUM_UPLOAD = 20480; # File size limit, in bytes. Default is 20k. Set to 0 for no limit.
# That's all the configuration you need to do.

$| = 1;
chop $SAVE_DIRECTORY if ($SAVE_DIRECTORY =~ /\/$/);
use CGI qw(:standard);
$query = new CGI;

foreach $key (sort {$a <=> $b} $query->param()) {
        next if ($key =~ /^\s*$/);
        next if ($query->param($key) =~ /^\s*$/);
        next if ($key !~ /^file-to-upload-(\d+)$/);
        $Number = $1;

        if ($query->param($key) =~ /([^\/\\]+)$/) {
                $Filename = $1;
                $Filename =~ s/^\.+//;
                $File_Handle = $query->param($key);

                unless (($Filename =~ /\.jpg$/i) || ($Filename =~ /\.gif$/i)) {
                        print header;
                        print <<__END_OF_HTML_CODE__;
                        <HTML>
                        <HEAD>
                        <TITLE>Error: Filename Problem</TITLE>
                        <body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" alink="$ActiveLinkColor"></head>
                        <CENTER><IMG SRC="$imagesdir/$BBTitle"><P>
                        Sorry, aber Sie drfen nur Bilder (mit Erweiterung .gif oder .jpg) hochladen. Bitte gehen Sie<A HREF="javascript:history.go(-1)"> zurck</A> und nehmen Sie andere Datei.
                        </CENTER>
                        </BODY>
                        </HTML>
__END_OF_HTML_CODE__

                        exit;
                        }
                } else {
                        $FILENAME_IN_QUESTION = $query->param($key);
                        print header;
                        print <<__END_OF_HTML_CODE__;
                        <HTML>
                        <HEAD>
                        <TITLE>FEHLER: Dateiname Problem</TITLE>
                        <body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" alink="$ActiveLinkColor"></head>
                        <CENTER><IMG SRC="$imagesdir/$BBTitle"><P>
                        Der Name des Bildes ist nicht korrekt, bitte gehen Sie wieder
<A HREF="javascript:history.go(-1)">zurck</A>. Der Name darf keine Sonderzeichen haben, sowie eine Erweiterung ist ntig.
                        </CENTER>
                        </BODY>
                        </HTML>
__END_OF_HTML_CODE__

                        exit;
                }
                if (-e "$SAVE_DIRECTORY/$Filename") {
                        print header;
                        print <<__END_OF_HTML_CODE__;
                        <HTML>
                        <HEAD>
                        <TITLE>Error: Filename Problem</TITLE>
                        <body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" alink="$ActiveLinkColor"></head>
                        <CENTER><IMG SRC="$imagesdir/$BBTitle"><P>
                        Die Datei "$Filename" existiert schon auf unserem Server. Bitte bennen Sie die Datei um und versuchen Sie die Datei wieder <A HREF="javascript:history.go(-1)">hochzuladen</A>.</CENTER>
                        </BODY>
                        </HTML>
__END_OF_HTML_CODE__
                        exit;
                }
                open(OUTFILE, ">$SAVE_DIRECTORY\/$Filename");
                undef $BytesRead;
                undef $Buffer;

                while ($Bytes = read($File_Handle,$Buffer,2096)) {
                        $BytesRead += $Bytes;
                binmode OUTFILE;
                        print OUTFILE $Buffer;
        }

                push(@Files_Written, "$SAVE_DIRECTORY\/$Filename");
                $TOTAL_BYTES += $BytesRead;
                $Confirmation{$File_Handle} = $BytesRead;

        close($File_Handle);
                close(OUTFILE);
    }

        $FILES_UPLOADED = scalar(keys(%Confirmation));

        if ($TOTAL_BYTES > $MAXIMUM_UPLOAD && $MAXIMUM_UPLOAD > 0) {
                foreach $File (@Files_Written) {
                        unlink $File;
                }

                print header;
                print <<__END_OF_HTML_CODE__;
                <HTML>
                <HEAD>
                <TITLE>Error: Limit Reached</TITLE>
                <body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" alink="$ActiveLinkColor"></head>
                <CENTER><IMG SRC="$imagesdir/$BBTitle"><P>
                Ihre Datei hat die max. Dateigre berschritten. Die Datei ist
<B>$TOTAL_BYTES</B> bytes gro. Sie drfen nur Dateien hochladen, die weniger als <B>$MAXIMUM_UPLOAD</B> bytes haben. Bitte gehen Sie <A HREF="javascript:history.go(-1)">zurck </A> und whlen Sie kleinere Datei.
                </CENTER>
                </BODY>
                </HTML>
__END_OF_HTML_CODE__
                exit;
        }

if (($TOTAL_BYTES eq $null) || ($TOTAL_BYTES == 0)) {
        print header;
        print <<__END_OF_HTML_CODE__;
        <HTML>
        <HEAD>
        <TITLE>Error: Filename Problem</TITLE>
        <body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" alink="$ActiveLinkColor"></head>
        <CENTER><IMG SRC="$imagesdir/$BBTitle"><P>
        Sie haben keine Datei ausgewhlt oder die Datei ist leer. Bitte gehen Sie <A HREF="javascript:history.go(-1)">zurck</A> und versuchen Sie nochmal.</CENTER>
        </BODY>
        </HTML>
__END_OF_HTML_CODE__
exit;
}


print header;
print qq(
<HTML>
<HEAD>
<TITLE>Upload Finished</TITLE>
<body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" alink="$ActiveLinkColor"></head>
<CENTER><IMG SRC="$imagesdir/$BBTitle"><P>
Ihre Datei ist erfolgreich hochgeladen und hier abgelegt:<P>
<B><FONT SIZE="-1"><IMG SRC="$SAVE_HTTP/$Filename"></B></FONT>
</center>
</BODY>
</HTML>
);
exit;