<ID>
smiley_bugfix
</ID>

<version>
1.0
</version>

Revision:
1.0 11/08/00 First release.  Based on 9.17.00 version of YaBB. 

Installation Difficulty:
Extremely Easy

Reason for this fix:
The Post.pl replaces a double space with space+&nbsp;, which then causes a D at 
the start of a sentence to become the big grin smiley when the doUBBC sub in 
Display.pl is run.  This could also happen with the other character replacements,
so just removing the double space one will not fix it.  This mod checks for a 
non-word character before the semicolon to screen out any &nbsp; or other 
replacement codes like &lt;.  This only affects the ;) ;-) and ;D smileys. 

<Mod info>
This mod fixes the bug that causes the grin smiley ;D after 2 spaces.  Also adds a couple of new options for smileys.
After installing this mod, any smiley that starts with a semicolon must have a space or non-alpha character before it.
</Mod info>

<Author>
DaveG
</Author>

<Homepage> 
http://www.cafetropico.com/
</Homepage>

<Edit file>
Sources\Display.pl
</Edit file>

<Search for>
		$message =~ s/\:\)/\<img src=$imagesdir\/smiley\.gif\>/g;
		$message =~ s/\:\-\)/\<img src=$imagesdir\/smiley\.gif\>/g;
		$message =~ s|\;\)|\<img src=$imagesdir\/wink.gif\>|g;
		$message =~ s|\;\-\)|\<img src=$imagesdir\/wink.gif\>|g;
		$message =~ s|\:D|\<img src=$imagesdir\/cheesy.gif\>|g;
		$message =~ s|\;D|\<img src=$imagesdir\/grin.gif\>|g;
		$message =~ s|\)\:\(|\<img src=$imagesdir\/angry.gif\>|g;
		$message =~ s|\:\-\(|\<img src=$imagesdir\/sad.gif\>|g;
		$message =~ s|\:\(|\<img src=$imagesdir\/sad.gif\>|g;
		$message =~ s|\:o|\<img src=$imagesdir\/shocked.gif\>|g;
		$message =~ s|8\)|\<img src=$imagesdir\/cool.gif\>|g;
		$message =~ s|\?\?\?|\<img src=$imagesdir\/huh.gif\>|g;
</Search for>

<Replace>
		$message =~ s/\:\)/\<img src=$imagesdir\/smiley\.gif\>/g;
		$message =~ s/\:\-\)/\<img src=$imagesdir\/smiley\.gif\>/g;
		$message =~ s/(\W)\;\)/$1\<img src=$imagesdir\/wink.gif\>/g;
		$message =~ s/(\W)\;\-\)/$1\<img src=$imagesdir\/wink.gif\>/g;
		$message =~ s/\:D/\<img src=$imagesdir\/cheesy.gif\>/g;
		$message =~ s/(\W)\;D/$1\<img src=$imagesdir\/grin.gif\>/g;
		$message =~ s/\)\:\(/\<img src=$imagesdir\/angry.gif\>/g;
		$message =~ s/\>\:\(/\<img src=$imagesdir\/angry.gif\>/g;
		$message =~ s/\:\-\(/\<img src=$imagesdir\/sad.gif\>/g;
		$message =~ s/\:\(/\<img src=$imagesdir\/sad.gif\>/g;
		$message =~ s/\:o/\<img src=$imagesdir\/shocked.gif\>/gi;
		$message =~ s/8\)/\<img src=$imagesdir\/cool.gif\>/g;
		$message =~ s/\?\?\?/\<img src=$imagesdir\/huh.gif\>/g;
		$message =~ s/\?\!\?/\<img src=$imagesdir\/huh.gif\>/g;
</Replace>


